//-----------------------------------------------------------------------------
#ifndef mvIMPACT_acquire_GenICam_CPP_autogen_h
#if !defined(DOXYGEN_SHOULD_SKIP_THIS) && !defined(WRAP_ANY)
#   define mvIMPACT_acquire_GenICam_CPP_autogen_h mvIMPACT_acquire_GenICam_CPP_autogen_h
#endif // DOXYGEN_SHOULD_SKIP_THIS && WRAP_ANY
//-----------------------------------------------------------------------------
// AUTOMATICALLY GENERATED CODE. DO NOT EDIT!!!

#include <mvIMPACT_CPP/mvIMPACT_acquire.h>

#ifdef SWIG
#   ifdef SWIGPYTHON
#       define WRAP_PYTHON
#   endif
#   ifdef SWIGJAVA
#       define WRAP_JAVA
#   endif
#endif

#ifdef WRAP_PYTHON
#   define PYTHON_ONLY(X) X
#   define PYTHON_CPP_SWITCH(PYTHON_WRAPPER_CODE,CPP_WRAPPER_CODE) PYTHON_WRAPPER_CODE
#   ifndef WRAP_ANY
#       define WRAP_ANY
#   endif // #ifndef WRAP_ANY
#else // #ifdef WRAP_PYTHON
#   define PYTHON_ONLY(X)
#   define PYTHON_CPP_SWITCH(PYTHON_WRAPPER_CODE,CPP_WRAPPER_CODE) CPP_WRAPPER_CODE
#endif // #ifdef WRAP_PYTHON

#ifdef _MSC_VER // is Microsoft compiler?
#   pragma warning( push )
#   if _MSC_VER < 1300 // is 'old' VC 6 compiler?
#       pragma warning( disable : 4786 ) // 'identifier was truncated to '255' characters in the debug information'
#       define __FUNCTION__ "No function name information as the __FUNCTION__ macro is not supported by this(VC 6) compiler"
#       pragma message( "WARNING: This header(" __FILE__ ") uses the __FUNCTION__ macro, which is not supported by this compiler. A default definition(\"" __FUNCTION__ "\") will be used!" )
#       pragma message( "WARNING: This header(" __FILE__ ") uses inheritance for exception classes. However this compiler can't handle this correctly. Trying to catch a specific exception by writing a catch block for a base class will not work!" )
#   endif // #if _MSC_VER < 1300
#   if _MSC_VER >= 1400 // is at least VC 2005 compiler?
#       include <assert.h>
#   endif // #if _MSC_VER >= 1400
#   pragma warning( disable : 4512 ) // 'assignment operator could not be generated' (reason: assignment operators declared 'private' but not implemented)
#endif // #ifdef _MSC_VER

namespace mvIMPACT
{
namespace acquire
{
namespace GenICam
{

/// \defgroup GenICamInterface GenICam interface layout
/// \brief Classes and functions that will be available if the device is used
/// with the \a GenICam interface layout
/**
 *  This group contains classes and functions that will be available if the device is used
 *  with the <b>mvIMPACT::acquire::dilGenICam</b> interface layout.
 */
/// @{

//-----------------------------------------------------------------------------
/// \brief Category for device information and control.
/**
 *  A category for device information and control.
 */
class DeviceControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::DeviceControl</b> object.
    explicit DeviceControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        deviceType(),
        deviceScanType(),
        deviceVendorName(),
        deviceModelName(),
        deviceFamilyName(),
        deviceManufacturerInfo(),
        deviceVersion(),
        deviceFirmwareVersion(),
        deviceSerialNumber(),
        deviceID(),
        deviceUserID(),
        deviceSFNCVersionMajor(),
        deviceSFNCVersionMinor(),
        deviceSFNCVersionSubMinor(),
        deviceManifestEntrySelector(),
        deviceManifestXMLMajorVersion(),
        deviceManifestXMLMinorVersion(),
        deviceManifestXMLSubMinorVersion(),
        deviceManifestSchemaMajorVersion(),
        deviceManifestSchemaMinorVersion(),
        deviceManifestPrimaryURL(),
        deviceManifestSecondaryURL(),
        deviceTLType(),
        deviceTLVersionMajor(),
        deviceTLVersionMinor(),
        deviceTLVersionSubMinor(),
        deviceGenCPVersionMajor(),
        deviceGenCPVersionMinor(),
        deviceMaxThroughput(),
        deviceConnectionSelector(),
        deviceConnectionSpeed(),
        deviceConnectionStatus(),
        deviceLinkSelector(),
        deviceLinkSpeed(),
        deviceLinkThroughputLimitMode(),
        deviceLinkThroughputLimit(),
        deviceLinkConnectionCount(),
        deviceLinkHeartbeatMode(),
        deviceLinkHeartbeatTimeout(),
        deviceLinkCommandTimeout(),
        deviceStreamChannelCount(),
        deviceStreamChannelSelector(),
        deviceStreamChannelType(),
        deviceStreamChannelLink(),
        deviceStreamChannelEndianness(),
        deviceStreamChannelPacketSize(),
        deviceEventChannelCount(),
        deviceMessageChannelCount(),
        deviceCharacterSet(),
        deviceReset(),
        deviceIndicatorMode(),
        deviceFeaturePersistenceStart(),
        deviceFeaturePersistenceEnd(),
        deviceRegistersStreamingStart(),
        deviceRegistersStreamingEnd(),
        deviceRegistersCheck(),
        deviceRegistersValid(),
        deviceRegistersEndianness(),
        deviceTemperatureSelector(),
        deviceTemperature(),
        deviceClockSelector(),
        deviceClockFrequency(),
        deviceSerialPortSelector(),
        deviceSerialPortBaudRate(),
        timestamp(),
        timestampReset(),
        timestampLatch(),
        timestampLatchValue(),
        mvDeviceTemperatureRaw(),
        mvDeviceTemperatureUpperLimit(),
        mvDeviceTemperatureLowerLimit(),
        mvDeviceTemperatureLimitHysteresis(),
        mvDeviceClockFrequency(),
        mvDeviceClockGranularity(),
        mvDeviceSensorName(),
        mvDeviceSensorColorMode(),
        mvDeviceFPGAVersion(),
        mvDeviceFirmwareSource(),
        mvDeviceProcessingUnit(),
        mvDevicePowerMode()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( deviceType, "DeviceType" );
        locator.bindComponent( deviceScanType, "DeviceScanType" );
        locator.bindComponent( deviceVendorName, "DeviceVendorName" );
        locator.bindComponent( deviceModelName, "DeviceModelName" );
        locator.bindComponent( deviceFamilyName, "DeviceFamilyName" );
        locator.bindComponent( deviceManufacturerInfo, "DeviceManufacturerInfo" );
        locator.bindComponent( deviceVersion, "DeviceVersion" );
        locator.bindComponent( deviceFirmwareVersion, "DeviceFirmwareVersion" );
        locator.bindComponent( deviceSerialNumber, "DeviceSerialNumber" );
        locator.bindComponent( deviceID, "DeviceID" );
        locator.bindComponent( deviceUserID, "DeviceUserID" );
        locator.bindComponent( deviceSFNCVersionMajor, "DeviceSFNCVersionMajor" );
        locator.bindComponent( deviceSFNCVersionMinor, "DeviceSFNCVersionMinor" );
        locator.bindComponent( deviceSFNCVersionSubMinor, "DeviceSFNCVersionSubMinor" );
        locator.bindComponent( deviceManifestEntrySelector, "DeviceManifestEntrySelector" );
        locator.bindComponent( deviceManifestXMLMajorVersion, "DeviceManifestXMLMajorVersion" );
        locator.bindComponent( deviceManifestXMLMinorVersion, "DeviceManifestXMLMinorVersion" );
        locator.bindComponent( deviceManifestXMLSubMinorVersion, "DeviceManifestXMLSubMinorVersion" );
        locator.bindComponent( deviceManifestSchemaMajorVersion, "DeviceManifestSchemaMajorVersion" );
        locator.bindComponent( deviceManifestSchemaMinorVersion, "DeviceManifestSchemaMinorVersion" );
        locator.bindComponent( deviceManifestPrimaryURL, "DeviceManifestPrimaryURL" );
        locator.bindComponent( deviceManifestSecondaryURL, "DeviceManifestSecondaryURL" );
        locator.bindComponent( deviceTLType, "DeviceTLType" );
        locator.bindComponent( deviceTLVersionMajor, "DeviceTLVersionMajor" );
        locator.bindComponent( deviceTLVersionMinor, "DeviceTLVersionMinor" );
        locator.bindComponent( deviceTLVersionSubMinor, "DeviceTLVersionSubMinor" );
        locator.bindComponent( deviceGenCPVersionMajor, "DeviceGenCPVersionMajor" );
        locator.bindComponent( deviceGenCPVersionMinor, "DeviceGenCPVersionMinor" );
        locator.bindComponent( deviceMaxThroughput, "DeviceMaxThroughput" );
        locator.bindComponent( deviceConnectionSelector, "DeviceConnectionSelector" );
        locator.bindComponent( deviceConnectionSpeed, "DeviceConnectionSpeed" );
        locator.bindComponent( deviceConnectionStatus, "DeviceConnectionStatus" );
        locator.bindComponent( deviceLinkSelector, "DeviceLinkSelector" );
        locator.bindComponent( deviceLinkSpeed, "DeviceLinkSpeed" );
        locator.bindComponent( deviceLinkThroughputLimitMode, "DeviceLinkThroughputLimitMode" );
        locator.bindComponent( deviceLinkThroughputLimit, "DeviceLinkThroughputLimit" );
        locator.bindComponent( deviceLinkConnectionCount, "DeviceLinkConnectionCount" );
        locator.bindComponent( deviceLinkHeartbeatMode, "DeviceLinkHeartbeatMode" );
        locator.bindComponent( deviceLinkHeartbeatTimeout, "DeviceLinkHeartbeatTimeout" );
        locator.bindComponent( deviceLinkCommandTimeout, "DeviceLinkCommandTimeout" );
        locator.bindComponent( deviceStreamChannelCount, "DeviceStreamChannelCount" );
        locator.bindComponent( deviceStreamChannelSelector, "DeviceStreamChannelSelector" );
        locator.bindComponent( deviceStreamChannelType, "DeviceStreamChannelType" );
        locator.bindComponent( deviceStreamChannelLink, "DeviceStreamChannelLink" );
        locator.bindComponent( deviceStreamChannelEndianness, "DeviceStreamChannelEndianness" );
        locator.bindComponent( deviceStreamChannelPacketSize, "DeviceStreamChannelPacketSize" );
        locator.bindComponent( deviceEventChannelCount, "DeviceEventChannelCount" );
        locator.bindComponent( deviceMessageChannelCount, "DeviceMessageChannelCount" );
        locator.bindComponent( deviceCharacterSet, "DeviceCharacterSet" );
        locator.bindComponent( deviceReset, "DeviceReset@i" );
        locator.bindComponent( deviceIndicatorMode, "DeviceIndicatorMode" );
        locator.bindComponent( deviceFeaturePersistenceStart, "DeviceFeaturePersistenceStart@i" );
        locator.bindComponent( deviceFeaturePersistenceEnd, "DeviceFeaturePersistenceEnd@i" );
        locator.bindComponent( deviceRegistersStreamingStart, "DeviceRegistersStreamingStart@i" );
        locator.bindComponent( deviceRegistersStreamingEnd, "DeviceRegistersStreamingEnd@i" );
        locator.bindComponent( deviceRegistersCheck, "DeviceRegistersCheck@i" );
        locator.bindComponent( deviceRegistersValid, "DeviceRegistersValid" );
        locator.bindComponent( deviceRegistersEndianness, "DeviceRegistersEndianness" );
        locator.bindComponent( deviceTemperatureSelector, "DeviceTemperatureSelector" );
        locator.bindComponent( deviceTemperature, "DeviceTemperature" );
        locator.bindComponent( deviceClockSelector, "DeviceClockSelector" );
        locator.bindComponent( deviceClockFrequency, "DeviceClockFrequency" );
        locator.bindComponent( deviceSerialPortSelector, "DeviceSerialPortSelector" );
        locator.bindComponent( deviceSerialPortBaudRate, "DeviceSerialPortBaudRate" );
        locator.bindComponent( timestamp, "Timestamp" );
        locator.bindComponent( timestampReset, "TimestampReset@i" );
        locator.bindComponent( timestampLatch, "TimestampLatch@i" );
        locator.bindComponent( timestampLatchValue, "TimestampLatchValue" );
        locator.bindComponent( mvDeviceTemperatureRaw, "mvDeviceTemperatureRaw" );
        locator.bindComponent( mvDeviceTemperatureUpperLimit, "mvDeviceTemperatureUpperLimit" );
        locator.bindComponent( mvDeviceTemperatureLowerLimit, "mvDeviceTemperatureLowerLimit" );
        locator.bindComponent( mvDeviceTemperatureLimitHysteresis, "mvDeviceTemperatureLimitHysteresis" );
        locator.bindComponent( mvDeviceClockFrequency, "mvDeviceClockFrequency" );
        locator.bindComponent( mvDeviceClockGranularity, "mvDeviceClockGranularity" );
        locator.bindComponent( mvDeviceSensorName, "mvDeviceSensorName" );
        locator.bindComponent( mvDeviceSensorColorMode, "mvDeviceSensorColorMode" );
        locator.bindComponent( mvDeviceFPGAVersion, "mvDeviceFPGAVersion" );
        locator.bindComponent( mvDeviceFirmwareSource, "mvDeviceFirmwareSource" );
        locator.bindComponent( mvDeviceProcessingUnit, "mvDeviceProcessingUnit" );
        locator.bindComponent( mvDevicePowerMode, "mvDevicePowerMode" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Returns the device type.
    /**
     *  Returns the device type.
     */
    PropertyI64 deviceType;
    /// \brief Scan type of the sensor of the device.
    /**
     *  Scan type of the sensor of the device.
     */
    PropertyI64 deviceScanType;
    /// \brief Name of the manufacturer of the device.
    /**
     *  Name of the manufacturer of the device.
     */
    PropertyS deviceVendorName;
    /// \brief Model of the device.
    /**
     *  Model of the device.
     */
    PropertyS deviceModelName;
    /// \brief Identifier of the product family of the device.
    /**
     *  Identifier of the product family of the device.
     */
    PropertyS deviceFamilyName;
    /// \brief Manufacturer information about the device.
    /**
     *  Manufacturer information about the device.
     */
    PropertyS deviceManufacturerInfo;
    /// \brief Version of the device.
    /**
     *  Version of the device.
     */
    PropertyS deviceVersion;
    /// \brief Version of the firmware in the device.
    /**
     *  Version of the firmware in the device.
     */
    PropertyS deviceFirmwareVersion;
    /// \brief Device's serial number.
    /**
     *  Device's serial number. This string is a unique identifier of the device.
     */
    PropertyS deviceSerialNumber;
    /// \brief This feature is deprecated (See DeviceSerialNumber).
    /**
     *  \deprecated
     *  This feature is deprecated (See DeviceSerialNumber). It was representing the Device unique identifier (serial number).
     */
    PropertyS deviceID;
    /// \brief User-programmable device identifier.
    /**
     *  User-programmable device identifier.
     */
    PropertyS deviceUserID;
    /// \brief Major version of the Standard Features Naming Convention that was used to create the device's GenICam XML.
    /**
     *  Major version of the Standard Features Naming Convention that was used to create the device's GenICam XML.
     */
    PropertyI64 deviceSFNCVersionMajor;
    /// \brief Minor version of the Standard Features Naming Convention that was used to create the device's GenICam XML.
    /**
     *  Minor version of the Standard Features Naming Convention that was used to create the device's GenICam XML.
     */
    PropertyI64 deviceSFNCVersionMinor;
    /// \brief Sub minor version of Standard Features Naming Convention that was used to create the device's GenICam XML.
    /**
     *  Sub minor version of Standard Features Naming Convention that was used to create the device's GenICam XML.
     */
    PropertyI64 deviceSFNCVersionSubMinor;
    /// \brief Selects the manifest entry to reference.
    /**
     *  Selects the manifest entry to reference.
     */
    PropertyI64 deviceManifestEntrySelector;
    /// \brief Indicates the major version number of the GenICam XML file of the selected manifest entry.
    /**
     *  Indicates the major version number of the GenICam XML file of the selected manifest entry.
     */
    PropertyI64 deviceManifestXMLMajorVersion;
    /// \brief Indicates the minor version number of the GenICam XML file of the selected manifest entry.
    /**
     *  Indicates the minor version number of the GenICam XML file of the selected manifest entry.
     */
    PropertyI64 deviceManifestXMLMinorVersion;
    /// \brief Indicates the subminor version number of the GenICam XML file of the selected manifest entry.
    /**
     *  Indicates the subminor version number of the GenICam XML file of the selected manifest entry.
     */
    PropertyI64 deviceManifestXMLSubMinorVersion;
    /// \brief Indicates the major version number of the schema file of the selected manifest entry.
    /**
     *  Indicates the major version number of the schema file of the selected manifest entry.
     */
    PropertyI64 deviceManifestSchemaMajorVersion;
    /// \brief Indicates the minor version number of the schema file of the selected manifest entry.
    /**
     *  Indicates the minor version number of the schema file of the selected manifest entry.
     */
    PropertyI64 deviceManifestSchemaMinorVersion;
    /// \brief Indicates the first URL to the GenICam XML device description file of the selected manifest entry.
    /**
     *  Indicates the first URL to the GenICam XML device description file of the selected manifest entry.
     */
    PropertyS deviceManifestPrimaryURL;
    /// \brief Indicates the second URL to the GenICam XML device description file of the selected manifest entry.
    /**
     *  Indicates the second URL to the GenICam XML device description file of the selected manifest entry.
     */
    PropertyS deviceManifestSecondaryURL;
    /// \brief Transport Layer type of the device.
    /**
     *  Transport Layer type of the device.
     */
    PropertyI64 deviceTLType;
    /// \brief Major version of the Transport Layer of the device.
    /**
     *  Major version of the Transport Layer of the device.
     */
    PropertyI64 deviceTLVersionMajor;
    /// \brief Minor version of the Transport Layer of the device.
    /**
     *  Minor version of the Transport Layer of the device.
     */
    PropertyI64 deviceTLVersionMinor;
    /// \brief Sub minor version of the Transport Layer of the device.
    /**
     *  Sub minor version of the Transport Layer of the device.
     */
    PropertyI64 deviceTLVersionSubMinor;
    /// \brief Major version of the GenCP protocol supported by the device.
    /**
     *  Major version of the GenCP protocol supported by the device.
     */
    PropertyI64 deviceGenCPVersionMajor;
    /// \brief Minor version of the GenCP protocol supported by the device.
    /**
     *  Minor version of the GenCP protocol supported by the device.
     */
    PropertyI64 deviceGenCPVersionMinor;
    /// \brief Maximum bandwidth of the data that can be streamed out of the device.
    /**
     *  Maximum bandwidth of the data that can be streamed out of the device. This can be used to estimate if the physical connection(s) can sustain transfer of free-running images from the camera at its maximum speed.
     */
    PropertyI64 deviceMaxThroughput;
    /// \brief Selects which Connection of the device to control.
    /**
     *  Selects which Connection of the device to control.
     */
    PropertyI64 deviceConnectionSelector;
    /// \brief Indicates the speed of transmission of the specified Connection.
    /**
     *  Indicates the speed of transmission of the specified Connection
     */
    PropertyI64 deviceConnectionSpeed;
    /// \brief Indicates the status of the specified Connection.
    /**
     *  Indicates the status of the specified Connection.
     */
    PropertyI64 deviceConnectionStatus;
    /// \brief Selects which Link of the device to control.
    /**
     *  Selects which Link of the device to control.
     */
    PropertyI64 deviceLinkSelector;
    /// \brief Indicates the speed of transmission negotiated on the specified Link.
    /**
     *  Indicates the speed of transmission negotiated on the specified Link.
     */
    PropertyI64 deviceLinkSpeed;
    /// \brief Controls if the DeviceLinkThroughputLimit is active.
    /**
     *  Controls if the DeviceLinkThroughputLimit is active. When disabled, lower level TL specific features are expected to control the throughput. When enabled, DeviceLinkThroughputLimit controls the overall throughput.
     */
    PropertyI64 deviceLinkThroughputLimitMode;
    /// \brief Limits the maximum bandwidth of the data that will be streamed out by the device on the selected Link.
    /**
     *  Limits the maximum bandwidth of the data that will be streamed out by the device on the selected Link. If necessary, delays will be uniformly inserted between transport layer packets in order to control the peak bandwidth.
     */
    PropertyI64 deviceLinkThroughputLimit;
    /// \brief Returns the number of physical connection of the device used by a particular Link.
    /**
     *  Returns the number of physical connection of the device used by a particular Link.
     */
    PropertyI64 deviceLinkConnectionCount;
    /// \brief Activate or deactivate the Link's heartbeat.
    /**
     *  Activate or deactivate the Link's heartbeat.
     */
    PropertyI64 deviceLinkHeartbeatMode;
    /// \brief Controls the current heartbeat timeout of the specific Link.
    /**
     *  Controls the current heartbeat timeout of the specific Link.
     */
    PropertyF deviceLinkHeartbeatTimeout;
    /// \brief Indicates the command timeout of the specified Link.
    /**
     *  Indicates the command timeout of the specified Link. This corresponds to the maximum response time of the device for a command sent on that link.
     */
    PropertyF deviceLinkCommandTimeout;
    /// \brief Indicates the number of streaming channels supported by the device.
    /**
     *  Indicates the number of streaming channels supported by the device.
     */
    PropertyI64 deviceStreamChannelCount;
    /// \brief Selects the stream channel to control.
    /**
     *  Selects the stream channel to control.
     */
    PropertyI64 deviceStreamChannelSelector;
    /// \brief Reports the type of the stream channel.
    /**
     *  Reports the type of the stream channel.
     */
    PropertyI64 deviceStreamChannelType;
    /// \brief Index of device's Link to use for streaming the specifed stream channel.
    /**
     *  Index of device's Link to use for streaming the specifed stream channel.
     */
    PropertyI64 deviceStreamChannelLink;
    /// \brief Endianess of multi-byte pixel data for this stream.
    /**
     *  Endianess of multi-byte pixel data for this stream.
     */
    PropertyI64 deviceStreamChannelEndianness;
    /// \brief Specifies the stream packet size, in bytes, to send on the selected channel for a Transmitter or specifies the maximum packet size supported by a receiver.
    /**
     *  Specifies the stream packet size, in bytes, to send on the selected channel for a Transmitter or specifies the maximum packet size supported by a receiver.
     */
    PropertyI64 deviceStreamChannelPacketSize;
    /// \brief Indicates the number of event channels supported by the device.
    /**
     *  Indicates the number of event channels supported by the device.
     */
    PropertyI64 deviceEventChannelCount;
    /// \brief This feature is deprecated (See DeviceEventChannelCount).
    /**
     *  \deprecated
     *  This feature is deprecated (See DeviceEventChannelCount). It indicates the number of message/event channels supported by the device.
     */
    PropertyI64 deviceMessageChannelCount;
    /// \brief Character set used by the strings of the device's bootstrap registers.
    /**
     *  Character set used by the strings of the device's bootstrap registers.
     */
    PropertyI64 deviceCharacterSet;
    /// \brief Resets the device to its power up state.
    /**
     *  Resets the device to its power up state. After reset, the device must be rediscovered.
     */
    Method deviceReset;
    /// \brief Controls the behavior of the indicators (such as LEDs) showing the status of the Device.
    /**
     *  Controls the behavior of the indicators (such as LEDs) showing the status of the Device.
     */
    PropertyI64 deviceIndicatorMode;
    /// \brief Indicate to the device and GenICam XML to get ready for persisting of all streamable features.
    /**
     *  Indicate to the device and GenICam XML to get ready for persisting of all streamable features.
     */
    Method deviceFeaturePersistenceStart;
    /// \brief Indicate to the device the end of feature persistence.
    /**
     *  Indicate to the device the end of feature persistence.
     */
    Method deviceFeaturePersistenceEnd;
    /// \brief Prepare the device for registers streaming without checking for consistency.
    /**
     *  Prepare the device for registers streaming without checking for consistency.
     */
    Method deviceRegistersStreamingStart;
    /// \brief Announce the end of registers streaming.
    /**
     *  Announce the end of registers streaming. This will do a register set validation for consistency and activate it. This will also update the DeviceRegistersValid flag.
     */
    Method deviceRegistersStreamingEnd;
    /// \brief Perform the validation of the current register set for consistency.
    /**
     *  Perform the validation of the current register set for consistency. This will update the DeviceRegistersValid flag.
     */
    Method deviceRegistersCheck;
    /// \brief Returns if the current register set is valid and consistent.
    /**
     *  Returns if the current register set is valid and consistent.
     */
    PropertyIBoolean deviceRegistersValid;
    /// \brief Endianess of the registers of the device.
    /**
     *  Endianess of the registers of the device.
     */
    PropertyI64 deviceRegistersEndianness;
    /// \brief Selects the location within the device, where the temperature will be measured.
    /**
     *  Selects the location within the device, where the temperature will be measured.
     */
    PropertyI64 deviceTemperatureSelector;
    /// \brief Device temperature in degrees Celsius (C).
    /**
     *  Device temperature in degrees Celsius (C). It is measured at the location selected by DeviceTemperatureSelector.
     */
    PropertyF deviceTemperature;
    /// \brief Selects the clock frequency to access from the device.
    /**
     *  Selects the clock frequency to access from the device.
     */
    PropertyI64 deviceClockSelector;
    /// \brief Returns the frequency of the selected Clock.
    /**
     *  Returns the frequency of the selected Clock.
     */
    PropertyF deviceClockFrequency;
    /// \brief Selects which serial port of the device to control.
    /**
     *  Selects which serial port of the device to control.
     */
    PropertyI64 deviceSerialPortSelector;
    /// \brief This feature controls the baud rate used by the selected serial port.
    /**
     *  This feature controls the baud rate used by the selected serial port.
     */
    PropertyI64 deviceSerialPortBaudRate;
    /// \brief Reports the current value of the device timestamp counter.
    /**
     *  Reports the current value of the device timestamp counter.
     */
    PropertyI64 timestamp;
    /// \brief Resets the current value of the device timestamp counter.
    /**
     *  Resets the current value of the device timestamp counter.
     */
    Method timestampReset;
    /// \brief Latches the current timestamp counter into TimestampLatchValue.
    /**
     *  Latches the current timestamp counter into TimestampLatchValue.
     */
    Method timestampLatch;
    /// \brief Returns the latched value of the timestamp counter.
    /**
     *  Returns the latched value of the timestamp counter.
     */
    PropertyI64 timestampLatchValue;
    /// \brief Device temperature in degrees Celsius (C).
    /**
     *  Device temperature in degrees Celsius (C). It is measured at the location selected by DeviceTemperatureSelector.
     */
    PropertyI64 mvDeviceTemperatureRaw;
    /// \brief Upper limit in degrees Celsius(C) for the TemperatureOutOfRange signal.
    /**
     *  Upper limit in degrees Celsius(C) for the TemperatureOutOfRange signal.
     */
    PropertyI64 mvDeviceTemperatureUpperLimit;
    /// \brief Lower limit in degrees Celsius(C) for the TemperatureOutOfRange signal.
    /**
     *  Lower limit in degrees Celsius(C) for the TemperatureOutOfRange signal.
     */
    PropertyI64 mvDeviceTemperatureLowerLimit;
    /// \brief Hysteresis in degrees Celsius(C) for temperature limits.
    /**
     *  Hysteresis in degrees Celsius(C) for temperature limits.
     */
    PropertyI64 mvDeviceTemperatureLimitHysteresis;
    /// \brief Clock frequency of the image sensor of the camera.
    /**
     *  Clock frequency of the image sensor of the camera.
     */
    PropertyI64 mvDeviceClockFrequency;
    /// \brief Special register to configure the clock granularity for LUPA sensors.
    /**
     *  Special register to configure the clock granularity for LUPA sensors.
     */
    PropertyI64 mvDeviceClockGranularity;
    /// \brief Shows the name of the sensor.
    /**
     *  Shows the name of the sensor.
     */
    PropertyS mvDeviceSensorName;
    /// \brief Shows color mode of the sensor.
    /**
     *  Shows color mode of the sensor.
     */
    PropertyI64 mvDeviceSensorColorMode;
    /// \brief Shows version number of the FPGA.
    /**
     *  Shows version number of the FPGA.
     */
    PropertyS mvDeviceFPGAVersion;
    /// \brief Shows the location from where the firmware was loaded.
    /**
     *  Shows the location from where the firmware was loaded.
     */
    PropertyI64 mvDeviceFirmwareSource;
    /// \brief The processing unit to activate for the selected processing unit.
    /**
     *  The processing unit to activate for the selected processing unit.
     */
    PropertyI64 mvDeviceProcessingUnit;
    /// \brief Selects the device power mode.
    /**
     *  Selects the device power mode.
     */
    PropertyI64 mvDevicePowerMode;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category for Image Format Control features.
/**
 *  A category for Image Format Control features.
 */
class ImageFormatControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::ImageFormatControl</b> object.
    explicit ImageFormatControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        sensorWidth(),
        sensorHeight(),
        sensorShutterMode(),
        sensorTaps(),
        sensorDigitizationTaps(),
        widthMax(),
        heightMax(),
        regionSelector(),
        regionMode(),
        regionDestination(),
        imageComponentSelector(),
        imageComponentEnable(),
        width(),
        height(),
        offsetX(),
        offsetY(),
        linePitch(),
        binningSelector(),
        binningHorizontalMode(),
        binningHorizontal(),
        binningVerticalMode(),
        binningVertical(),
        decimationHorizontalMode(),
        decimationHorizontal(),
        decimationVerticalMode(),
        decimationVertical(),
        reverseX(),
        reverseY(),
        pixelFormat(),
        pixelFormatInfoSelector(),
        pixelFormatInfoID(),
        pixelCoding(),
        pixelSize(),
        pixelColorFilter(),
        pixelDynamicRangeMin(),
        pixelDynamicRangeMax(),
        testPatternGeneratorSelector(),
        testPattern(),
        testImageSelector(),
        deinterlacing(),
        imageCompressionMode(),
        imageCompressionRateOption(),
        imageCompressionQuality(),
        imageCompressionBitrate(),
        imageCompressionJPEGFormatOption(),
        mvDigitizationMode(),
        mvOffsetYSensorB(),
        mvSensorLineOffsetSelector(),
        mvSensorLineOffset(),
        mvSensorLinePeriod()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( sensorWidth, "SensorWidth" );
        locator.bindComponent( sensorHeight, "SensorHeight" );
        locator.bindComponent( sensorShutterMode, "SensorShutterMode" );
        locator.bindComponent( sensorTaps, "SensorTaps" );
        locator.bindComponent( sensorDigitizationTaps, "SensorDigitizationTaps" );
        locator.bindComponent( widthMax, "WidthMax" );
        locator.bindComponent( heightMax, "HeightMax" );
        locator.bindComponent( regionSelector, "RegionSelector" );
        locator.bindComponent( regionMode, "RegionMode" );
        locator.bindComponent( regionDestination, "RegionDestination" );
        locator.bindComponent( imageComponentSelector, "ImageComponentSelector" );
        locator.bindComponent( imageComponentEnable, "ImageComponentEnable" );
        locator.bindComponent( width, "Width" );
        locator.bindComponent( height, "Height" );
        locator.bindComponent( offsetX, "OffsetX" );
        locator.bindComponent( offsetY, "OffsetY" );
        locator.bindComponent( linePitch, "LinePitch" );
        locator.bindComponent( binningSelector, "BinningSelector" );
        locator.bindComponent( binningHorizontalMode, "BinningHorizontalMode" );
        locator.bindComponent( binningHorizontal, "BinningHorizontal" );
        locator.bindComponent( binningVerticalMode, "BinningVerticalMode" );
        locator.bindComponent( binningVertical, "BinningVertical" );
        locator.bindComponent( decimationHorizontalMode, "DecimationHorizontalMode" );
        locator.bindComponent( decimationHorizontal, "DecimationHorizontal" );
        locator.bindComponent( decimationVerticalMode, "DecimationVerticalMode" );
        locator.bindComponent( decimationVertical, "DecimationVertical" );
        locator.bindComponent( reverseX, "ReverseX" );
        locator.bindComponent( reverseY, "ReverseY" );
        locator.bindComponent( pixelFormat, "PixelFormat" );
        locator.bindComponent( pixelFormatInfoSelector, "PixelFormatInfoSelector" );
        locator.bindComponent( pixelFormatInfoID, "PixelFormatInfoID" );
        locator.bindComponent( pixelCoding, "PixelCoding" );
        locator.bindComponent( pixelSize, "PixelSize" );
        locator.bindComponent( pixelColorFilter, "PixelColorFilter" );
        locator.bindComponent( pixelDynamicRangeMin, "PixelDynamicRangeMin" );
        locator.bindComponent( pixelDynamicRangeMax, "PixelDynamicRangeMax" );
        locator.bindComponent( testPatternGeneratorSelector, "TestPatternGeneratorSelector" );
        locator.bindComponent( testPattern, "TestPattern" );
        locator.bindComponent( testImageSelector, "TestImageSelector" );
        locator.bindComponent( deinterlacing, "Deinterlacing" );
        locator.bindComponent( imageCompressionMode, "ImageCompressionMode" );
        locator.bindComponent( imageCompressionRateOption, "ImageCompressionRateOption" );
        locator.bindComponent( imageCompressionQuality, "ImageCompressionQuality" );
        locator.bindComponent( imageCompressionBitrate, "ImageCompressionBitrate" );
        locator.bindComponent( imageCompressionJPEGFormatOption, "ImageCompressionJPEGFormatOption" );
        locator.bindComponent( mvDigitizationMode, "mvDigitizationMode" );
        locator.bindComponent( mvOffsetYSensorB, "mvOffsetYSensorB" );
        locator.bindComponent( mvSensorLineOffsetSelector, "mvSensorLineOffsetSelector" );
        locator.bindComponent( mvSensorLineOffset, "mvSensorLineOffset" );
        locator.bindComponent( mvSensorLinePeriod, "mvSensorLinePeriod" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Effective width of the sensor in pixels.
    /**
     *  Effective width of the sensor in pixels.
     */
    PropertyI64 sensorWidth;
    /// \brief Effective height of the sensor in pixels.
    /**
     *  Effective height of the sensor in pixels.
     */
    PropertyI64 sensorHeight;
    /// \brief Sets the shutter mode of the device.
    /**
     *  Sets the shutter mode of the device.
     */
    PropertyI64 sensorShutterMode;
    /// \brief Number of taps of the camera sensor.
    /**
     *  Number of taps of the camera sensor.
     */
    PropertyI64 sensorTaps;
    /// \brief Number of digitized samples outputted simultaneously by the camera A/D conversion stage.
    /**
     *  Number of digitized samples outputted simultaneously by the camera A/D conversion stage.
     */
    PropertyI64 sensorDigitizationTaps;
    /// \brief Maximum width of the image (in pixels).
    /**
     *  Maximum width of the image (in pixels). The dimension is calculated after horizontal binning, decimation or any other function changing the horizontal dimension of the image.
     */
    PropertyI64 widthMax;
    /// \brief Maximum height of the image (in pixels).
    /**
     *  Maximum height of the image (in pixels). This dimension is calculated after vertical binning, decimation or any other function changing the vertical dimension of the image
     */
    PropertyI64 heightMax;
    /// \brief Selects the Region of interest to control.
    /**
     *  Selects the Region of interest to control. The RegionSelector feature allows devices that are able to extract multiple regions out of an image, to configure the features of those individual regions independently.
     */
    PropertyI64 regionSelector;
    /// \brief Controls if the selected Region of interest is active and streaming.
    /**
     *  Controls if the selected Region of interest is active and streaming.
     */
    PropertyI64 regionMode;
    /// \brief Control the destination of the selected region.
    /**
     *  Control the destination of the selected region.
     */
    PropertyI64 regionDestination;
    /// \brief Selects a component to activate data streaming from.
    /**
     *  Selects a component to activate data streaming from.
     */
    PropertyI64 imageComponentSelector;
    /// \brief Controls if the selected component streaming is active.
    /**
     *  Controls if the selected component streaming is active.
     */
    PropertyIBoolean imageComponentEnable;
    /// \brief Width of the image provided by the device (in pixels).
    /**
     *  Width of the image provided by the device (in pixels).
     */
    PropertyI64 width;
    /// \brief Height of the image provided by the device (in pixels).
    /**
     *  Height of the image provided by the device (in pixels).
     */
    PropertyI64 height;
    /// \brief Horizontal offset from the origin to the region of interest (in pixels).
    /**
     *  Horizontal offset from the origin to the region of interest (in pixels).
     */
    PropertyI64 offsetX;
    /// \brief Vertical offset from the origin to the region of interest (in pixels).
    /**
     *  Vertical offset from the origin to the region of interest (in pixels).
     */
    PropertyI64 offsetY;
    /// \brief Total number of bytes between 2 successive lines.
    /**
     *  Total number of bytes between 2 successive lines. This feature is used to facilitate alignment of image data.
     */
    PropertyI64 linePitch;
    /// \brief Selects which binning engine is controlled by the BinningHorizontal and BinningVertical features.
    /**
     *  Selects which binning engine is controlled by the BinningHorizontal and BinningVertical features.
     */
    PropertyI64 binningSelector;
    /// \brief Sets the mode to use to combine horizontal photo-sensitive cells together when BinningHorizontal is used.
    /**
     *  Sets the mode to use to combine horizontal photo-sensitive cells together when BinningHorizontal is used.
     */
    PropertyI64 binningHorizontalMode;
    /// \brief Number of horizontal photo-sensitive cells to combine together.
    /**
     *  Number of horizontal photo-sensitive cells to combine together. This reduces the horizontal resolution (width) of the image.
     */
    PropertyI64 binningHorizontal;
    /// \brief Sets the mode used to combine horizontal photo-sensitive cells together when BinningVertical is used.
    /**
     *  Sets the mode used to combine horizontal photo-sensitive cells together when BinningVertical is used.
     */
    PropertyI64 binningVerticalMode;
    /// \brief Number of vertical photo-sensitive cells to combine together.
    /**
     *  Number of vertical photo-sensitive cells to combine together. This reduces the vertical resolution (height) of the image.
     */
    PropertyI64 binningVertical;
    /// \brief Sets the mode used to reduce the horizontal resolution when DecimationHorizontal is used.
    /**
     *  Sets the mode used to reduce the horizontal resolution when DecimationHorizontal is used.
     */
    PropertyI64 decimationHorizontalMode;
    /// \brief Horizontal sub-sampling of the image.
    /**
     *  Horizontal sub-sampling of the image. This reduces the horizontal resolution (width) of the image by the specified horizontal decimation factor.
     */
    PropertyI64 decimationHorizontal;
    /// \brief Sets the mode used to reduce the Vertical resolution when DecimationVertical is used.
    /**
     *  Sets the mode used to reduce the Vertical resolution when DecimationVertical is used.
     */
    PropertyI64 decimationVerticalMode;
    /// \brief Vertical sub-sampling of the image.
    /**
     *  Vertical sub-sampling of the image. This reduces the vertical resolution (height) of the image by the specified vertical decimation factor.
     */
    PropertyI64 decimationVertical;
    /// \brief Flip horizontally the image sent by the device.
    /**
     *  Flip horizontally the image sent by the device. The Region of interest is applied after the flipping.
     */
    PropertyIBoolean reverseX;
    /// \brief Flip vertically the image sent by the device.
    /**
     *  Flip vertically the image sent by the device. The Region of interest is applied after the flipping.
     */
    PropertyIBoolean reverseY;
    /// \brief Format of the pixels provided by the device.
    /**
     *  Format of the pixels provided by the device. It represents all the information provided by PixelSize, PixelColorFilter combined in a single feature.
     */
    PropertyI64 pixelFormat;
    /// \brief Select the pixel format for which the information will be returned.
    /**
     *  Select the pixel format for which the information will be returned.
     */
    PropertyI64 pixelFormatInfoSelector;
    /// \brief Returns the value used by the streaming channels to identify the selected pixel format.
    /**
     *  Returns the value used by the streaming channels to identify the selected pixel format.
     */
    PropertyI64 pixelFormatInfoID;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It represents the coding of the pixels in the image. Raw gives the data in the native format of the sensor.
     */
    PropertyI64 pixelCoding;
    /// \brief Total size in bits of a pixel of the image.
    /**
     *  Total size in bits of a pixel of the image.
     */
    PropertyI64 pixelSize;
    /// \brief Type of color filter that is applied to the image.
    /**
     *  Type of color filter that is applied to the image.
     */
    PropertyI64 pixelColorFilter;
    /// \brief Minimum value that can be returned during the digitization process.
    /**
     *  Minimum value that can be returned during the digitization process. This corresponds to the darkest value of the camera. For color camera, this returns the smallest value that each color component can take.
     */
    PropertyI64 pixelDynamicRangeMin;
    /// \brief Maximum value that will be returned during the digitization process.
    /**
     *  Maximum value that will be returned during the digitization process. This corresponds to the brightest value of the camera. For color camera, this returns the biggest value that each color component can take.
     */
    PropertyI64 pixelDynamicRangeMax;
    /// \brief Selects which test pattern generator is controlled by the TestPattern feature.
    /**
     *  Selects which test pattern generator is controlled by the TestPattern feature.
     */
    PropertyI64 testPatternGeneratorSelector;
    /// \brief Selects the type of test pattern that is generated by the device as image source.
    /**
     *  Selects the type of test pattern that is generated by the device as image source.
     */
    PropertyI64 testPattern;
    /// \brief This feature is deprecated (See TestPattern).
    /**
     *  \deprecated
     *  This feature is deprecated (See TestPattern). Selects the type of test image that is sent by the device.
     */
    PropertyI64 testImageSelector;
    /// \brief Controls how the device performs de-interlacing.
    /**
     *  Controls how the device performs de-interlacing.
     */
    PropertyI64 deinterlacing;
    /// \brief Enable a specific image compression mode as the base mode for image transfer.
    /**
     *  Enable a specific image compression mode as the base mode for image transfer. Optionally, chunk data can be appended to the compressed image (See chunk section).
     */
    PropertyI64 imageCompressionMode;
    /// \brief Two rate controlling options are offered: fixed bit rate or fixed quality.
    /**
     *  Two rate controlling options are offered: fixed bit rate or fixed quality. The exact implementation to achieve one or the other is vendor-specific.
     */
    PropertyI64 imageCompressionRateOption;
    /// \brief Control the quality of the produced compressed stream.
    /**
     *  Control the quality of the produced compressed stream.
     */
    PropertyI64 imageCompressionQuality;
    /// \brief Control the rate of the produced compressed stream.
    /**
     *  Control the rate of the produced compressed stream.
     */
    PropertyF imageCompressionBitrate;
    /// \brief When JPEG is selected as the compression format, a device might optionally offer better control over JPEG-specific options through this feature.
    /**
     *  When JPEG is selected as the compression format, a device might optionally offer better control over JPEG-specific options through this feature.
     */
    PropertyI64 imageCompressionJPEGFormatOption;
    /// \brief This feature allows to manually select the resolution of the device's ADC.
    /**
     *  This feature allows to manually select the resolution of the device's ADC.
     */
    PropertyI64 mvDigitizationMode;
    /// \brief Vertical offset of SensorB from the origin to the region of interest (in pixels).
    /**
     *  Vertical offset of SensorB from the origin to the region of interest (in pixels).
     */
    PropertyI64 mvOffsetYSensorB;
    /// \brief Selects the sensor to configure
    /**
     *  Selects the sensor to configure
     */
    PropertyI64 mvSensorLineOffsetSelector;
    /// \brief Sets the offset of the sensor selected by mvSensorLineOffsetSelector.
    /**
     *  Sets the offset of the sensor selected by mvSensorLineOffsetSelector.
     */
    PropertyI64 mvSensorLineOffset;
    /// \brief Time in nanoseconds for one line
    /**
     *  Time in nanoseconds for one line
     */
    PropertyI64 mvSensorLinePeriod;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category for the acquisition and trigger control features.
/**
 *  A category for the acquisition and trigger control features.
 */
class AcquisitionControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::AcquisitionControl</b> object.
    explicit AcquisitionControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        acquisitionMode(),
        acquisitionArm(),
        acquisitionFrameCount(),
        acquisitionBurstFrameCount(),
        acquisitionFrameRate(),
        acquisitionFrameRateRaw(),
        acquisitionLineRate(),
        acquisitionLineRateRaw(),
        acquisitionStatusSelector(),
        acquisitionStatus(),
        triggerSelector(),
        triggerMode(),
        triggerSoftware(),
        triggerSource(),
        triggerActivation(),
        triggerOverlap(),
        triggerDelay(),
        triggerDelayRaw(),
        triggerDivider(),
        triggerMultiplier(),
        exposureMode(),
        exposureTimeMode(),
        exposureTimeSelector(),
        exposureTime(),
        exposureTimeRaw(),
        exposureAuto(),
        mvAcquisitionFrameRateLimitMode(),
        mvAcquisitionFrameRateEnable(),
        mvResultingFrameRate(),
        mvShutterMode(),
        mvCompressionKneepoint(),
        mvDefectivePixelEnable(),
        mvExposureAutoLowerLimit(),
        mvExposureAutoUpperLimit(),
        mvExposureAutoSpeed(),
        mvExposureAutoDelayImages(),
        mvExposureAutoAverageGrey(),
        mvExposureAutoHighlightAOI(),
        mvExposureAutoAOIMode(),
        mvExposureAutoOffsetX(),
        mvExposureAutoOffsetY(),
        mvExposureAutoWidth(),
        mvExposureAutoHeight(),
        mvExposureAutoMode(),
        mvSmearReduction(),
        mvAcquisitionMemoryMode(),
        mvPretriggerFrameCount(),
        mvAcquisitionMemoryMaxFrameCount(),
        mvAcquisitionMemoryAOIParameterChanged()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( acquisitionMode, "AcquisitionMode" );
        locator.bindComponent( acquisitionArm, "AcquisitionArm@i" );
        locator.bindComponent( acquisitionFrameCount, "AcquisitionFrameCount" );
        locator.bindComponent( acquisitionBurstFrameCount, "AcquisitionBurstFrameCount" );
        locator.bindComponent( acquisitionFrameRate, "AcquisitionFrameRate" );
        if( !acquisitionFrameRate.isValid() )
        {
            locator.bindComponent( acquisitionFrameRate, "AcquisitionFrameRateAbs" );
        }
        locator.bindComponent( acquisitionFrameRateRaw, "AcquisitionFrameRateRaw" );
        locator.bindComponent( acquisitionLineRate, "AcquisitionLineRate" );
        if( !acquisitionLineRate.isValid() )
        {
            locator.bindComponent( acquisitionLineRate, "AcquisitionLineRateAbs" );
        }
        locator.bindComponent( acquisitionLineRateRaw, "AcquisitionLineRateRaw" );
        locator.bindComponent( acquisitionStatusSelector, "AcquisitionStatusSelector" );
        locator.bindComponent( acquisitionStatus, "AcquisitionStatus" );
        locator.bindComponent( triggerSelector, "TriggerSelector" );
        locator.bindComponent( triggerMode, "TriggerMode" );
        locator.bindComponent( triggerSoftware, "TriggerSoftware@i" );
        locator.bindComponent( triggerSource, "TriggerSource" );
        locator.bindComponent( triggerActivation, "TriggerActivation" );
        locator.bindComponent( triggerOverlap, "TriggerOverlap" );
        locator.bindComponent( triggerDelay, "TriggerDelay" );
        if( !triggerDelay.isValid() )
        {
            locator.bindComponent( triggerDelay, "TriggerDelayAbs" );
        }
        locator.bindComponent( triggerDelayRaw, "TriggerDelayRaw" );
        locator.bindComponent( triggerDivider, "TriggerDivider" );
        locator.bindComponent( triggerMultiplier, "TriggerMultiplier" );
        locator.bindComponent( exposureMode, "ExposureMode" );
        locator.bindComponent( exposureTimeMode, "ExposureTimeMode" );
        locator.bindComponent( exposureTimeSelector, "ExposureTimeSelector" );
        locator.bindComponent( exposureTime, "ExposureTime" );
        if( !exposureTime.isValid() )
        {
            locator.bindComponent( exposureTime, "ExposureTimeAbs" );
        }
        locator.bindComponent( exposureTimeRaw, "ExposureTimeRaw" );
        locator.bindComponent( exposureAuto, "ExposureAuto" );
        locator.bindComponent( mvAcquisitionFrameRateLimitMode, "mvAcquisitionFrameRateLimitMode" );
        locator.bindComponent( mvAcquisitionFrameRateEnable, "mvAcquisitionFrameRateEnable" );
        locator.bindComponent( mvResultingFrameRate, "mvResultingFrameRate" );
        locator.bindComponent( mvShutterMode, "mvShutterMode" );
        locator.bindComponent( mvCompressionKneepoint, "mvCompressionKneepoint" );
        locator.bindComponent( mvDefectivePixelEnable, "mvDefectivePixelEnable" );
        locator.bindComponent( mvExposureAutoLowerLimit, "mvExposureAutoLowerLimit" );
        locator.bindComponent( mvExposureAutoUpperLimit, "mvExposureAutoUpperLimit" );
        locator.bindComponent( mvExposureAutoSpeed, "mvExposureAutoSpeed" );
        locator.bindComponent( mvExposureAutoDelayImages, "mvExposureAutoDelayImages" );
        locator.bindComponent( mvExposureAutoAverageGrey, "mvExposureAutoAverageGrey" );
        locator.bindComponent( mvExposureAutoHighlightAOI, "mvExposureAutoHighlightAOI" );
        locator.bindComponent( mvExposureAutoAOIMode, "mvExposureAutoAOIMode" );
        locator.bindComponent( mvExposureAutoOffsetX, "mvExposureAutoOffsetX" );
        locator.bindComponent( mvExposureAutoOffsetY, "mvExposureAutoOffsetY" );
        locator.bindComponent( mvExposureAutoWidth, "mvExposureAutoWidth" );
        locator.bindComponent( mvExposureAutoHeight, "mvExposureAutoHeight" );
        locator.bindComponent( mvExposureAutoMode, "mvExposureAutoMode" );
        locator.bindComponent( mvSmearReduction, "mvSmearReduction" );
        locator.bindComponent( mvAcquisitionMemoryMode, "mvAcquisitionMemoryMode" );
        locator.bindComponent( mvPretriggerFrameCount, "mvPretriggerFrameCount" );
        locator.bindComponent( mvAcquisitionMemoryMaxFrameCount, "mvAcquisitionMemoryMaxFrameCount" );
        locator.bindComponent( mvAcquisitionMemoryAOIParameterChanged, "mvAcquisitionMemoryAOIParameterChanged" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Sets the acquisition mode of the device.
    /**
     *  Sets the acquisition mode of the device. It defines mainly the number of frames to capture during an acquisition and the way the acquisition stops.
     */
    PropertyI64 acquisitionMode;
    /// \brief Arms the device before an AcquisitionStart command.
    /**
     *  Arms the device before an AcquisitionStart command. This optional command validates all the current features for consistency and prepares the device for a fast start of the Acquisition.
     */
    Method acquisitionArm;
    /// \brief Number of frames to acquire in MultiFrame Acquisition mode.
    /**
     *  Number of frames to acquire in MultiFrame Acquisition mode.
     */
    PropertyI64 acquisitionFrameCount;
    /// \brief Number of frames to acquire for each FrameBurstStart trigger.
    /**
     *  Number of frames to acquire for each FrameBurstStart trigger.
     */
    PropertyI64 acquisitionBurstFrameCount;
    /// \brief Controls the acquisition rate (in Hertz) at which the frames are captured.
    /**
     *  Controls the acquisition rate (in Hertz) at which the frames are captured.
     */
    PropertyF acquisitionFrameRate;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It controls the rate (in device specific unit) at which the Frames are captured when TriggerMode is Off for the Frame trigger.
     */
    PropertyI64 acquisitionFrameRateRaw;
    /// \brief Controls the rate (in Hertz) at which the Lines in a Frame are captured.
    /**
     *  Controls the rate (in Hertz) at which the Lines in a Frame are captured.
     */
    PropertyF acquisitionLineRate;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It controls the rate (in device specific unit) at which the Lines in a Frame are captured when TriggerMode is Off for the Line trigger.
     */
    PropertyI64 acquisitionLineRateRaw;
    /// \brief Selects the internal acquisition signal to read using AcquisitionStatus.
    /**
     *  Selects the internal acquisition signal to read using AcquisitionStatus.
     */
    PropertyI64 acquisitionStatusSelector;
    /// \brief Reads the state of the internal acquisition signal selected using AcquisitionStatusSelector.
    /**
     *  Reads the state of the internal acquisition signal selected using AcquisitionStatusSelector.
     */
    PropertyIBoolean acquisitionStatus;
    /// \brief Selects the type of trigger to configure.
    /**
     *  Selects the type of trigger to configure.
     */
    PropertyI64 triggerSelector;
    /// \brief Controls if the selected trigger is active.
    /**
     *  Controls if the selected trigger is active.
     */
    PropertyI64 triggerMode;
    /// \brief Generates an internal trigger.
    /**
     *  Generates an internal trigger. TriggerSource must be set to Software.
     */
    Method triggerSoftware;
    /// \brief Specifies the internal signal or physical input Line to use as the trigger source.
    /**
     *  Specifies the internal signal or physical input Line to use as the trigger source. The selected trigger must have its TriggerMode set to On.
     */
    PropertyI64 triggerSource;
    /// \brief Specifies the activation mode of the trigger.
    /**
     *  Specifies the activation mode of the trigger.
     */
    PropertyI64 triggerActivation;
    /// \brief Specifies the type trigger overlap permitted with the previous frame or line.
    /**
     *  Specifies the type trigger overlap permitted with the previous frame or line. This defines when a valid trigger will be accepted (or latched) for a new frame or a new line.
     */
    PropertyI64 triggerOverlap;
    /// \brief Specifies the delay in microseconds (us) to apply after the trigger reception before activating it.
    /**
     *  Specifies the delay in microseconds (us) to apply after the trigger reception before activating it.
     */
    PropertyF triggerDelay;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. TriggerDelayRaw specifies the delay in device-specific unit to apply after the trigger reception before effectively activating it. TriggerDelayAbs must reflect the state of TriggerDelayRaw when they are both supported.
     */
    PropertyI64 triggerDelayRaw;
    /// \brief Specifies a division factor for the incoming trigger pulses.
    /**
     *  Specifies a division factor for the incoming trigger pulses.
     */
    PropertyI64 triggerDivider;
    /// \brief Specifies a multiplication factor for the incoming trigger pulses.
    /**
     *  Specifies a multiplication factor for the incoming trigger pulses. It is used generally used in conjunction with TriggerDivider to control the ratio of triggers that are accepted.
     */
    PropertyI64 triggerMultiplier;
    /// \brief Sets the operation mode of the Exposure.
    /**
     *  Sets the operation mode of the Exposure.
     */
    PropertyI64 exposureMode;
    /// \brief Sets the configuration mode of the ExposureTime feature.
    /**
     *  Sets the configuration mode of the ExposureTime feature.
     */
    PropertyI64 exposureTimeMode;
    /// \brief Selects which exposure time is controlled by the ExposureTime feature.
    /**
     *  Selects which exposure time is controlled by the ExposureTime feature. This allows for independent control over the exposure components.
     */
    PropertyI64 exposureTimeSelector;
    /// \brief Sets the Exposure time when ExposureMode is Timed and ExposureAuto is Off.
    /**
     *  Sets the Exposure time when ExposureMode is Timed and ExposureAuto is Off. This controls the duration where the photosensitive cells are exposed to light.
     */
    PropertyF exposureTime;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It can used to set the Exposure time in device-specific unit when ExposureMode is Timed. This controls the duration where the photosensitive cells are exposed to light.
     */
    PropertyI64 exposureTimeRaw;
    /// \brief Sets the automatic exposure mode when ExposureMode is Timed.
    /**
     *  Sets the automatic exposure mode when ExposureMode is Timed. The exact algorithm used to implement this control is device-specific.
     */
    PropertyI64 exposureAuto;
    /// \brief Controls the calculation of the maximum frame rate.
    /**
     *  Controls the calculation of the maximum frame rate.
     */
    PropertyI64 mvAcquisitionFrameRateLimitMode;
    /// \brief Enables the use of the 'AcquisitionFrameRate' feature.
    /**
     *  Enables the use of the 'AcquisitionFrameRate' feature.
     */
    PropertyI64 mvAcquisitionFrameRateEnable;
    /// \brief Shows the resulting frame rate.
    /**
     *  Shows the resulting frame rate.
     */
    PropertyF mvResultingFrameRate;
    /// \brief Selects the shutter mode of the sensor.
    /**
     *  Selects the shutter mode of the sensor.
     */
    PropertyI64 mvShutterMode;
    /// \brief Kneepoint of 10 to 8 bit compression.
    /**
     *  Kneepoint of 10 to 8 bit compression.
     */
    PropertyI64 mvCompressionKneepoint;
    /// \brief Activates the sensor's defective pixel correction.
    /**
     *  Activates the sensor's defective pixel correction.
     */
    PropertyIBoolean mvDefectivePixelEnable;
    /// \brief The lower limit of the exposure time in auto exposure mode.
    /**
     *  The lower limit of the exposure time in auto exposure mode.
     */
    PropertyF mvExposureAutoLowerLimit;
    /// \brief The upper limit of the exposure time in auto exposure mode.
    /**
     *  The upper limit of the exposure time in auto exposure mode.
     */
    PropertyF mvExposureAutoUpperLimit;
    /// \brief Determines the increment or decrement size of exposure value from frame to frame.
    /**
     *  Determines the increment or decrement size of exposure value from frame to frame.
     */
    PropertyI64 mvExposureAutoSpeed;
    /// \brief The number of frames that the AEC must skip before updating the exposure register.
    /**
     *  The number of frames that the AEC must skip before updating the exposure register.
     */
    PropertyI64 mvExposureAutoDelayImages;
    /// \brief Common desired average grey value (in percent) used for Auto Gain Control(AGC) and Auto Exposure Control(AEC).
    /**
     *  Common desired average grey value (in percent) used for auto gain control(AGC) and auto exposure control (AEC).
     */
    PropertyI64 mvExposureAutoAverageGrey;
    /// \brief Highlight auto control AOI to check AOI settings. Switch off for normal operation.
    /**
     *  Highlight auto control AOI to check AOI settings. Switch off for normal operation.
     */
    PropertyI64 mvExposureAutoHighlightAOI;
    /// \brief Common AutoControl AOI used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AutoControl AOI used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvExposureAutoAOIMode;
    /// \brief Common AOI XOffset used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI XOffset used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvExposureAutoOffsetX;
    /// \brief Common AOI YOffset used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI YOffset used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvExposureAutoOffsetY;
    /// \brief Common AOI Width used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Width used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvExposureAutoWidth;
    /// \brief Common AOI Height used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Height used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvExposureAutoHeight;
    /// \brief Selects the common auto mode for gain and exposure.
    /**
     *  Selects the common auto mode for gain and exposure.
     */
    PropertyI64 mvExposureAutoMode;
    /// \brief Smear reduction in triggered and nonoverlapped mode.
    /**
     *  Smear reduction in triggered and nonoverlapped mode.
     */
    PropertyI64 mvSmearReduction;
    /// \brief mvRecord is used to store frames in memory. mvPlayback transfers stored frames. mvPretrigger stores frames in memory to be transfered after trigger.
    /**
     *  mvRecord is used to store frames in memory. mvPlayback transfers stored frames. mvPretrigger stores frames in memory to be transfered after trigger.
     */
    PropertyI64 mvAcquisitionMemoryMode;
    /// \brief Number of frames to acquire before the occurence of an AcquisitionStart or AcquisitionActive trigger.
    /**
     *  Number of frames to acquire before the occurence of an AcquisitionStart or AcquisitionActive trigger.
     */
    PropertyI64 mvPretriggerFrameCount;
    /// \brief Max number of frames to record.
    /**
     *  Max number of frames to record.
     */
    PropertyI64 mvAcquisitionMemoryMaxFrameCount;
    /// \brief AOI and/or binning parameter changed after last Acquisition.
    /**
     *  AOI and/or binning parameter changed after last Acquisition.
     */
    PropertyI64 mvAcquisitionMemoryAOIParameterChanged;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the Analog control features.
/**
 *  A category that contains the Analog control features.
 */
class AnalogControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::AnalogControl</b> object.
    explicit AnalogControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        gainSelector(),
        gain(),
        gainRaw(),
        gainAuto(),
        gainAutoBalance(),
        blackLevelSelector(),
        blackLevel(),
        blackLevelRaw(),
        blackLevelAuto(),
        blackLevelAutoBalance(),
        whiteClipSelector(),
        whiteClip(),
        whiteClipRaw(),
        balanceRatioSelector(),
        balanceRatio(),
        balanceWhiteAuto(),
        gamma(),
        mvGainAutoDelayImages(),
        mvGainAutoUpperLimit(),
        mvGainAutoLowerLimit(),
        mvGainAutoSpeed(),
        mvGainAutoAverageGrey(),
        mvGainAutoHighlightAOI(),
        mvGainAutoAOIMode(),
        mvGainAutoOffsetX(),
        mvGainAutoOffsetY(),
        mvGainAutoWidth(),
        mvGainAutoHeight(),
        mvGainAutoMode(),
        mvBalanceWhiteAutoAOIMode(),
        mvBalanceWhiteAutoOffsetX(),
        mvBalanceWhiteAutoOffsetY(),
        mvBalanceWhiteAutoWidth(),
        mvBalanceWhiteAutoHeight(),
        mvVCAL(),
        mvVBLACK(),
        mvVOFFSET(),
        mvLowLight(),
        mvADCGain(),
        mvVRamp(),
        mvLinearLogarithmicMode(),
        mvDigitalGainOffset(),
        mvSaveCalibrationData()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( gainSelector, "GainSelector" );
        locator.bindComponent( gain, "Gain" );
        if( !gain.isValid() )
        {
            locator.bindComponent( gain, "GainAbs" );
        }
        locator.bindComponent( gainRaw, "GainRaw" );
        locator.bindComponent( gainAuto, "GainAuto" );
        locator.bindComponent( gainAutoBalance, "GainAutoBalance" );
        locator.bindComponent( blackLevelSelector, "BlackLevelSelector" );
        locator.bindComponent( blackLevel, "BlackLevel" );
        if( !blackLevel.isValid() )
        {
            locator.bindComponent( blackLevel, "BlackLevelAbs" );
        }
        locator.bindComponent( blackLevelRaw, "BlackLevelRaw" );
        locator.bindComponent( blackLevelAuto, "BlackLevelAuto" );
        locator.bindComponent( blackLevelAutoBalance, "BlackLevelAutoBalance" );
        locator.bindComponent( whiteClipSelector, "WhiteClipSelector" );
        locator.bindComponent( whiteClip, "WhiteClip" );
        if( !whiteClip.isValid() )
        {
            locator.bindComponent( whiteClip, "WhiteClipAbs" );
        }
        locator.bindComponent( whiteClipRaw, "WhiteClipRaw" );
        locator.bindComponent( balanceRatioSelector, "BalanceRatioSelector" );
        locator.bindComponent( balanceRatio, "BalanceRatio" );
        if( !balanceRatio.isValid() )
        {
            locator.bindComponent( balanceRatio, "BalanceRatioAbs" );
        }
        locator.bindComponent( balanceWhiteAuto, "BalanceWhiteAuto" );
        locator.bindComponent( gamma, "Gamma" );
        locator.bindComponent( mvGainAutoDelayImages, "mvGainAutoDelayImages" );
        locator.bindComponent( mvGainAutoUpperLimit, "mvGainAutoUpperLimit" );
        locator.bindComponent( mvGainAutoLowerLimit, "mvGainAutoLowerLimit" );
        locator.bindComponent( mvGainAutoSpeed, "mvGainAutoSpeed" );
        locator.bindComponent( mvGainAutoAverageGrey, "mvGainAutoAverageGrey" );
        locator.bindComponent( mvGainAutoHighlightAOI, "mvGainAutoHighlightAOI" );
        locator.bindComponent( mvGainAutoAOIMode, "mvGainAutoAOIMode" );
        locator.bindComponent( mvGainAutoOffsetX, "mvGainAutoOffsetX" );
        locator.bindComponent( mvGainAutoOffsetY, "mvGainAutoOffsetY" );
        locator.bindComponent( mvGainAutoWidth, "mvGainAutoWidth" );
        locator.bindComponent( mvGainAutoHeight, "mvGainAutoHeight" );
        locator.bindComponent( mvGainAutoMode, "mvGainAutoMode" );
        locator.bindComponent( mvBalanceWhiteAutoAOIMode, "mvBalanceWhiteAutoAOIMode" );
        locator.bindComponent( mvBalanceWhiteAutoOffsetX, "mvBalanceWhiteAutoOffsetX" );
        locator.bindComponent( mvBalanceWhiteAutoOffsetY, "mvBalanceWhiteAutoOffsetY" );
        locator.bindComponent( mvBalanceWhiteAutoWidth, "mvBalanceWhiteAutoWidth" );
        locator.bindComponent( mvBalanceWhiteAutoHeight, "mvBalanceWhiteAutoHeight" );
        locator.bindComponent( mvVCAL, "mvVCAL" );
        locator.bindComponent( mvVBLACK, "mvVBLACK" );
        locator.bindComponent( mvVOFFSET, "mvVOFFSET" );
        locator.bindComponent( mvLowLight, "mvLowLight" );
        locator.bindComponent( mvADCGain, "mvADCGain" );
        locator.bindComponent( mvVRamp, "mvVRamp" );
        locator.bindComponent( mvLinearLogarithmicMode, "mvLinearLogarithmicMode" );
        locator.bindComponent( mvDigitalGainOffset, "mvDigitalGainOffset" );
        locator.bindComponent( mvSaveCalibrationData, "mvSaveCalibrationData@i" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which Gain is controlled by the various Gain features.
    /**
     *  Selects which Gain is controlled by the various Gain features.
     */
    PropertyI64 gainSelector;
    /// \brief Controls the selected gain as an absolute physical value.
    /**
     *  Controls the selected gain as an absolute physical value. This is an amplification factor applied to the video signal.
     */
    PropertyF gain;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It controls the selected gain as a raw integer value. This is an amplification factor applied to the video signal.
     */
    PropertyI64 gainRaw;
    /// \brief Sets the automatic gain control (AGC) mode.
    /**
     *  Sets the automatic gain control (AGC) mode. The exact algorithm used to implement AGC is device-specific.
     */
    PropertyI64 gainAuto;
    /// \brief Sets the mode for automatic gain balancing between the sensor color channels or taps.
    /**
     *  Sets the mode for automatic gain balancing between the sensor color channels or taps. The gain coefficients of each channel or tap are adjusted so they are matched.
     */
    PropertyI64 gainAutoBalance;
    /// \brief Selects which Black Level is controlled by the various Black Level features.
    /**
     *  Selects which Black Level is controlled by the various Black Level features.
     */
    PropertyI64 blackLevelSelector;
    /// \brief Controls the analog black level as an absolute physical value.
    /**
     *  Controls the analog black level as an absolute physical value. This represents a DC offset applied to the video signal.
     */
    PropertyF blackLevel;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It controls the analog black level as a raw integer value. This represents a DC offset applied to the video signal.
     */
    PropertyI64 blackLevelRaw;
    /// \brief Controls the mode for automatic black level adjustment.
    /**
     *  Controls the mode for automatic black level adjustment. The exact algorithm used to implement this adjustment is device-specific.
     */
    PropertyI64 blackLevelAuto;
    /// \brief Controls the mode for automatic black level balancing between the sensor color channels or taps.
    /**
     *  Controls the mode for automatic black level balancing between the sensor color channels or taps. The black level coefficients of each channel are adjusted so they are matched.
     */
    PropertyI64 blackLevelAutoBalance;
    /// \brief Selects which White Clip to control.
    /**
     *  Selects which White Clip to control.
     */
    PropertyI64 whiteClipSelector;
    /// \brief Controls the maximal intensity taken by the video signal before being clipped as an absolute physical value.
    /**
     *  Controls the maximal intensity taken by the video signal before being clipped as an absolute physical value. The video signal will never exceed the white clipping point: it will saturate at that level.
     */
    PropertyF whiteClip;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. Controls the maximal intensity taken by the video signal before being clipped as a raw integer value. The video signal will never exceed the white clipping point: it will saturate at that level.
     */
    PropertyI64 whiteClipRaw;
    /// \brief Selects which Balance ratio to control.
    /**
     *  Selects which Balance ratio to control.
     */
    PropertyI64 balanceRatioSelector;
    /// \brief Controls ratio of the selected color component to a reference color component.
    /**
     *  Controls ratio of the selected color component to a reference color component. It is used for white balancing.
     */
    PropertyF balanceRatio;
    /// \brief Controls the mode for automatic white balancing between the color channels.
    /**
     *  Controls the mode for automatic white balancing between the color channels. The white balancing ratios are automatically adjusted.
     */
    PropertyI64 balanceWhiteAuto;
    /// \brief Controls the gamma correction of pixel intensity.
    /**
     *  Controls the gamma correction of pixel intensity. This is typically used to compensate for non-linearity of the display system (such as CRT).
     */
    PropertyF gamma;
    /// \brief The number of frames that the AEC must skip before updating the exposure register
    /**
     *  The number of frames that the AEC must skip before updating the exposure register
     */
    PropertyI64 mvGainAutoDelayImages;
    /// \brief The upper limit of the gain in auto gain mode
    /**
     *  The upper limit of the gain in auto gain mode
     */
    PropertyF mvGainAutoUpperLimit;
    /// \brief The lower limit of the gain in auto gain mode
    /**
     *  The lower limit of the gain in auto gain mode
     */
    PropertyF mvGainAutoLowerLimit;
    /// \brief Determines the increment or decrement size of gain value from frame to frame.
    /**
     *  Determines the increment or decrement size of gain value from frame to frame.
     */
    PropertyI64 mvGainAutoSpeed;
    /// \brief Common desired average grey value (in percent) used for Auto Gain Control(AGC) and Auto Exposure Control(AEC).
    /**
     *  Common desired average grey value (in percent) used for Auto Gain Control(AGC) and Auto Exposure Control(AEC).
     */
    PropertyI64 mvGainAutoAverageGrey;
    /// \brief Highlight auto control AOI to check AOI settings. Switch off for normal operation.
    /**
     *  Highlight auto control AOI to check AOI settings. Switch off for normal operation.
     */
    PropertyI64 mvGainAutoHighlightAOI;
    /// \brief Common AutoControl AOI used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balancing.
    /**
     *  Common AutoControl AOI used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balancing.
     */
    PropertyI64 mvGainAutoAOIMode;
    /// \brief Common AOI X-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI X-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvGainAutoOffsetX;
    /// \brief Common AOI Y-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Y-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvGainAutoOffsetY;
    /// \brief Common AOI Width used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Width used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvGainAutoWidth;
    /// \brief Common AOI Height used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Height used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvGainAutoHeight;
    /// \brief Selects the common auto mode for gain and exposure.
    /**
     *  Selects the common auto mode for gain and exposure.
     */
    PropertyI64 mvGainAutoMode;
    /// \brief Common AutoControl AOI used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AutoControl AOI used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvBalanceWhiteAutoAOIMode;
    /// \brief Common AOI X-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI XOffset used for auto gain control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvBalanceWhiteAutoOffsetX;
    /// \brief Common AOI Y-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Y-Offset used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvBalanceWhiteAutoOffsetY;
    /// \brief Common AOI Width used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Width used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvBalanceWhiteAutoWidth;
    /// \brief Common AOI Height used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
    /**
     *  Common AOI Height used for Auto Gain Control(AGC), Auto Exposure Control(AEC) and Auto White Balance(AWB).
     */
    PropertyI64 mvBalanceWhiteAutoHeight;
    /// \brief Sets the voltage in millivolt.
    /**
     *  Sets the voltage in millivolt.
     */
    PropertyI64 mvVCAL;
    /// \brief Sets the voltage in millivolt.
    /**
     *  Sets the voltage in millivolt.
     */
    PropertyI64 mvVBLACK;
    /// \brief Sets the voltage in millivolt.
    /**
     *  Sets the voltage in millivolt.
     */
    PropertyI64 mvVOFFSET;
    /// \brief Makes the image brighter.
    /**
     *  Makes the image brighter.
     */
    PropertyI64 mvLowLight;
    /// \brief Adapt gain. Gain value of the sensor may differ from sensor to sensor.
    /**
     *  Adapt gain. Gain value of the sensor may differ from sensor to sensor.
     */
    PropertyI64 mvADCGain;
    /// \brief Adjusting this value will result in better column CDS (correlated double sampling) which will remove the column FPN from the image.
    /**
     *  Adjusting this value will result in better column CDS (correlated double sampling) which will remove the column FPN from the image.
     */
    PropertyI64 mvVRamp;
    /// \brief Controls the knee point between linear response and logarithmic response.
    /**
     *  Controls the knee point between linear response and logarithmic response.
     */
    PropertyI64 mvLinearLogarithmicMode;
    /// \brief Used for fine tuning of the brightness of the sensor.
    /**
     *  Used for fine tuning of the brightness of the sensor.
     */
    PropertyI64 mvDigitalGainOffset;
    /// \brief Saves the calibration data to non-volatile memory.
    /**
     *  Saves the calibration data to non-volatile memory.
     */
    Method mvSaveCalibrationData;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that includes the LUT control features.
/**
 *  A category that includes the LUT control features.
 */
class LUTControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::LUTControl</b> object.
    explicit LUTControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        LUTSelector(),
        LUTEnable(),
        LUTIndex(),
        LUTValue(),
        LUTValueAll()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( LUTSelector, "LUTSelector" );
        locator.bindComponent( LUTEnable, "LUTEnable" );
        locator.bindComponent( LUTIndex, "LUTIndex" );
        locator.bindComponent( LUTValue, "LUTValue" );
        locator.bindComponent( LUTValueAll, "LUTValueAll" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which LUT to control.
    /**
     *  Selects which LUT to control.
     */
    PropertyI64 LUTSelector;
    /// \brief Activates the selected LUT.
    /**
     *  Activates the selected LUT.
     */
    PropertyIBoolean LUTEnable;
    /// \brief Control the index (offset) of the coefficient to access in the selected LUT.
    /**
     *  Control the index (offset) of the coefficient to access in the selected LUT.
     */
    PropertyI64 LUTIndex;
    /// \brief Returns the Value at entry LUTIndex of the LUT selected by LUTSelector.
    /**
     *  Returns the Value at entry LUTIndex of the LUT selected by LUTSelector.
     */
    PropertyI64 LUTValue;
    /// \brief Accesses all the LUT coefficients in a single access without using individual LUTIndex.
    /**
     *  Accesses all the LUT coefficients in a single access without using individual LUTIndex.
     */
    PropertyS LUTValueAll;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the Color Transformation control features.
/**
 *  A category that contains the Color Transformation control features.
 */
class ColorTransformationControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::ColorTransformationControl</b> object.
    explicit ColorTransformationControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        colorTransformationSelector(),
        colorTransformationEnable(),
        colorTransformationValueSelector(),
        colorTransformationValue()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( colorTransformationSelector, "ColorTransformationSelector" );
        locator.bindComponent( colorTransformationEnable, "ColorTransformationEnable" );
        locator.bindComponent( colorTransformationValueSelector, "ColorTransformationValueSelector" );
        locator.bindComponent( colorTransformationValue, "ColorTransformationValue" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which Color Transformation module is controlled by the various Color Transformation features.
    /**
     *  Selects which Color Transformation module is controlled by the various Color Transformation features.
     */
    PropertyI64 colorTransformationSelector;
    /// \brief Activates the selected Color Transformation module.
    /**
     *  Activates the selected Color Transformation module.
     */
    PropertyIBoolean colorTransformationEnable;
    /// \brief Selects the Gain factor or Offset of the Transformation matrix to access in the selected Color Transformation module.
    /**
     *  Selects the Gain factor or Offset of the Transformation matrix to access in the selected Color Transformation module.
     */
    PropertyI64 colorTransformationValueSelector;
    /// \brief Represents the value of the selected Gain factor or Offset inside the Transformation matrix.
    /**
     *  Represents the value of the selected Gain factor or Offset inside the Transformation matrix.
     */
    PropertyF colorTransformationValue;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the digital input and output control features.
/**
 *  A category that contains the digital input and output control features.
 */
class DigitalIOControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::DigitalIOControl</b> object.
    explicit DigitalIOControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        lineSelector(),
        lineMode(),
        lineInverter(),
        lineStatus(),
        lineStatusAll(),
        lineSource(),
        lineFormat(),
        userOutputSelector(),
        userOutputValue(),
        userOutputValueAll(),
        userOutputValueAllMask(),
        mvLineDebounceTimeRisingEdge(),
        mvLineDebounceTimeFallingEdge(),
        mvRTMInputSelector(),
        mvRTMSource()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( lineSelector, "LineSelector" );
        locator.bindComponent( lineMode, "LineMode" );
        locator.bindComponent( lineInverter, "LineInverter" );
        locator.bindComponent( lineStatus, "LineStatus" );
        locator.bindComponent( lineStatusAll, "LineStatusAll" );
        locator.bindComponent( lineSource, "LineSource" );
        locator.bindComponent( lineFormat, "LineFormat" );
        locator.bindComponent( userOutputSelector, "UserOutputSelector" );
        locator.bindComponent( userOutputValue, "UserOutputValue" );
        locator.bindComponent( userOutputValueAll, "UserOutputValueAll" );
        locator.bindComponent( userOutputValueAllMask, "UserOutputValueAllMask" );
        locator.bindComponent( mvLineDebounceTimeRisingEdge, "mvLineDebounceTimeRisingEdge" );
        locator.bindComponent( mvLineDebounceTimeFallingEdge, "mvLineDebounceTimeFallingEdge" );
        locator.bindComponent( mvRTMInputSelector, "mvRTMInputSelector" );
        locator.bindComponent( mvRTMSource, "mvRTMSource" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects the physical line (or pin) of the external device connector or the virtual line of the Transport Layer to configure.
    /**
     *  Selects the physical line (or pin) of the external device connector or the virtual line of the Transport Layer to configure.
     */
    PropertyI64 lineSelector;
    /// \brief Controls if the physical Line is used to Input or Output a signal.
    /**
     *  Controls if the physical Line is used to Input or Output a signal.
     */
    PropertyI64 lineMode;
    /// \brief Controls the inversion of the signal of the selected input or output Line.
    /**
     *  Controls the inversion of the signal of the selected input or output Line.
     */
    PropertyIBoolean lineInverter;
    /// \brief Returns the current status of the selected input or output Line.
    /**
     *  Returns the current status of the selected input or output Line.
     */
    PropertyIBoolean lineStatus;
    /// \brief Returns the current status of all available Line signals at time of polling in a single bitfield.
    /**
     *  Returns the current status of all available Line signals at time of polling in a single bitfield.
     */
    PropertyI64 lineStatusAll;
    /// \brief Selects which internal acquisition or I/O source signal to output on the selected Line.
    /**
     *  Selects which internal acquisition or I/O source signal to output on the selected Line. LineMode must be Output.
     */
    PropertyI64 lineSource;
    /// \brief Controls the current electrical format of the selected physical input or output Line.
    /**
     *  Controls the current electrical format of the selected physical input or output Line.
     */
    PropertyI64 lineFormat;
    /// \brief Selects which bit of the User Output register will be set by UserOutputValue.
    /**
     *  Selects which bit of the User Output register will be set by UserOutputValue.
     */
    PropertyI64 userOutputSelector;
    /// \brief Sets the value of the bit selected by UserOutputSelector.
    /**
     *  Sets the value of the bit selected by UserOutputSelector.
     */
    PropertyIBoolean userOutputValue;
    /// \brief Sets the value of all the bits of the User Output register.
    /**
     *  Sets the value of all the bits of the User Output register. It is subject to the UserOutputValueAllMask.
     */
    PropertyI64 userOutputValueAll;
    /// \brief Sets the write mask to apply to the value specified by UserOutputValueAll before writing it in the User Output register.
    /**
     *  Sets the write mask to apply to the value specified by UserOutputValueAll before writing it in the User Output register. If the UserOutputValueAllMask feature is present, setting the user Output register using UserOutputValueAll will only change the bits that have a corresponding bit in the mask set to one.
     */
    PropertyI64 userOutputValueAllMask;
    /// \brief Sets the debounce time in micro seconds for low to high transitions.
    /**
     *  Sets the debounce time in micro seconds for low to high transitions.
     */
    PropertyI64 mvLineDebounceTimeRisingEdge;
    /// \brief Sets the debounce time in micro seconds for high to low transitions.
    /**
     *  Sets the debounce time in micro seconds for high to low transitions.
     */
    PropertyI64 mvLineDebounceTimeFallingEdge;
    /// \brief Selects which RTM input to configure.
    /**
     *  Selects which RTM input to configure.
     */
    PropertyI64 mvRTMInputSelector;
    /// \brief Selects which signal to connect to the selected RTM input.
    /**
     *  Selects which signal to connect to the selected RTM input.
     */
    PropertyI64 mvRTMSource;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the Counter and Timer control features.
/**
 *  A category that contains the Counter and Timer control features.
 */
class CounterAndTimerControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::CounterAndTimerControl</b> object.
    explicit CounterAndTimerControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        counterSelector(),
        counterEventSource(),
        counterEventActivation(),
        counterResetSource(),
        counterResetActivation(),
        counterReset(),
        counterValue(),
        counterValueAtReset(),
        counterDuration(),
        counterStatus(),
        counterTriggerSource(),
        counterTriggerActivation(),
        timerSelector(),
        timerDuration(),
        timerDurationRaw(),
        timerDelay(),
        timerDelayRaw(),
        timerReset(),
        timerValue(),
        timerValueRaw(),
        timerStatus(),
        timerTriggerSource(),
        timerTriggerActivation()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( counterSelector, "CounterSelector" );
        locator.bindComponent( counterEventSource, "CounterEventSource" );
        locator.bindComponent( counterEventActivation, "CounterEventActivation" );
        locator.bindComponent( counterResetSource, "CounterResetSource" );
        locator.bindComponent( counterResetActivation, "CounterResetActivation" );
        locator.bindComponent( counterReset, "CounterReset@i" );
        locator.bindComponent( counterValue, "CounterValue" );
        locator.bindComponent( counterValueAtReset, "CounterValueAtReset" );
        locator.bindComponent( counterDuration, "CounterDuration" );
        locator.bindComponent( counterStatus, "CounterStatus" );
        locator.bindComponent( counterTriggerSource, "CounterTriggerSource" );
        locator.bindComponent( counterTriggerActivation, "CounterTriggerActivation" );
        locator.bindComponent( timerSelector, "TimerSelector" );
        locator.bindComponent( timerDuration, "TimerDuration" );
        if( !timerDuration.isValid() )
        {
            locator.bindComponent( timerDuration, "TimerDurationAbs" );
        }
        locator.bindComponent( timerDurationRaw, "TimerDurationRaw" );
        locator.bindComponent( timerDelay, "TimerDelay" );
        if( !timerDelay.isValid() )
        {
            locator.bindComponent( timerDelay, "TimerDelayAbs" );
        }
        locator.bindComponent( timerDelayRaw, "TimerDelayRaw" );
        locator.bindComponent( timerReset, "TimerReset@i" );
        locator.bindComponent( timerValue, "TimerValue" );
        if( !timerValue.isValid() )
        {
            locator.bindComponent( timerValue, "TimerValueAbs" );
        }
        locator.bindComponent( timerValueRaw, "TimerValueRaw" );
        locator.bindComponent( timerStatus, "TimerStatus" );
        locator.bindComponent( timerTriggerSource, "TimerTriggerSource" );
        locator.bindComponent( timerTriggerActivation, "TimerTriggerActivation" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which Counter to configure.
    /**
     *  Selects which Counter to configure.
     */
    PropertyI64 counterSelector;
    /// \brief Select the events that will be the source to increment the Counter.
    /**
     *  Select the events that will be the source to increment the Counter.
     */
    PropertyI64 counterEventSource;
    /// \brief Selects the Activation mode Event Source signal.
    /**
     *  Selects the Activation mode Event Source signal.
     */
    PropertyI64 counterEventActivation;
    /// \brief Selects the signals that will be the source to reset the Counter.
    /**
     *  Selects the signals that will be the source to reset the Counter.
     */
    PropertyI64 counterResetSource;
    /// \brief Selects the Activation mode of the Counter Reset Source signal.
    /**
     *  Selects the Activation mode of the Counter Reset Source signal.
     */
    PropertyI64 counterResetActivation;
    /// \brief Does a software reset of the selected Counter and starts it.
    /**
     *  Does a software reset of the selected Counter and starts it. The counter starts counting events immediately after the reset unless a Counter trigger is active. CounterReset can be used to reset the Counter independently from the CounterResetSource. To disable the counter temporarily, set CounterEventSource to Off.
     */
    Method counterReset;
    /// \brief Reads or writes the current value of the selected Counter.
    /**
     *  Reads or writes the current value of the selected Counter.
     */
    PropertyI64 counterValue;
    /// \brief Reads the value of the selected Counter when it was reset by a trigger or by an explicit CounterReset command.
    /**
     *  Reads the value of the selected Counter when it was reset by a trigger or by an explicit CounterReset command.
     */
    PropertyI64 counterValueAtReset;
    /// \brief Sets the duration (or number of events) before the CounterEnd event is generated.
    /**
     *  Sets the duration (or number of events) before the CounterEnd event is generated.
     */
    PropertyI64 counterDuration;
    /// \brief Returns the current status of the Counter.
    /**
     *  Returns the current status of the Counter.
     */
    PropertyI64 counterStatus;
    /// \brief Selects the source to start the Counter.
    /**
     *  Selects the source to start the Counter.
     */
    PropertyI64 counterTriggerSource;
    /// \brief Selects the activation mode of the trigger to start the Counter.
    /**
     *  Selects the activation mode of the trigger to start the Counter.
     */
    PropertyI64 counterTriggerActivation;
    /// \brief Selects which Timer to configure.
    /**
     *  Selects which Timer to configure.
     */
    PropertyI64 timerSelector;
    /// \brief Sets the duration (in microseconds) of the Timer pulse.
    /**
     *  Sets the duration (in microseconds) of the Timer pulse.
     */
    PropertyF timerDuration;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It sets the duration in device-specific unit of the Timer pulse.
     */
    PropertyI64 timerDurationRaw;
    /// \brief Sets the duration (in microseconds) of the delay to apply at the reception of a trigger before starting the Timer.
    /**
     *  Sets the duration (in microseconds) of the delay to apply at the reception of a trigger before starting the Timer.
     */
    PropertyF timerDelay;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. It sets the duration in device-specific unit of the delay to apply after the reception of a trigger before starting the Timer.
     */
    PropertyI64 timerDelayRaw;
    /// \brief Does a software reset of the selected timer and starts it.
    /**
     *  Does a software reset of the selected timer and starts it. The timer starts immediately after the reset unless a timer trigger is active.
     */
    Method timerReset;
    /// \brief Reads or writes the current value (in microseconds) of the selected Timer.
    /**
     *  Reads or writes the current value (in microseconds) of the selected Timer.
     */
    PropertyF timerValue;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. This feature is used to read the current value in device-specific unit of the selected Timer.
     */
    PropertyI64 timerValueRaw;
    /// \brief Returns the current status of the Timer.
    /**
     *  Returns the current status of the Timer.
     */
    PropertyI64 timerStatus;
    /// \brief Selects the source of the trigger to start the Timer.
    /**
     *  Selects the source of the trigger to start the Timer.
     */
    PropertyI64 timerTriggerSource;
    /// \brief Selects the activation mode of the trigger to start the Timer.
    /**
     *  Selects the activation mode of the trigger to start the Timer.
     */
    PropertyI64 timerTriggerActivation;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the quadrature Encoder Control features.
/**
 *  A category that contains the quadrature Encoder Control features.
 */
class EncoderControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::EncoderControl</b> object.
    explicit EncoderControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        encoderSelector(),
        encoderSourceA(),
        encoderSourceB(),
        encoderMode(),
        encoderDivider(),
        encoderOutputMode(),
        encoderStatus(),
        encoderTimeout(),
        encoderResetSource(),
        encoderResetActivation(),
        encoderReset(),
        encoderValue(),
        encoderValueAtReset()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( encoderSelector, "EncoderSelector" );
        locator.bindComponent( encoderSourceA, "EncoderSourceA" );
        locator.bindComponent( encoderSourceB, "EncoderSourceB" );
        locator.bindComponent( encoderMode, "EncoderMode" );
        locator.bindComponent( encoderDivider, "EncoderDivider" );
        locator.bindComponent( encoderOutputMode, "EncoderOutputMode" );
        locator.bindComponent( encoderStatus, "EncoderStatus" );
        locator.bindComponent( encoderTimeout, "EncoderTimeout" );
        locator.bindComponent( encoderResetSource, "EncoderResetSource" );
        locator.bindComponent( encoderResetActivation, "EncoderResetActivation" );
        locator.bindComponent( encoderReset, "EncoderReset@i" );
        locator.bindComponent( encoderValue, "EncoderValue" );
        locator.bindComponent( encoderValueAtReset, "EncoderValueAtReset" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which Encoder to configure.
    /**
     *  Selects which Encoder to configure.
     */
    PropertyI64 encoderSelector;
    /// \brief Selects the signal which will be the source of the A input of the Encoder.
    /**
     *  Selects the signal which will be the source of the A input of the Encoder.
     */
    PropertyI64 encoderSourceA;
    /// \brief Selects the signal which will be the source of the B input of the Encoder.
    /**
     *  Selects the signal which will be the source of the B input of the Encoder.
     */
    PropertyI64 encoderSourceB;
    /// \brief Selects if the count of encoder uses FourPhase mode with jitter filtering or the HighResolution mode without jitter filtering.
    /**
     *  Selects if the count of encoder uses FourPhase mode with jitter filtering or the HighResolution mode without jitter filtering.
     */
    PropertyI64 encoderMode;
    /// \brief Sets how many Encoder increment/decrements that are needed generate an Encoder output pulse signal.
    /**
     *  Sets how many Encoder increment/decrements that are needed generate an Encoder output pulse signal.
     */
    PropertyI64 encoderDivider;
    /// \brief Selects the conditions for the Encoder interface to generate a valid Encoder output signal.
    /**
     *  Selects the conditions for the Encoder interface to generate a valid Encoder output signal.
     */
    PropertyI64 encoderOutputMode;
    /// \brief Returns the motion status of the encoder.
    /**
     *  Returns the motion status of the encoder.
     */
    PropertyI64 encoderStatus;
    /// \brief Sets the maximum time interval between encoder counter increments before the status turns to static.
    /**
     *  Sets the maximum time interval between encoder counter increments before the status turns to static.
     */
    PropertyF encoderTimeout;
    /// \brief Selects the signals that will be the source to reset the Encoder.
    /**
     *  Selects the signals that will be the source to reset the Encoder.
     */
    PropertyI64 encoderResetSource;
    /// \brief Selects the Activation mode of the Encoder Reset Source signal.
    /**
     *  Selects the Activation mode of the Encoder Reset Source signal.
     */
    PropertyI64 encoderResetActivation;
    /// \brief Does a software reset of the selected Encoder and starts it.
    /**
     *  Does a software reset of the selected Encoder and starts it. The Encoder starts counting events immediately after the reset. EncoderReset can be used to reset the Encoder independently from the EncoderResetSource.
     */
    Method encoderReset;
    /// \brief Reads or writes the current value of the position counter of the selected Encoder.
    /**
     *  Reads or writes the current value of the position counter of the selected Encoder.
     */
    PropertyI64 encoderValue;
    /// \brief Reads the value of the of the position counter of the selected Encoder when it was reset by a signal or by an explicit EncoderReset command.
    /**
     *  Reads the value of the of the position counter of the selected Encoder when it was reset by a signal or by an explicit EncoderReset command.
     */
    PropertyI64 encoderValueAtReset;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the Software Signal Control features.
/**
 *  A category that contains the Software Signal Control features.
 */
class SoftwareSignalControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::SoftwareSignalControl</b> object.
    explicit SoftwareSignalControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        softwareSignalSelector(),
        softwareSignalPulse()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( softwareSignalSelector, "SoftwareSignalSelector" );
        locator.bindComponent( softwareSignalPulse, "SoftwareSignalPulse@i" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which Software Signal features to control.
    /**
     *  Selects which Software Signal features to control.
     */
    PropertyI64 softwareSignalSelector;
    /// \brief Generates a pulse signal that can be used as a software trigger.
    /**
     *  Generates a pulse signal that can be used as a software trigger. This command can be used to trigger other modules that accept a SoftwareSignal as trigger source.
     */
    Method softwareSignalPulse;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the Action control features.
/**
 *  A category that contains the Action control features.
 */
class ActionControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::ActionControl</b> object.
    explicit ActionControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        actionUnconditionalMode(),
        actionDeviceKey(),
        actionQueueSize(),
        actionSelector(),
        actionGroupMask(),
        actionGroupKey()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( actionUnconditionalMode, "ActionUnconditionalMode" );
        locator.bindComponent( actionDeviceKey, "ActionDeviceKey" );
        locator.bindComponent( actionQueueSize, "ActionQueueSize" );
        locator.bindComponent( actionSelector, "ActionSelector" );
        locator.bindComponent( actionGroupMask, "ActionGroupMask" );
        locator.bindComponent( actionGroupKey, "ActionGroupKey" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Enables the unconditional action command mode where action commands are processed even when the primary control channel is closed.
    /**
     *  Enables the unconditional action command mode where action commands are processed even when the primary control channel is closed.
     */
    PropertyI64 actionUnconditionalMode;
    /// \brief Provides the device key that allows the device to check the validity of action commands.
    /**
     *  Provides the device key that allows the device to check the validity of action commands. The device internal assertion of an action signal is only authorized if the ActionDeviceKey and the action device key value in the protocol message are equal.
     */
    PropertyI64 actionDeviceKey;
    /// \brief Indicates the size of the scheduled action commands queue.
    /**
     *  Indicates the size of the scheduled action commands queue. This number represents the maximum number of scheduled action commands that can be pending at a given point in time.
     */
    PropertyI64 actionQueueSize;
    /// \brief Selects to which Action Signal further Action settings apply.
    /**
     *  Selects to which Action Signal further Action settings apply.
     */
    PropertyI64 actionSelector;
    /// \brief Provides the mask that the device will use to validate the action on reception of the action protocol message.
    /**
     *  Provides the mask that the device will use to validate the action on reception of the action protocol message.
     */
    PropertyI64 actionGroupMask;
    /// \brief Provides the key that the device will use to validate the action on reception of the action protocol message.
    /**
     *  Provides the key that the device will use to validate the action on reception of the action protocol message.
     */
    PropertyI64 actionGroupKey;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains Event control features.
/**
 *  A category that contains Event control features.
 */
class EventControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::EventControl</b> object.
    explicit EventControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        eventSelector(),
        eventNotification(),
        eventAcquisitionTrigger(),
        eventAcquisitionTriggerTimestamp(),
        eventAcquisitionTriggerFrameID(),
        eventAcquisitionStart(),
        eventAcquisitionStartTimestamp(),
        eventAcquisitionStartFrameID(),
        eventAcquisitionEnd(),
        eventAcquisitionEndTimestamp(),
        eventAcquisitionEndFrameID(),
        eventAcquisitionTransferStart(),
        eventAcquisitionTransferStartTimestamp(),
        eventAcquisitionTransferStartFrameID(),
        eventAcquisitionTransferEnd(),
        eventAcquisitionTransferEndTimestamp(),
        eventAcquisitionTransferEndFrameID(),
        eventAcquisitionError(),
        eventAcquisitionErrorTimestamp(),
        eventAcquisitionErrorFrameID(),
        eventFrameTrigger(),
        eventFrameTriggerTimestamp(),
        eventFrameTriggerFrameID(),
        eventFrameStart(),
        eventFrameStartTimestamp(),
        eventFrameStartFrameID(),
        eventFrameEnd(),
        eventFrameEndTimestamp(),
        eventFrameEndFrameID(),
        eventFrameBurstStart(),
        eventFrameBurstStartTimestamp(),
        eventFrameBurstStartFrameID(),
        eventFrameBurstEnd(),
        eventFrameBurstEndTimestamp(),
        eventFrameBurstEndFrameID(),
        eventFrameTransferStart(),
        eventFrameTransferStartTimestamp(),
        eventFrameTransferStartFrameID(),
        eventFrameTransferEnd(),
        eventFrameTransferEndTimestamp(),
        eventFrameTransferEndFrameID(),
        eventExposureStart(),
        eventExposureStartTimestamp(),
        eventExposureStartFrameID(),
        eventExposureEnd(),
        eventExposureEndTimestamp(),
        eventExposureEndFrameID(),
        eventCounter0Start(),
        eventCounter0StartTimestamp(),
        eventCounter0StartFrameID(),
        eventCounter1Start(),
        eventCounter1StartTimestamp(),
        eventCounter1StartFrameID(),
        eventCounter2Start(),
        eventCounter2StartTimestamp(),
        eventCounter2StartFrameID(),
        eventCounter3Start(),
        eventCounter3StartTimestamp(),
        eventCounter3StartFrameID(),
        eventCounter4Start(),
        eventCounter4StartTimestamp(),
        eventCounter4StartFrameID(),
        eventCounter5Start(),
        eventCounter5StartTimestamp(),
        eventCounter5StartFrameID(),
        eventCounter6Start(),
        eventCounter6StartTimestamp(),
        eventCounter6StartFrameID(),
        eventCounter7Start(),
        eventCounter7StartTimestamp(),
        eventCounter7StartFrameID(),
        eventCounter8Start(),
        eventCounter8StartTimestamp(),
        eventCounter8StartFrameID(),
        eventCounter9Start(),
        eventCounter9StartTimestamp(),
        eventCounter9StartFrameID(),
        eventCounter10Start(),
        eventCounter10StartTimestamp(),
        eventCounter10StartFrameID(),
        eventCounter11Start(),
        eventCounter11StartTimestamp(),
        eventCounter11StartFrameID(),
        eventCounter12Start(),
        eventCounter12StartTimestamp(),
        eventCounter12StartFrameID(),
        eventCounter13Start(),
        eventCounter13StartTimestamp(),
        eventCounter13StartFrameID(),
        eventCounter14Start(),
        eventCounter14StartTimestamp(),
        eventCounter14StartFrameID(),
        eventCounter0End(),
        eventCounter0EndTimestamp(),
        eventCounter0EndFrameID(),
        eventCounter1End(),
        eventCounter1EndTimestamp(),
        eventCounter1EndFrameID(),
        eventCounter2End(),
        eventCounter2EndTimestamp(),
        eventCounter2EndFrameID(),
        eventCounter3End(),
        eventCounter3EndTimestamp(),
        eventCounter3EndFrameID(),
        eventCounter4End(),
        eventCounter4EndTimestamp(),
        eventCounter4EndFrameID(),
        eventCounter5End(),
        eventCounter5EndTimestamp(),
        eventCounter5EndFrameID(),
        eventCounter6End(),
        eventCounter6EndTimestamp(),
        eventCounter6EndFrameID(),
        eventCounter7End(),
        eventCounter7EndTimestamp(),
        eventCounter7EndFrameID(),
        eventCounter8End(),
        eventCounter8EndTimestamp(),
        eventCounter8EndFrameID(),
        eventCounter9End(),
        eventCounter9EndTimestamp(),
        eventCounter9EndFrameID(),
        eventCounter10End(),
        eventCounter10EndTimestamp(),
        eventCounter10EndFrameID(),
        eventCounter11End(),
        eventCounter11EndTimestamp(),
        eventCounter11EndFrameID(),
        eventCounter12End(),
        eventCounter12EndTimestamp(),
        eventCounter12EndFrameID(),
        eventCounter13End(),
        eventCounter13EndTimestamp(),
        eventCounter13EndFrameID(),
        eventCounter14End(),
        eventCounter14EndTimestamp(),
        eventCounter14EndFrameID(),
        eventTimer0Start(),
        eventTimer0StartTimestamp(),
        eventTimer0StartFrameID(),
        eventTimer1Start(),
        eventTimer1StartTimestamp(),
        eventTimer1StartFrameID(),
        eventTimer2Start(),
        eventTimer2StartTimestamp(),
        eventTimer2StartFrameID(),
        eventTimer3Start(),
        eventTimer3StartTimestamp(),
        eventTimer3StartFrameID(),
        eventTimer4Start(),
        eventTimer4StartTimestamp(),
        eventTimer4StartFrameID(),
        eventTimer5Start(),
        eventTimer5StartTimestamp(),
        eventTimer5StartFrameID(),
        eventTimer6Start(),
        eventTimer6StartTimestamp(),
        eventTimer6StartFrameID(),
        eventTimer7Start(),
        eventTimer7StartTimestamp(),
        eventTimer7StartFrameID(),
        eventTimer8Start(),
        eventTimer8StartTimestamp(),
        eventTimer8StartFrameID(),
        eventTimer9Start(),
        eventTimer9StartTimestamp(),
        eventTimer9StartFrameID(),
        eventTimer10Start(),
        eventTimer10StartTimestamp(),
        eventTimer10StartFrameID(),
        eventTimer11Start(),
        eventTimer11StartTimestamp(),
        eventTimer11StartFrameID(),
        eventTimer12Start(),
        eventTimer12StartTimestamp(),
        eventTimer12StartFrameID(),
        eventTimer13Start(),
        eventTimer13StartTimestamp(),
        eventTimer13StartFrameID(),
        eventTimer14Start(),
        eventTimer14StartTimestamp(),
        eventTimer14StartFrameID(),
        eventTimer0End(),
        eventTimer0EndTimestamp(),
        eventTimer0EndFrameID(),
        eventTimer1End(),
        eventTimer1EndTimestamp(),
        eventTimer1EndFrameID(),
        eventTimer2End(),
        eventTimer2EndTimestamp(),
        eventTimer2EndFrameID(),
        eventTimer3End(),
        eventTimer3EndTimestamp(),
        eventTimer3EndFrameID(),
        eventTimer4End(),
        eventTimer4EndTimestamp(),
        eventTimer4EndFrameID(),
        eventTimer5End(),
        eventTimer5EndTimestamp(),
        eventTimer5EndFrameID(),
        eventTimer6End(),
        eventTimer6EndTimestamp(),
        eventTimer6EndFrameID(),
        eventTimer7End(),
        eventTimer7EndTimestamp(),
        eventTimer7EndFrameID(),
        eventTimer8End(),
        eventTimer8EndTimestamp(),
        eventTimer8EndFrameID(),
        eventTimer9End(),
        eventTimer9EndTimestamp(),
        eventTimer9EndFrameID(),
        eventTimer10End(),
        eventTimer10EndTimestamp(),
        eventTimer10EndFrameID(),
        eventTimer11End(),
        eventTimer11EndTimestamp(),
        eventTimer11EndFrameID(),
        eventTimer12End(),
        eventTimer12EndTimestamp(),
        eventTimer12EndFrameID(),
        eventTimer13End(),
        eventTimer13EndTimestamp(),
        eventTimer13EndFrameID(),
        eventTimer14End(),
        eventTimer14EndTimestamp(),
        eventTimer14EndFrameID(),
        eventLine0RisingEdge(),
        eventLine0RisingEdgeTimestamp(),
        eventLine0RisingEdgeFrameID(),
        eventLine1RisingEdge(),
        eventLine1RisingEdgeTimestamp(),
        eventLine1RisingEdgeFrameID(),
        eventLine2RisingEdge(),
        eventLine2RisingEdgeTimestamp(),
        eventLine2RisingEdgeFrameID(),
        eventLine3RisingEdge(),
        eventLine3RisingEdgeTimestamp(),
        eventLine3RisingEdgeFrameID(),
        eventLine4RisingEdge(),
        eventLine4RisingEdgeTimestamp(),
        eventLine4RisingEdgeFrameID(),
        eventLine5RisingEdge(),
        eventLine5RisingEdgeTimestamp(),
        eventLine5RisingEdgeFrameID(),
        eventLine6RisingEdge(),
        eventLine6RisingEdgeTimestamp(),
        eventLine6RisingEdgeFrameID(),
        eventLine7RisingEdge(),
        eventLine7RisingEdgeTimestamp(),
        eventLine7RisingEdgeFrameID(),
        eventLine8RisingEdge(),
        eventLine8RisingEdgeTimestamp(),
        eventLine8RisingEdgeFrameID(),
        eventLine9RisingEdge(),
        eventLine9RisingEdgeTimestamp(),
        eventLine9RisingEdgeFrameID(),
        eventLine10RisingEdge(),
        eventLine10RisingEdgeTimestamp(),
        eventLine10RisingEdgeFrameID(),
        eventLine11RisingEdge(),
        eventLine11RisingEdgeTimestamp(),
        eventLine11RisingEdgeFrameID(),
        eventLine12RisingEdge(),
        eventLine12RisingEdgeTimestamp(),
        eventLine12RisingEdgeFrameID(),
        eventLine13RisingEdge(),
        eventLine13RisingEdgeTimestamp(),
        eventLine13RisingEdgeFrameID(),
        eventLine14RisingEdge(),
        eventLine14RisingEdgeTimestamp(),
        eventLine14RisingEdgeFrameID(),
        eventLine0FallingEdge(),
        eventLine0FallingEdgeTimestamp(),
        eventLine0FallingEdgeFrameID(),
        eventLine1FallingEdge(),
        eventLine1FallingEdgeTimestamp(),
        eventLine1FallingEdgeFrameID(),
        eventLine2FallingEdge(),
        eventLine2FallingEdgeTimestamp(),
        eventLine2FallingEdgeFrameID(),
        eventLine3FallingEdge(),
        eventLine3FallingEdgeTimestamp(),
        eventLine3FallingEdgeFrameID(),
        eventLine4FallingEdge(),
        eventLine4FallingEdgeTimestamp(),
        eventLine4FallingEdgeFrameID(),
        eventLine5FallingEdge(),
        eventLine5FallingEdgeTimestamp(),
        eventLine5FallingEdgeFrameID(),
        eventLine6FallingEdge(),
        eventLine6FallingEdgeTimestamp(),
        eventLine6FallingEdgeFrameID(),
        eventLine7FallingEdge(),
        eventLine7FallingEdgeTimestamp(),
        eventLine7FallingEdgeFrameID(),
        eventLine8FallingEdge(),
        eventLine8FallingEdgeTimestamp(),
        eventLine8FallingEdgeFrameID(),
        eventLine9FallingEdge(),
        eventLine9FallingEdgeTimestamp(),
        eventLine9FallingEdgeFrameID(),
        eventLine10FallingEdge(),
        eventLine10FallingEdgeTimestamp(),
        eventLine10FallingEdgeFrameID(),
        eventLine11FallingEdge(),
        eventLine11FallingEdgeTimestamp(),
        eventLine11FallingEdgeFrameID(),
        eventLine12FallingEdge(),
        eventLine12FallingEdgeTimestamp(),
        eventLine12FallingEdgeFrameID(),
        eventLine13FallingEdge(),
        eventLine13FallingEdgeTimestamp(),
        eventLine13FallingEdgeFrameID(),
        eventLine14FallingEdge(),
        eventLine14FallingEdgeTimestamp(),
        eventLine14FallingEdgeFrameID(),
        eventLine0AnyEdge(),
        eventLine0AnyEdgeTimestamp(),
        eventLine0AnyEdgeFrameID(),
        eventLine1AnyEdge(),
        eventLine1AnyEdgeTimestamp(),
        eventLine1AnyEdgeFrameID(),
        eventLine2AnyEdge(),
        eventLine2AnyEdgeTimestamp(),
        eventLine2AnyEdgeFrameID(),
        eventLine3AnyEdge(),
        eventLine3AnyEdgeTimestamp(),
        eventLine3AnyEdgeFrameID(),
        eventLine4AnyEdge(),
        eventLine4AnyEdgeTimestamp(),
        eventLine4AnyEdgeFrameID(),
        eventLine5AnyEdge(),
        eventLine5AnyEdgeTimestamp(),
        eventLine5AnyEdgeFrameID(),
        eventLine6AnyEdge(),
        eventLine6AnyEdgeTimestamp(),
        eventLine6AnyEdgeFrameID(),
        eventLine7AnyEdge(),
        eventLine7AnyEdgeTimestamp(),
        eventLine7AnyEdgeFrameID(),
        eventLine8AnyEdge(),
        eventLine8AnyEdgeTimestamp(),
        eventLine8AnyEdgeFrameID(),
        eventLine9AnyEdge(),
        eventLine9AnyEdgeTimestamp(),
        eventLine9AnyEdgeFrameID(),
        eventLine10AnyEdge(),
        eventLine10AnyEdgeTimestamp(),
        eventLine10AnyEdgeFrameID(),
        eventLine11AnyEdge(),
        eventLine11AnyEdgeTimestamp(),
        eventLine11AnyEdgeFrameID(),
        eventLine12AnyEdge(),
        eventLine12AnyEdgeTimestamp(),
        eventLine12AnyEdgeFrameID(),
        eventLine13AnyEdge(),
        eventLine13AnyEdgeTimestamp(),
        eventLine13AnyEdgeFrameID(),
        eventLine14AnyEdge(),
        eventLine14AnyEdgeTimestamp(),
        eventLine14AnyEdgeFrameID(),
        eventError(),
        eventErrorTimestamp(),
        eventErrorFrameID(),
        eventErrorCode()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( eventSelector, "EventSelector" );
        locator.bindComponent( eventNotification, "EventNotification" );
        locator.bindComponent( eventAcquisitionTrigger, "EventAcquisitionTrigger" );
        locator.bindComponent( eventAcquisitionTriggerTimestamp, "EventAcquisitionTriggerTimestamp" );
        locator.bindComponent( eventAcquisitionTriggerFrameID, "EventAcquisitionTriggerFrameID" );
        locator.bindComponent( eventAcquisitionStart, "EventAcquisitionStart" );
        locator.bindComponent( eventAcquisitionStartTimestamp, "EventAcquisitionStartTimestamp" );
        locator.bindComponent( eventAcquisitionStartFrameID, "EventAcquisitionStartFrameID" );
        locator.bindComponent( eventAcquisitionEnd, "EventAcquisitionEnd" );
        locator.bindComponent( eventAcquisitionEndTimestamp, "EventAcquisitionEndTimestamp" );
        locator.bindComponent( eventAcquisitionEndFrameID, "EventAcquisitionEndFrameID" );
        locator.bindComponent( eventAcquisitionTransferStart, "EventAcquisitionTransferStart" );
        locator.bindComponent( eventAcquisitionTransferStartTimestamp, "EventAcquisitionTransferStartTimestamp" );
        locator.bindComponent( eventAcquisitionTransferStartFrameID, "EventAcquisitionTransferStartFrameID" );
        locator.bindComponent( eventAcquisitionTransferEnd, "EventAcquisitionTransferEnd" );
        locator.bindComponent( eventAcquisitionTransferEndTimestamp, "EventAcquisitionTransferEndTimestamp" );
        locator.bindComponent( eventAcquisitionTransferEndFrameID, "EventAcquisitionTransferEndFrameID" );
        locator.bindComponent( eventAcquisitionError, "EventAcquisitionError" );
        locator.bindComponent( eventAcquisitionErrorTimestamp, "EventAcquisitionErrorTimestamp" );
        locator.bindComponent( eventAcquisitionErrorFrameID, "EventAcquisitionErrorFrameID" );
        locator.bindComponent( eventFrameTrigger, "EventFrameTrigger" );
        locator.bindComponent( eventFrameTriggerTimestamp, "EventFrameTriggerTimestamp" );
        locator.bindComponent( eventFrameTriggerFrameID, "EventFrameTriggerFrameID" );
        locator.bindComponent( eventFrameStart, "EventFrameStart" );
        locator.bindComponent( eventFrameStartTimestamp, "EventFrameStartTimestamp" );
        locator.bindComponent( eventFrameStartFrameID, "EventFrameStartFrameID" );
        locator.bindComponent( eventFrameEnd, "EventFrameEnd" );
        locator.bindComponent( eventFrameEndTimestamp, "EventFrameEndTimestamp" );
        locator.bindComponent( eventFrameEndFrameID, "EventFrameEndFrameID" );
        locator.bindComponent( eventFrameBurstStart, "EventFrameBurstStart" );
        locator.bindComponent( eventFrameBurstStartTimestamp, "EventFrameBurstStartTimestamp" );
        locator.bindComponent( eventFrameBurstStartFrameID, "EventFrameBurstStartFrameID" );
        locator.bindComponent( eventFrameBurstEnd, "EventFrameBurstEnd" );
        locator.bindComponent( eventFrameBurstEndTimestamp, "EventFrameBurstEndTimestamp" );
        locator.bindComponent( eventFrameBurstEndFrameID, "EventFrameBurstEndFrameID" );
        locator.bindComponent( eventFrameTransferStart, "EventFrameTransferStart" );
        locator.bindComponent( eventFrameTransferStartTimestamp, "EventFrameTransferStartTimestamp" );
        locator.bindComponent( eventFrameTransferStartFrameID, "EventFrameTransferStartFrameID" );
        locator.bindComponent( eventFrameTransferEnd, "EventFrameTransferEnd" );
        locator.bindComponent( eventFrameTransferEndTimestamp, "EventFrameTransferEndTimestamp" );
        locator.bindComponent( eventFrameTransferEndFrameID, "EventFrameTransferEndFrameID" );
        locator.bindComponent( eventExposureStart, "EventExposureStart" );
        locator.bindComponent( eventExposureStartTimestamp, "EventExposureStartTimestamp" );
        locator.bindComponent( eventExposureStartFrameID, "EventExposureStartFrameID" );
        locator.bindComponent( eventExposureEnd, "EventExposureEnd" );
        locator.bindComponent( eventExposureEndTimestamp, "EventExposureEndTimestamp" );
        locator.bindComponent( eventExposureEndFrameID, "EventExposureEndFrameID" );
        locator.bindComponent( eventCounter0Start, "EventCounter0Start" );
        locator.bindComponent( eventCounter0StartTimestamp, "EventCounter0StartTimestamp" );
        locator.bindComponent( eventCounter0StartFrameID, "EventCounter0StartFrameID" );
        locator.bindComponent( eventCounter1Start, "EventCounter1Start" );
        locator.bindComponent( eventCounter1StartTimestamp, "EventCounter1StartTimestamp" );
        locator.bindComponent( eventCounter1StartFrameID, "EventCounter1StartFrameID" );
        locator.bindComponent( eventCounter2Start, "EventCounter2Start" );
        locator.bindComponent( eventCounter2StartTimestamp, "EventCounter2StartTimestamp" );
        locator.bindComponent( eventCounter2StartFrameID, "EventCounter2StartFrameID" );
        locator.bindComponent( eventCounter3Start, "EventCounter3Start" );
        locator.bindComponent( eventCounter3StartTimestamp, "EventCounter3StartTimestamp" );
        locator.bindComponent( eventCounter3StartFrameID, "EventCounter3StartFrameID" );
        locator.bindComponent( eventCounter4Start, "EventCounter4Start" );
        locator.bindComponent( eventCounter4StartTimestamp, "EventCounter4StartTimestamp" );
        locator.bindComponent( eventCounter4StartFrameID, "EventCounter4StartFrameID" );
        locator.bindComponent( eventCounter5Start, "EventCounter5Start" );
        locator.bindComponent( eventCounter5StartTimestamp, "EventCounter5StartTimestamp" );
        locator.bindComponent( eventCounter5StartFrameID, "EventCounter5StartFrameID" );
        locator.bindComponent( eventCounter6Start, "EventCounter6Start" );
        locator.bindComponent( eventCounter6StartTimestamp, "EventCounter6StartTimestamp" );
        locator.bindComponent( eventCounter6StartFrameID, "EventCounter6StartFrameID" );
        locator.bindComponent( eventCounter7Start, "EventCounter7Start" );
        locator.bindComponent( eventCounter7StartTimestamp, "EventCounter7StartTimestamp" );
        locator.bindComponent( eventCounter7StartFrameID, "EventCounter7StartFrameID" );
        locator.bindComponent( eventCounter8Start, "EventCounter8Start" );
        locator.bindComponent( eventCounter8StartTimestamp, "EventCounter8StartTimestamp" );
        locator.bindComponent( eventCounter8StartFrameID, "EventCounter8StartFrameID" );
        locator.bindComponent( eventCounter9Start, "EventCounter9Start" );
        locator.bindComponent( eventCounter9StartTimestamp, "EventCounter9StartTimestamp" );
        locator.bindComponent( eventCounter9StartFrameID, "EventCounter9StartFrameID" );
        locator.bindComponent( eventCounter10Start, "EventCounter10Start" );
        locator.bindComponent( eventCounter10StartTimestamp, "EventCounter10StartTimestamp" );
        locator.bindComponent( eventCounter10StartFrameID, "EventCounter10StartFrameID" );
        locator.bindComponent( eventCounter11Start, "EventCounter11Start" );
        locator.bindComponent( eventCounter11StartTimestamp, "EventCounter11StartTimestamp" );
        locator.bindComponent( eventCounter11StartFrameID, "EventCounter11StartFrameID" );
        locator.bindComponent( eventCounter12Start, "EventCounter12Start" );
        locator.bindComponent( eventCounter12StartTimestamp, "EventCounter12StartTimestamp" );
        locator.bindComponent( eventCounter12StartFrameID, "EventCounter12StartFrameID" );
        locator.bindComponent( eventCounter13Start, "EventCounter13Start" );
        locator.bindComponent( eventCounter13StartTimestamp, "EventCounter13StartTimestamp" );
        locator.bindComponent( eventCounter13StartFrameID, "EventCounter13StartFrameID" );
        locator.bindComponent( eventCounter14Start, "EventCounter14Start" );
        locator.bindComponent( eventCounter14StartTimestamp, "EventCounter14StartTimestamp" );
        locator.bindComponent( eventCounter14StartFrameID, "EventCounter14StartFrameID" );
        locator.bindComponent( eventCounter0End, "EventCounter0End" );
        locator.bindComponent( eventCounter0EndTimestamp, "EventCounter0EndTimestamp" );
        locator.bindComponent( eventCounter0EndFrameID, "EventCounter0EndFrameID" );
        locator.bindComponent( eventCounter1End, "EventCounter1End" );
        locator.bindComponent( eventCounter1EndTimestamp, "EventCounter1EndTimestamp" );
        locator.bindComponent( eventCounter1EndFrameID, "EventCounter1EndFrameID" );
        locator.bindComponent( eventCounter2End, "EventCounter2End" );
        locator.bindComponent( eventCounter2EndTimestamp, "EventCounter2EndTimestamp" );
        locator.bindComponent( eventCounter2EndFrameID, "EventCounter2EndFrameID" );
        locator.bindComponent( eventCounter3End, "EventCounter3End" );
        locator.bindComponent( eventCounter3EndTimestamp, "EventCounter3EndTimestamp" );
        locator.bindComponent( eventCounter3EndFrameID, "EventCounter3EndFrameID" );
        locator.bindComponent( eventCounter4End, "EventCounter4End" );
        locator.bindComponent( eventCounter4EndTimestamp, "EventCounter4EndTimestamp" );
        locator.bindComponent( eventCounter4EndFrameID, "EventCounter4EndFrameID" );
        locator.bindComponent( eventCounter5End, "EventCounter5End" );
        locator.bindComponent( eventCounter5EndTimestamp, "EventCounter5EndTimestamp" );
        locator.bindComponent( eventCounter5EndFrameID, "EventCounter5EndFrameID" );
        locator.bindComponent( eventCounter6End, "EventCounter6End" );
        locator.bindComponent( eventCounter6EndTimestamp, "EventCounter6EndTimestamp" );
        locator.bindComponent( eventCounter6EndFrameID, "EventCounter6EndFrameID" );
        locator.bindComponent( eventCounter7End, "EventCounter7End" );
        locator.bindComponent( eventCounter7EndTimestamp, "EventCounter7EndTimestamp" );
        locator.bindComponent( eventCounter7EndFrameID, "EventCounter7EndFrameID" );
        locator.bindComponent( eventCounter8End, "EventCounter8End" );
        locator.bindComponent( eventCounter8EndTimestamp, "EventCounter8EndTimestamp" );
        locator.bindComponent( eventCounter8EndFrameID, "EventCounter8EndFrameID" );
        locator.bindComponent( eventCounter9End, "EventCounter9End" );
        locator.bindComponent( eventCounter9EndTimestamp, "EventCounter9EndTimestamp" );
        locator.bindComponent( eventCounter9EndFrameID, "EventCounter9EndFrameID" );
        locator.bindComponent( eventCounter10End, "EventCounter10End" );
        locator.bindComponent( eventCounter10EndTimestamp, "EventCounter10EndTimestamp" );
        locator.bindComponent( eventCounter10EndFrameID, "EventCounter10EndFrameID" );
        locator.bindComponent( eventCounter11End, "EventCounter11End" );
        locator.bindComponent( eventCounter11EndTimestamp, "EventCounter11EndTimestamp" );
        locator.bindComponent( eventCounter11EndFrameID, "EventCounter11EndFrameID" );
        locator.bindComponent( eventCounter12End, "EventCounter12End" );
        locator.bindComponent( eventCounter12EndTimestamp, "EventCounter12EndTimestamp" );
        locator.bindComponent( eventCounter12EndFrameID, "EventCounter12EndFrameID" );
        locator.bindComponent( eventCounter13End, "EventCounter13End" );
        locator.bindComponent( eventCounter13EndTimestamp, "EventCounter13EndTimestamp" );
        locator.bindComponent( eventCounter13EndFrameID, "EventCounter13EndFrameID" );
        locator.bindComponent( eventCounter14End, "EventCounter14End" );
        locator.bindComponent( eventCounter14EndTimestamp, "EventCounter14EndTimestamp" );
        locator.bindComponent( eventCounter14EndFrameID, "EventCounter14EndFrameID" );
        locator.bindComponent( eventTimer0Start, "EventTimer0Start" );
        locator.bindComponent( eventTimer0StartTimestamp, "EventTimer0StartTimestamp" );
        locator.bindComponent( eventTimer0StartFrameID, "EventTimer0StartFrameID" );
        locator.bindComponent( eventTimer1Start, "EventTimer1Start" );
        locator.bindComponent( eventTimer1StartTimestamp, "EventTimer1StartTimestamp" );
        locator.bindComponent( eventTimer1StartFrameID, "EventTimer1StartFrameID" );
        locator.bindComponent( eventTimer2Start, "EventTimer2Start" );
        locator.bindComponent( eventTimer2StartTimestamp, "EventTimer2StartTimestamp" );
        locator.bindComponent( eventTimer2StartFrameID, "EventTimer2StartFrameID" );
        locator.bindComponent( eventTimer3Start, "EventTimer3Start" );
        locator.bindComponent( eventTimer3StartTimestamp, "EventTimer3StartTimestamp" );
        locator.bindComponent( eventTimer3StartFrameID, "EventTimer3StartFrameID" );
        locator.bindComponent( eventTimer4Start, "EventTimer4Start" );
        locator.bindComponent( eventTimer4StartTimestamp, "EventTimer4StartTimestamp" );
        locator.bindComponent( eventTimer4StartFrameID, "EventTimer4StartFrameID" );
        locator.bindComponent( eventTimer5Start, "EventTimer5Start" );
        locator.bindComponent( eventTimer5StartTimestamp, "EventTimer5StartTimestamp" );
        locator.bindComponent( eventTimer5StartFrameID, "EventTimer5StartFrameID" );
        locator.bindComponent( eventTimer6Start, "EventTimer6Start" );
        locator.bindComponent( eventTimer6StartTimestamp, "EventTimer6StartTimestamp" );
        locator.bindComponent( eventTimer6StartFrameID, "EventTimer6StartFrameID" );
        locator.bindComponent( eventTimer7Start, "EventTimer7Start" );
        locator.bindComponent( eventTimer7StartTimestamp, "EventTimer7StartTimestamp" );
        locator.bindComponent( eventTimer7StartFrameID, "EventTimer7StartFrameID" );
        locator.bindComponent( eventTimer8Start, "EventTimer8Start" );
        locator.bindComponent( eventTimer8StartTimestamp, "EventTimer8StartTimestamp" );
        locator.bindComponent( eventTimer8StartFrameID, "EventTimer8StartFrameID" );
        locator.bindComponent( eventTimer9Start, "EventTimer9Start" );
        locator.bindComponent( eventTimer9StartTimestamp, "EventTimer9StartTimestamp" );
        locator.bindComponent( eventTimer9StartFrameID, "EventTimer9StartFrameID" );
        locator.bindComponent( eventTimer10Start, "EventTimer10Start" );
        locator.bindComponent( eventTimer10StartTimestamp, "EventTimer10StartTimestamp" );
        locator.bindComponent( eventTimer10StartFrameID, "EventTimer10StartFrameID" );
        locator.bindComponent( eventTimer11Start, "EventTimer11Start" );
        locator.bindComponent( eventTimer11StartTimestamp, "EventTimer11StartTimestamp" );
        locator.bindComponent( eventTimer11StartFrameID, "EventTimer11StartFrameID" );
        locator.bindComponent( eventTimer12Start, "EventTimer12Start" );
        locator.bindComponent( eventTimer12StartTimestamp, "EventTimer12StartTimestamp" );
        locator.bindComponent( eventTimer12StartFrameID, "EventTimer12StartFrameID" );
        locator.bindComponent( eventTimer13Start, "EventTimer13Start" );
        locator.bindComponent( eventTimer13StartTimestamp, "EventTimer13StartTimestamp" );
        locator.bindComponent( eventTimer13StartFrameID, "EventTimer13StartFrameID" );
        locator.bindComponent( eventTimer14Start, "EventTimer14Start" );
        locator.bindComponent( eventTimer14StartTimestamp, "EventTimer14StartTimestamp" );
        locator.bindComponent( eventTimer14StartFrameID, "EventTimer14StartFrameID" );
        locator.bindComponent( eventTimer0End, "EventTimer0End" );
        locator.bindComponent( eventTimer0EndTimestamp, "EventTimer0EndTimestamp" );
        locator.bindComponent( eventTimer0EndFrameID, "EventTimer0EndFrameID" );
        locator.bindComponent( eventTimer1End, "EventTimer1End" );
        locator.bindComponent( eventTimer1EndTimestamp, "EventTimer1EndTimestamp" );
        locator.bindComponent( eventTimer1EndFrameID, "EventTimer1EndFrameID" );
        locator.bindComponent( eventTimer2End, "EventTimer2End" );
        locator.bindComponent( eventTimer2EndTimestamp, "EventTimer2EndTimestamp" );
        locator.bindComponent( eventTimer2EndFrameID, "EventTimer2EndFrameID" );
        locator.bindComponent( eventTimer3End, "EventTimer3End" );
        locator.bindComponent( eventTimer3EndTimestamp, "EventTimer3EndTimestamp" );
        locator.bindComponent( eventTimer3EndFrameID, "EventTimer3EndFrameID" );
        locator.bindComponent( eventTimer4End, "EventTimer4End" );
        locator.bindComponent( eventTimer4EndTimestamp, "EventTimer4EndTimestamp" );
        locator.bindComponent( eventTimer4EndFrameID, "EventTimer4EndFrameID" );
        locator.bindComponent( eventTimer5End, "EventTimer5End" );
        locator.bindComponent( eventTimer5EndTimestamp, "EventTimer5EndTimestamp" );
        locator.bindComponent( eventTimer5EndFrameID, "EventTimer5EndFrameID" );
        locator.bindComponent( eventTimer6End, "EventTimer6End" );
        locator.bindComponent( eventTimer6EndTimestamp, "EventTimer6EndTimestamp" );
        locator.bindComponent( eventTimer6EndFrameID, "EventTimer6EndFrameID" );
        locator.bindComponent( eventTimer7End, "EventTimer7End" );
        locator.bindComponent( eventTimer7EndTimestamp, "EventTimer7EndTimestamp" );
        locator.bindComponent( eventTimer7EndFrameID, "EventTimer7EndFrameID" );
        locator.bindComponent( eventTimer8End, "EventTimer8End" );
        locator.bindComponent( eventTimer8EndTimestamp, "EventTimer8EndTimestamp" );
        locator.bindComponent( eventTimer8EndFrameID, "EventTimer8EndFrameID" );
        locator.bindComponent( eventTimer9End, "EventTimer9End" );
        locator.bindComponent( eventTimer9EndTimestamp, "EventTimer9EndTimestamp" );
        locator.bindComponent( eventTimer9EndFrameID, "EventTimer9EndFrameID" );
        locator.bindComponent( eventTimer10End, "EventTimer10End" );
        locator.bindComponent( eventTimer10EndTimestamp, "EventTimer10EndTimestamp" );
        locator.bindComponent( eventTimer10EndFrameID, "EventTimer10EndFrameID" );
        locator.bindComponent( eventTimer11End, "EventTimer11End" );
        locator.bindComponent( eventTimer11EndTimestamp, "EventTimer11EndTimestamp" );
        locator.bindComponent( eventTimer11EndFrameID, "EventTimer11EndFrameID" );
        locator.bindComponent( eventTimer12End, "EventTimer12End" );
        locator.bindComponent( eventTimer12EndTimestamp, "EventTimer12EndTimestamp" );
        locator.bindComponent( eventTimer12EndFrameID, "EventTimer12EndFrameID" );
        locator.bindComponent( eventTimer13End, "EventTimer13End" );
        locator.bindComponent( eventTimer13EndTimestamp, "EventTimer13EndTimestamp" );
        locator.bindComponent( eventTimer13EndFrameID, "EventTimer13EndFrameID" );
        locator.bindComponent( eventTimer14End, "EventTimer14End" );
        locator.bindComponent( eventTimer14EndTimestamp, "EventTimer14EndTimestamp" );
        locator.bindComponent( eventTimer14EndFrameID, "EventTimer14EndFrameID" );
        locator.bindComponent( eventLine0RisingEdge, "EventLine0RisingEdge" );
        locator.bindComponent( eventLine0RisingEdgeTimestamp, "EventLine0RisingEdgeTimestamp" );
        locator.bindComponent( eventLine0RisingEdgeFrameID, "EventLine0RisingEdgeFrameID" );
        locator.bindComponent( eventLine1RisingEdge, "EventLine1RisingEdge" );
        locator.bindComponent( eventLine1RisingEdgeTimestamp, "EventLine1RisingEdgeTimestamp" );
        locator.bindComponent( eventLine1RisingEdgeFrameID, "EventLine1RisingEdgeFrameID" );
        locator.bindComponent( eventLine2RisingEdge, "EventLine2RisingEdge" );
        locator.bindComponent( eventLine2RisingEdgeTimestamp, "EventLine2RisingEdgeTimestamp" );
        locator.bindComponent( eventLine2RisingEdgeFrameID, "EventLine2RisingEdgeFrameID" );
        locator.bindComponent( eventLine3RisingEdge, "EventLine3RisingEdge" );
        locator.bindComponent( eventLine3RisingEdgeTimestamp, "EventLine3RisingEdgeTimestamp" );
        locator.bindComponent( eventLine3RisingEdgeFrameID, "EventLine3RisingEdgeFrameID" );
        locator.bindComponent( eventLine4RisingEdge, "EventLine4RisingEdge" );
        locator.bindComponent( eventLine4RisingEdgeTimestamp, "EventLine4RisingEdgeTimestamp" );
        locator.bindComponent( eventLine4RisingEdgeFrameID, "EventLine4RisingEdgeFrameID" );
        locator.bindComponent( eventLine5RisingEdge, "EventLine5RisingEdge" );
        locator.bindComponent( eventLine5RisingEdgeTimestamp, "EventLine5RisingEdgeTimestamp" );
        locator.bindComponent( eventLine5RisingEdgeFrameID, "EventLine5RisingEdgeFrameID" );
        locator.bindComponent( eventLine6RisingEdge, "EventLine6RisingEdge" );
        locator.bindComponent( eventLine6RisingEdgeTimestamp, "EventLine6RisingEdgeTimestamp" );
        locator.bindComponent( eventLine6RisingEdgeFrameID, "EventLine6RisingEdgeFrameID" );
        locator.bindComponent( eventLine7RisingEdge, "EventLine7RisingEdge" );
        locator.bindComponent( eventLine7RisingEdgeTimestamp, "EventLine7RisingEdgeTimestamp" );
        locator.bindComponent( eventLine7RisingEdgeFrameID, "EventLine7RisingEdgeFrameID" );
        locator.bindComponent( eventLine8RisingEdge, "EventLine8RisingEdge" );
        locator.bindComponent( eventLine8RisingEdgeTimestamp, "EventLine8RisingEdgeTimestamp" );
        locator.bindComponent( eventLine8RisingEdgeFrameID, "EventLine8RisingEdgeFrameID" );
        locator.bindComponent( eventLine9RisingEdge, "EventLine9RisingEdge" );
        locator.bindComponent( eventLine9RisingEdgeTimestamp, "EventLine9RisingEdgeTimestamp" );
        locator.bindComponent( eventLine9RisingEdgeFrameID, "EventLine9RisingEdgeFrameID" );
        locator.bindComponent( eventLine10RisingEdge, "EventLine10RisingEdge" );
        locator.bindComponent( eventLine10RisingEdgeTimestamp, "EventLine10RisingEdgeTimestamp" );
        locator.bindComponent( eventLine10RisingEdgeFrameID, "EventLine10RisingEdgeFrameID" );
        locator.bindComponent( eventLine11RisingEdge, "EventLine11RisingEdge" );
        locator.bindComponent( eventLine11RisingEdgeTimestamp, "EventLine11RisingEdgeTimestamp" );
        locator.bindComponent( eventLine11RisingEdgeFrameID, "EventLine11RisingEdgeFrameID" );
        locator.bindComponent( eventLine12RisingEdge, "EventLine12RisingEdge" );
        locator.bindComponent( eventLine12RisingEdgeTimestamp, "EventLine12RisingEdgeTimestamp" );
        locator.bindComponent( eventLine12RisingEdgeFrameID, "EventLine12RisingEdgeFrameID" );
        locator.bindComponent( eventLine13RisingEdge, "EventLine13RisingEdge" );
        locator.bindComponent( eventLine13RisingEdgeTimestamp, "EventLine13RisingEdgeTimestamp" );
        locator.bindComponent( eventLine13RisingEdgeFrameID, "EventLine13RisingEdgeFrameID" );
        locator.bindComponent( eventLine14RisingEdge, "EventLine14RisingEdge" );
        locator.bindComponent( eventLine14RisingEdgeTimestamp, "EventLine14RisingEdgeTimestamp" );
        locator.bindComponent( eventLine14RisingEdgeFrameID, "EventLine14RisingEdgeFrameID" );
        locator.bindComponent( eventLine0FallingEdge, "EventLine0FallingEdge" );
        locator.bindComponent( eventLine0FallingEdgeTimestamp, "EventLine0FallingEdgeTimestamp" );
        locator.bindComponent( eventLine0FallingEdgeFrameID, "EventLine0FallingEdgeFrameID" );
        locator.bindComponent( eventLine1FallingEdge, "EventLine1FallingEdge" );
        locator.bindComponent( eventLine1FallingEdgeTimestamp, "EventLine1FallingEdgeTimestamp" );
        locator.bindComponent( eventLine1FallingEdgeFrameID, "EventLine1FallingEdgeFrameID" );
        locator.bindComponent( eventLine2FallingEdge, "EventLine2FallingEdge" );
        locator.bindComponent( eventLine2FallingEdgeTimestamp, "EventLine2FallingEdgeTimestamp" );
        locator.bindComponent( eventLine2FallingEdgeFrameID, "EventLine2FallingEdgeFrameID" );
        locator.bindComponent( eventLine3FallingEdge, "EventLine3FallingEdge" );
        locator.bindComponent( eventLine3FallingEdgeTimestamp, "EventLine3FallingEdgeTimestamp" );
        locator.bindComponent( eventLine3FallingEdgeFrameID, "EventLine3FallingEdgeFrameID" );
        locator.bindComponent( eventLine4FallingEdge, "EventLine4FallingEdge" );
        locator.bindComponent( eventLine4FallingEdgeTimestamp, "EventLine4FallingEdgeTimestamp" );
        locator.bindComponent( eventLine4FallingEdgeFrameID, "EventLine4FallingEdgeFrameID" );
        locator.bindComponent( eventLine5FallingEdge, "EventLine5FallingEdge" );
        locator.bindComponent( eventLine5FallingEdgeTimestamp, "EventLine5FallingEdgeTimestamp" );
        locator.bindComponent( eventLine5FallingEdgeFrameID, "EventLine5FallingEdgeFrameID" );
        locator.bindComponent( eventLine6FallingEdge, "EventLine6FallingEdge" );
        locator.bindComponent( eventLine6FallingEdgeTimestamp, "EventLine6FallingEdgeTimestamp" );
        locator.bindComponent( eventLine6FallingEdgeFrameID, "EventLine6FallingEdgeFrameID" );
        locator.bindComponent( eventLine7FallingEdge, "EventLine7FallingEdge" );
        locator.bindComponent( eventLine7FallingEdgeTimestamp, "EventLine7FallingEdgeTimestamp" );
        locator.bindComponent( eventLine7FallingEdgeFrameID, "EventLine7FallingEdgeFrameID" );
        locator.bindComponent( eventLine8FallingEdge, "EventLine8FallingEdge" );
        locator.bindComponent( eventLine8FallingEdgeTimestamp, "EventLine8FallingEdgeTimestamp" );
        locator.bindComponent( eventLine8FallingEdgeFrameID, "EventLine8FallingEdgeFrameID" );
        locator.bindComponent( eventLine9FallingEdge, "EventLine9FallingEdge" );
        locator.bindComponent( eventLine9FallingEdgeTimestamp, "EventLine9FallingEdgeTimestamp" );
        locator.bindComponent( eventLine9FallingEdgeFrameID, "EventLine9FallingEdgeFrameID" );
        locator.bindComponent( eventLine10FallingEdge, "EventLine10FallingEdge" );
        locator.bindComponent( eventLine10FallingEdgeTimestamp, "EventLine10FallingEdgeTimestamp" );
        locator.bindComponent( eventLine10FallingEdgeFrameID, "EventLine10FallingEdgeFrameID" );
        locator.bindComponent( eventLine11FallingEdge, "EventLine11FallingEdge" );
        locator.bindComponent( eventLine11FallingEdgeTimestamp, "EventLine11FallingEdgeTimestamp" );
        locator.bindComponent( eventLine11FallingEdgeFrameID, "EventLine11FallingEdgeFrameID" );
        locator.bindComponent( eventLine12FallingEdge, "EventLine12FallingEdge" );
        locator.bindComponent( eventLine12FallingEdgeTimestamp, "EventLine12FallingEdgeTimestamp" );
        locator.bindComponent( eventLine12FallingEdgeFrameID, "EventLine12FallingEdgeFrameID" );
        locator.bindComponent( eventLine13FallingEdge, "EventLine13FallingEdge" );
        locator.bindComponent( eventLine13FallingEdgeTimestamp, "EventLine13FallingEdgeTimestamp" );
        locator.bindComponent( eventLine13FallingEdgeFrameID, "EventLine13FallingEdgeFrameID" );
        locator.bindComponent( eventLine14FallingEdge, "EventLine14FallingEdge" );
        locator.bindComponent( eventLine14FallingEdgeTimestamp, "EventLine14FallingEdgeTimestamp" );
        locator.bindComponent( eventLine14FallingEdgeFrameID, "EventLine14FallingEdgeFrameID" );
        locator.bindComponent( eventLine0AnyEdge, "EventLine0AnyEdge" );
        locator.bindComponent( eventLine0AnyEdgeTimestamp, "EventLine0AnyEdgeTimestamp" );
        locator.bindComponent( eventLine0AnyEdgeFrameID, "EventLine0AnyEdgeFrameID" );
        locator.bindComponent( eventLine1AnyEdge, "EventLine1AnyEdge" );
        locator.bindComponent( eventLine1AnyEdgeTimestamp, "EventLine1AnyEdgeTimestamp" );
        locator.bindComponent( eventLine1AnyEdgeFrameID, "EventLine1AnyEdgeFrameID" );
        locator.bindComponent( eventLine2AnyEdge, "EventLine2AnyEdge" );
        locator.bindComponent( eventLine2AnyEdgeTimestamp, "EventLine2AnyEdgeTimestamp" );
        locator.bindComponent( eventLine2AnyEdgeFrameID, "EventLine2AnyEdgeFrameID" );
        locator.bindComponent( eventLine3AnyEdge, "EventLine3AnyEdge" );
        locator.bindComponent( eventLine3AnyEdgeTimestamp, "EventLine3AnyEdgeTimestamp" );
        locator.bindComponent( eventLine3AnyEdgeFrameID, "EventLine3AnyEdgeFrameID" );
        locator.bindComponent( eventLine4AnyEdge, "EventLine4AnyEdge" );
        locator.bindComponent( eventLine4AnyEdgeTimestamp, "EventLine4AnyEdgeTimestamp" );
        locator.bindComponent( eventLine4AnyEdgeFrameID, "EventLine4AnyEdgeFrameID" );
        locator.bindComponent( eventLine5AnyEdge, "EventLine5AnyEdge" );
        locator.bindComponent( eventLine5AnyEdgeTimestamp, "EventLine5AnyEdgeTimestamp" );
        locator.bindComponent( eventLine5AnyEdgeFrameID, "EventLine5AnyEdgeFrameID" );
        locator.bindComponent( eventLine6AnyEdge, "EventLine6AnyEdge" );
        locator.bindComponent( eventLine6AnyEdgeTimestamp, "EventLine6AnyEdgeTimestamp" );
        locator.bindComponent( eventLine6AnyEdgeFrameID, "EventLine6AnyEdgeFrameID" );
        locator.bindComponent( eventLine7AnyEdge, "EventLine7AnyEdge" );
        locator.bindComponent( eventLine7AnyEdgeTimestamp, "EventLine7AnyEdgeTimestamp" );
        locator.bindComponent( eventLine7AnyEdgeFrameID, "EventLine7AnyEdgeFrameID" );
        locator.bindComponent( eventLine8AnyEdge, "EventLine8AnyEdge" );
        locator.bindComponent( eventLine8AnyEdgeTimestamp, "EventLine8AnyEdgeTimestamp" );
        locator.bindComponent( eventLine8AnyEdgeFrameID, "EventLine8AnyEdgeFrameID" );
        locator.bindComponent( eventLine9AnyEdge, "EventLine9AnyEdge" );
        locator.bindComponent( eventLine9AnyEdgeTimestamp, "EventLine9AnyEdgeTimestamp" );
        locator.bindComponent( eventLine9AnyEdgeFrameID, "EventLine9AnyEdgeFrameID" );
        locator.bindComponent( eventLine10AnyEdge, "EventLine10AnyEdge" );
        locator.bindComponent( eventLine10AnyEdgeTimestamp, "EventLine10AnyEdgeTimestamp" );
        locator.bindComponent( eventLine10AnyEdgeFrameID, "EventLine10AnyEdgeFrameID" );
        locator.bindComponent( eventLine11AnyEdge, "EventLine11AnyEdge" );
        locator.bindComponent( eventLine11AnyEdgeTimestamp, "EventLine11AnyEdgeTimestamp" );
        locator.bindComponent( eventLine11AnyEdgeFrameID, "EventLine11AnyEdgeFrameID" );
        locator.bindComponent( eventLine12AnyEdge, "EventLine12AnyEdge" );
        locator.bindComponent( eventLine12AnyEdgeTimestamp, "EventLine12AnyEdgeTimestamp" );
        locator.bindComponent( eventLine12AnyEdgeFrameID, "EventLine12AnyEdgeFrameID" );
        locator.bindComponent( eventLine13AnyEdge, "EventLine13AnyEdge" );
        locator.bindComponent( eventLine13AnyEdgeTimestamp, "EventLine13AnyEdgeTimestamp" );
        locator.bindComponent( eventLine13AnyEdgeFrameID, "EventLine13AnyEdgeFrameID" );
        locator.bindComponent( eventLine14AnyEdge, "EventLine14AnyEdge" );
        locator.bindComponent( eventLine14AnyEdgeTimestamp, "EventLine14AnyEdgeTimestamp" );
        locator.bindComponent( eventLine14AnyEdgeFrameID, "EventLine14AnyEdgeFrameID" );
        locator.bindComponent( eventError, "EventError" );
        locator.bindComponent( eventErrorTimestamp, "EventErrorTimestamp" );
        locator.bindComponent( eventErrorFrameID, "EventErrorFrameID" );
        locator.bindComponent( eventErrorCode, "EventErrorCode" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which Event to signal to the host application.
    /**
     *  Selects which Event to signal to the host application.
     */
    PropertyI64 eventSelector;
    /// \brief Activate or deactivate the notification to the host application of the occurrence of the selected Event.
    /**
     *  Activate or deactivate the notification to the host application of the occurrence of the selected Event.
     */
    PropertyI64 eventNotification;
    /// \brief Returns the unique Identifier of the Acquisition Trigger type of Event.
    /**
     *  Returns the unique Identifier of the Acquisition Trigger type of Event.
     */
    PropertyI64 eventAcquisitionTrigger;
    /// \brief Returns the Timestamp of the Acquisition Trigger Event.
    /**
     *  Returns the Timestamp of the Acquisition Trigger Event.
     */
    PropertyI64 eventAcquisitionTriggerTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Acquisition Trigger Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Acquisition Trigger Event.
     */
    PropertyI64 eventAcquisitionTriggerFrameID;
    /// \brief Returns the unique Identifier of the Acquisition Start type of Event.
    /**
     *  Returns the unique Identifier of the Acquisition Start type of Event.
     */
    PropertyI64 eventAcquisitionStart;
    /// \brief Returns the Timestamp of the Acquisition Start Event.
    /**
     *  Returns the Timestamp of the Acquisition Start Event.
     */
    PropertyI64 eventAcquisitionStartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Acquisition Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Acquisition Start Event.
     */
    PropertyI64 eventAcquisitionStartFrameID;
    /// \brief Returns the unique Identifier of the Acquisition End type of Event.
    /**
     *  Returns the unique Identifier of the Acquisition End type of Event.
     */
    PropertyI64 eventAcquisitionEnd;
    /// \brief Returns the Timestamp of the Acquisition End Event.
    /**
     *  Returns the Timestamp of the Acquisition End Event.
     */
    PropertyI64 eventAcquisitionEndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Acquisition End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Acquisition End Event.
     */
    PropertyI64 eventAcquisitionEndFrameID;
    /// \brief Returns the unique Identifier of the Acquisition Transfer Start type of Event.
    /**
     *  Returns the unique Identifier of the Acquisition Transfer Start type of Event.
     */
    PropertyI64 eventAcquisitionTransferStart;
    /// \brief Returns the Timestamp of the Acquisition Transfer Start Event.
    /**
     *  Returns the Timestamp of the Acquisition Transfer Start Event.
     */
    PropertyI64 eventAcquisitionTransferStartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Acquisition Transfer Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Acquisition Transfer Start Event.
     */
    PropertyI64 eventAcquisitionTransferStartFrameID;
    /// \brief Returns the unique Identifier of the Acquisition Transfer End type of Event.
    /**
     *  Returns the unique Identifier of the Acquisition Transfer End type of Event.
     */
    PropertyI64 eventAcquisitionTransferEnd;
    /// \brief Returns the Timestamp of the Acquisition Transfer End Event.
    /**
     *  Returns the Timestamp of the Acquisition Transfer End Event.
     */
    PropertyI64 eventAcquisitionTransferEndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Acquisition Transfer End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Acquisition Transfer End Event.
     */
    PropertyI64 eventAcquisitionTransferEndFrameID;
    /// \brief Returns the unique Identifier of the Acquisition Error type of Event.
    /**
     *  Returns the unique Identifier of the Acquisition Error type of Event.
     */
    PropertyI64 eventAcquisitionError;
    /// \brief Returns the Timestamp of the Acquisition Error Event.
    /**
     *  Returns the Timestamp of the Acquisition Error Event.
     */
    PropertyI64 eventAcquisitionErrorTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Acquisition Error Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Acquisition Error Event.
     */
    PropertyI64 eventAcquisitionErrorFrameID;
    /// \brief Returns the unique Identifier of the FrameTrigger type of Event.
    /**
     *  Returns the unique Identifier of the FrameTrigger type of Event. It can be used to register a callback function to be notified of the event occurrence. Its value uniquely identifies the type event received.
     */
    PropertyI64 eventFrameTrigger;
    /// \brief Returns the Timestamp of the FrameTrigger Event.
    /**
     *  Returns the Timestamp of the FrameTrigger Event. It can be used to determine precisely when the event occurred.
     */
    PropertyI64 eventFrameTriggerTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the FrameTrigger Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the FrameTrigger Event.
     */
    PropertyI64 eventFrameTriggerFrameID;
    /// \brief Returns the unique Identifier of the Frame Start type of Event.
    /**
     *  Returns the unique Identifier of the Frame Start type of Event.
     */
    PropertyI64 eventFrameStart;
    /// \brief Returns the Timestamp of the Frame Start Event.
    /**
     *  Returns the Timestamp of the Frame Start Event.
     */
    PropertyI64 eventFrameStartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Frame Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Frame Start Event.
     */
    PropertyI64 eventFrameStartFrameID;
    /// \brief Returns the unique Identifier of the Frame End type of Event.
    /**
     *  Returns the unique Identifier of the Frame End type of Event.
     */
    PropertyI64 eventFrameEnd;
    /// \brief Returns the Timestamp of the Frame End Event.
    /**
     *  Returns the Timestamp of the Frame End Event.
     */
    PropertyI64 eventFrameEndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Frame End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Frame End Event.
     */
    PropertyI64 eventFrameEndFrameID;
    /// \brief Returns the unique Identifier of the Frame Burst Start type of Event.
    /**
     *  Returns the unique Identifier of the Frame Burst Start type of Event.
     */
    PropertyI64 eventFrameBurstStart;
    /// \brief Returns the Timestamp of the Frame Burst Start Event.
    /**
     *  Returns the Timestamp of the Frame Burst Start Event.
     */
    PropertyI64 eventFrameBurstStartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Frame Burst Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Frame Burst Start Event.
     */
    PropertyI64 eventFrameBurstStartFrameID;
    /// \brief Returns the unique Identifier of the Frame Burst End type of Event.
    /**
     *  Returns the unique Identifier of the Frame Burst End type of Event.
     */
    PropertyI64 eventFrameBurstEnd;
    /// \brief Returns the Timestamp of the Frame Burst End Event.
    /**
     *  Returns the Timestamp of the Frame Burst End Event.
     */
    PropertyI64 eventFrameBurstEndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Frame Burst End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Frame Burst End Event.
     */
    PropertyI64 eventFrameBurstEndFrameID;
    /// \brief Returns the unique Identifier of the Frame Transfer Start type of Event.
    /**
     *  Returns the unique Identifier of the Frame Transfer Start type of Event.
     */
    PropertyI64 eventFrameTransferStart;
    /// \brief Returns the Timestamp of the Frame Transfer Start Event.
    /**
     *  Returns the Timestamp of the Frame Transfer Start Event.
     */
    PropertyI64 eventFrameTransferStartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Frame Transfer Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Frame Transfer Start Event.
     */
    PropertyI64 eventFrameTransferStartFrameID;
    /// \brief Returns the unique Identifier of the Frame Transfer End type of Event.
    /**
     *  Returns the unique Identifier of the Frame Transfer End type of Event.
     */
    PropertyI64 eventFrameTransferEnd;
    /// \brief Returns the Timestamp of the Frame Transfer End Event.
    /**
     *  Returns the Timestamp of the Frame Transfer End Event.
     */
    PropertyI64 eventFrameTransferEndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Frame Transfer End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Frame Transfer End Event.
     */
    PropertyI64 eventFrameTransferEndFrameID;
    /// \brief Returns the unique Identifier of the Exposure Start type of Event.
    /**
     *  Returns the unique Identifier of the Exposure Start type of Event.
     */
    PropertyI64 eventExposureStart;
    /// \brief Returns the Timestamp of the Exposure Start Event.
    /**
     *  Returns the Timestamp of the Exposure Start Event.
     */
    PropertyI64 eventExposureStartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Exposure Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Exposure Start Event.
     */
    PropertyI64 eventExposureStartFrameID;
    /// \brief Returns the unique identifier of the ExposureEnd type of Event.
    /**
     *  Returns the unique identifier of the ExposureEnd type of Event. This feature can be used to register a callback function to be notified of the event occurrence. Its value uniquely identifies the type of event that will be received.
     */
    PropertyI64 eventExposureEnd;
    /// \brief Returns the Timestamp of the ExposureEnd Event.
    /**
     *  Returns the Timestamp of the ExposureEnd Event. It can be used to determine precisely when the event occurred.
     */
    PropertyI64 eventExposureEndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the ExposureEnd Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the ExposureEnd Event.
     */
    PropertyI64 eventExposureEndFrameID;
    /// \brief Returns the unique Identifier of the Counter 0 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 0 Start type of Event.
     */
    PropertyI64 eventCounter0Start;
    /// \brief Returns the Timestamp of the Counter 0 Start Event.
    /**
     *  Returns the Timestamp of the Counter 0 Start Event.
     */
    PropertyI64 eventCounter0StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 0 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 0 Start Event.
     */
    PropertyI64 eventCounter0StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 1 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 1 Start type of Event.
     */
    PropertyI64 eventCounter1Start;
    /// \brief Returns the Timestamp of the Counter 1 Start Event.
    /**
     *  Returns the Timestamp of the Counter 1 Start Event.
     */
    PropertyI64 eventCounter1StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 1 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 1 Start Event.
     */
    PropertyI64 eventCounter1StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 2 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 2 Start type of Event.
     */
    PropertyI64 eventCounter2Start;
    /// \brief Returns the Timestamp of the Counter 2 Start Event.
    /**
     *  Returns the Timestamp of the Counter 2 Start Event.
     */
    PropertyI64 eventCounter2StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 2 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 2 Start Event.
     */
    PropertyI64 eventCounter2StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 3 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 3 Start type of Event.
     */
    PropertyI64 eventCounter3Start;
    /// \brief Returns the Timestamp of the Counter 3 Start Event.
    /**
     *  Returns the Timestamp of the Counter 3 Start Event.
     */
    PropertyI64 eventCounter3StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 3 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 3 Start Event.
     */
    PropertyI64 eventCounter3StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 4 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 4 Start type of Event.
     */
    PropertyI64 eventCounter4Start;
    /// \brief Returns the Timestamp of the Counter 4 Start Event.
    /**
     *  Returns the Timestamp of the Counter 4 Start Event.
     */
    PropertyI64 eventCounter4StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 4 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 4 Start Event.
     */
    PropertyI64 eventCounter4StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 5 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 5 Start type of Event.
     */
    PropertyI64 eventCounter5Start;
    /// \brief Returns the Timestamp of the Counter 5 Start Event.
    /**
     *  Returns the Timestamp of the Counter 5 Start Event.
     */
    PropertyI64 eventCounter5StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 5 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 5 Start Event.
     */
    PropertyI64 eventCounter5StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 6 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 6 Start type of Event.
     */
    PropertyI64 eventCounter6Start;
    /// \brief Returns the Timestamp of the Counter 6 Start Event.
    /**
     *  Returns the Timestamp of the Counter 6 Start Event.
     */
    PropertyI64 eventCounter6StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 6 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 6 Start Event.
     */
    PropertyI64 eventCounter6StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 7 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 7 Start type of Event.
     */
    PropertyI64 eventCounter7Start;
    /// \brief Returns the Timestamp of the Counter 7 Start Event.
    /**
     *  Returns the Timestamp of the Counter 7 Start Event.
     */
    PropertyI64 eventCounter7StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 7 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 7 Start Event.
     */
    PropertyI64 eventCounter7StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 8 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 8 Start type of Event.
     */
    PropertyI64 eventCounter8Start;
    /// \brief Returns the Timestamp of the Counter 8 Start Event.
    /**
     *  Returns the Timestamp of the Counter 8 Start Event.
     */
    PropertyI64 eventCounter8StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 8 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 8 Start Event.
     */
    PropertyI64 eventCounter8StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 9 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 9 Start type of Event.
     */
    PropertyI64 eventCounter9Start;
    /// \brief Returns the Timestamp of the Counter 9 Start Event.
    /**
     *  Returns the Timestamp of the Counter 9 Start Event.
     */
    PropertyI64 eventCounter9StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 9 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 9 Start Event.
     */
    PropertyI64 eventCounter9StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 10 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 10 Start type of Event.
     */
    PropertyI64 eventCounter10Start;
    /// \brief Returns the Timestamp of the Counter 10 Start Event.
    /**
     *  Returns the Timestamp of the Counter 10 Start Event.
     */
    PropertyI64 eventCounter10StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 10 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 10 Start Event.
     */
    PropertyI64 eventCounter10StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 11 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 11 Start type of Event.
     */
    PropertyI64 eventCounter11Start;
    /// \brief Returns the Timestamp of the Counter 11 Start Event.
    /**
     *  Returns the Timestamp of the Counter 11 Start Event.
     */
    PropertyI64 eventCounter11StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 11 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 11 Start Event.
     */
    PropertyI64 eventCounter11StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 12 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 12 Start type of Event.
     */
    PropertyI64 eventCounter12Start;
    /// \brief Returns the Timestamp of the Counter 12 Start Event.
    /**
     *  Returns the Timestamp of the Counter 12 Start Event.
     */
    PropertyI64 eventCounter12StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 12 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 12 Start Event.
     */
    PropertyI64 eventCounter12StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 13 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 13 Start type of Event.
     */
    PropertyI64 eventCounter13Start;
    /// \brief Returns the Timestamp of the Counter 13 Start Event.
    /**
     *  Returns the Timestamp of the Counter 13 Start Event.
     */
    PropertyI64 eventCounter13StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 13 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 13 Start Event.
     */
    PropertyI64 eventCounter13StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 14 Start type of Event.
    /**
     *  Returns the unique Identifier of the Counter 14 Start type of Event.
     */
    PropertyI64 eventCounter14Start;
    /// \brief Returns the Timestamp of the Counter 14 Start Event.
    /**
     *  Returns the Timestamp of the Counter 14 Start Event.
     */
    PropertyI64 eventCounter14StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 14 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 14 Start Event.
     */
    PropertyI64 eventCounter14StartFrameID;
    /// \brief Returns the unique Identifier of the Counter 0 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 0 End type of Event.
     */
    PropertyI64 eventCounter0End;
    /// \brief Returns the Timestamp of the Counter 0 End Event.
    /**
     *  Returns the Timestamp of the Counter 0 End Event.
     */
    PropertyI64 eventCounter0EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 0 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 0 End Event.
     */
    PropertyI64 eventCounter0EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 1 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 1 End type of Event.
     */
    PropertyI64 eventCounter1End;
    /// \brief Returns the Timestamp of the Counter 1 End Event.
    /**
     *  Returns the Timestamp of the Counter 1 End Event.
     */
    PropertyI64 eventCounter1EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 1 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 1 End Event.
     */
    PropertyI64 eventCounter1EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 2 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 2 End type of Event.
     */
    PropertyI64 eventCounter2End;
    /// \brief Returns the Timestamp of the Counter 2 End Event.
    /**
     *  Returns the Timestamp of the Counter 2 End Event.
     */
    PropertyI64 eventCounter2EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 2 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 2 End Event.
     */
    PropertyI64 eventCounter2EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 3 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 3 End type of Event.
     */
    PropertyI64 eventCounter3End;
    /// \brief Returns the Timestamp of the Counter 3 End Event.
    /**
     *  Returns the Timestamp of the Counter 3 End Event.
     */
    PropertyI64 eventCounter3EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 3 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 3 End Event.
     */
    PropertyI64 eventCounter3EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 4 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 4 End type of Event.
     */
    PropertyI64 eventCounter4End;
    /// \brief Returns the Timestamp of the Counter 4 End Event.
    /**
     *  Returns the Timestamp of the Counter 4 End Event.
     */
    PropertyI64 eventCounter4EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 4 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 4 End Event.
     */
    PropertyI64 eventCounter4EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 5 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 5 End type of Event.
     */
    PropertyI64 eventCounter5End;
    /// \brief Returns the Timestamp of the Counter 5 End Event.
    /**
     *  Returns the Timestamp of the Counter 5 End Event.
     */
    PropertyI64 eventCounter5EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 5 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 5 End Event.
     */
    PropertyI64 eventCounter5EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 6 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 6 End type of Event.
     */
    PropertyI64 eventCounter6End;
    /// \brief Returns the Timestamp of the Counter 6 End Event.
    /**
     *  Returns the Timestamp of the Counter 6 End Event.
     */
    PropertyI64 eventCounter6EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 6 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 6 End Event.
     */
    PropertyI64 eventCounter6EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 7 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 7 End type of Event.
     */
    PropertyI64 eventCounter7End;
    /// \brief Returns the Timestamp of the Counter 7 End Event.
    /**
     *  Returns the Timestamp of the Counter 7 End Event.
     */
    PropertyI64 eventCounter7EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 7 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 7 End Event.
     */
    PropertyI64 eventCounter7EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 8 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 8 End type of Event.
     */
    PropertyI64 eventCounter8End;
    /// \brief Returns the Timestamp of the Counter 8 End Event.
    /**
     *  Returns the Timestamp of the Counter 8 End Event.
     */
    PropertyI64 eventCounter8EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 8 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 8 End Event.
     */
    PropertyI64 eventCounter8EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 9 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 9 End type of Event.
     */
    PropertyI64 eventCounter9End;
    /// \brief Returns the Timestamp of the Counter 9 End Event.
    /**
     *  Returns the Timestamp of the Counter 9 End Event.
     */
    PropertyI64 eventCounter9EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 9 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 9 End Event.
     */
    PropertyI64 eventCounter9EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 10 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 10 End type of Event.
     */
    PropertyI64 eventCounter10End;
    /// \brief Returns the Timestamp of the Counter 10 End Event.
    /**
     *  Returns the Timestamp of the Counter 10 End Event.
     */
    PropertyI64 eventCounter10EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 10 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 10 End Event.
     */
    PropertyI64 eventCounter10EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 11 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 11 End type of Event.
     */
    PropertyI64 eventCounter11End;
    /// \brief Returns the Timestamp of the Counter 11 End Event.
    /**
     *  Returns the Timestamp of the Counter 11 End Event.
     */
    PropertyI64 eventCounter11EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 11 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 11 End Event.
     */
    PropertyI64 eventCounter11EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 12 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 12 End type of Event.
     */
    PropertyI64 eventCounter12End;
    /// \brief Returns the Timestamp of the Counter 12 End Event.
    /**
     *  Returns the Timestamp of the Counter 12 End Event.
     */
    PropertyI64 eventCounter12EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 12 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 12 End Event.
     */
    PropertyI64 eventCounter12EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 13 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 13 End type of Event.
     */
    PropertyI64 eventCounter13End;
    /// \brief Returns the Timestamp of the Counter 13 End Event.
    /**
     *  Returns the Timestamp of the Counter 13 End Event.
     */
    PropertyI64 eventCounter13EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 13 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 13 End Event.
     */
    PropertyI64 eventCounter13EndFrameID;
    /// \brief Returns the unique Identifier of the Counter 14 End type of Event.
    /**
     *  Returns the unique Identifier of the Counter 14 End type of Event.
     */
    PropertyI64 eventCounter14End;
    /// \brief Returns the Timestamp of the Counter 14 End Event.
    /**
     *  Returns the Timestamp of the Counter 14 End Event.
     */
    PropertyI64 eventCounter14EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Counter 14 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Counter 14 End Event.
     */
    PropertyI64 eventCounter14EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 0 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 0 Start type of Event.
     */
    PropertyI64 eventTimer0Start;
    /// \brief Returns the Timestamp of the Timer 0 Start Event.
    /**
     *  Returns the Timestamp of the Timer 0 Start Event.
     */
    PropertyI64 eventTimer0StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 0 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 0 Start Event.
     */
    PropertyI64 eventTimer0StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 1 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 1 Start type of Event.
     */
    PropertyI64 eventTimer1Start;
    /// \brief Returns the Timestamp of the Timer 1 Start Event.
    /**
     *  Returns the Timestamp of the Timer 1 Start Event.
     */
    PropertyI64 eventTimer1StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 1 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 1 Start Event.
     */
    PropertyI64 eventTimer1StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 2 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 2 Start type of Event.
     */
    PropertyI64 eventTimer2Start;
    /// \brief Returns the Timestamp of the Timer 2 Start Event.
    /**
     *  Returns the Timestamp of the Timer 2 Start Event.
     */
    PropertyI64 eventTimer2StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 2 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 2 Start Event.
     */
    PropertyI64 eventTimer2StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 3 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 3 Start type of Event.
     */
    PropertyI64 eventTimer3Start;
    /// \brief Returns the Timestamp of the Timer 3 Start Event.
    /**
     *  Returns the Timestamp of the Timer 3 Start Event.
     */
    PropertyI64 eventTimer3StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 3 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 3 Start Event.
     */
    PropertyI64 eventTimer3StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 4 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 4 Start type of Event.
     */
    PropertyI64 eventTimer4Start;
    /// \brief Returns the Timestamp of the Timer 4 Start Event.
    /**
     *  Returns the Timestamp of the Timer 4 Start Event.
     */
    PropertyI64 eventTimer4StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 4 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 4 Start Event.
     */
    PropertyI64 eventTimer4StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 5 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 5 Start type of Event.
     */
    PropertyI64 eventTimer5Start;
    /// \brief Returns the Timestamp of the Timer 5 Start Event.
    /**
     *  Returns the Timestamp of the Timer 5 Start Event.
     */
    PropertyI64 eventTimer5StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 5 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 5 Start Event.
     */
    PropertyI64 eventTimer5StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 6 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 6 Start type of Event.
     */
    PropertyI64 eventTimer6Start;
    /// \brief Returns the Timestamp of the Timer 6 Start Event.
    /**
     *  Returns the Timestamp of the Timer 6 Start Event.
     */
    PropertyI64 eventTimer6StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 6 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 6 Start Event.
     */
    PropertyI64 eventTimer6StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 7 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 7 Start type of Event.
     */
    PropertyI64 eventTimer7Start;
    /// \brief Returns the Timestamp of the Timer 7 Start Event.
    /**
     *  Returns the Timestamp of the Timer 7 Start Event.
     */
    PropertyI64 eventTimer7StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 7 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 7 Start Event.
     */
    PropertyI64 eventTimer7StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 8 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 8 Start type of Event.
     */
    PropertyI64 eventTimer8Start;
    /// \brief Returns the Timestamp of the Timer 8 Start Event.
    /**
     *  Returns the Timestamp of the Timer 8 Start Event.
     */
    PropertyI64 eventTimer8StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 8 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 8 Start Event.
     */
    PropertyI64 eventTimer8StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 9 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 9 Start type of Event.
     */
    PropertyI64 eventTimer9Start;
    /// \brief Returns the Timestamp of the Timer 9 Start Event.
    /**
     *  Returns the Timestamp of the Timer 9 Start Event.
     */
    PropertyI64 eventTimer9StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 9 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 9 Start Event.
     */
    PropertyI64 eventTimer9StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 10 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 10 Start type of Event.
     */
    PropertyI64 eventTimer10Start;
    /// \brief Returns the Timestamp of the Timer 10 Start Event.
    /**
     *  Returns the Timestamp of the Timer 10 Start Event.
     */
    PropertyI64 eventTimer10StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 10 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 10 Start Event.
     */
    PropertyI64 eventTimer10StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 11 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 11 Start type of Event.
     */
    PropertyI64 eventTimer11Start;
    /// \brief Returns the Timestamp of the Timer 11 Start Event.
    /**
     *  Returns the Timestamp of the Timer 11 Start Event.
     */
    PropertyI64 eventTimer11StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 11 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 11 Start Event.
     */
    PropertyI64 eventTimer11StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 12 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 12 Start type of Event.
     */
    PropertyI64 eventTimer12Start;
    /// \brief Returns the Timestamp of the Timer 12 Start Event.
    /**
     *  Returns the Timestamp of the Timer 12 Start Event.
     */
    PropertyI64 eventTimer12StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 12 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 12 Start Event.
     */
    PropertyI64 eventTimer12StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 13 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 13 Start type of Event.
     */
    PropertyI64 eventTimer13Start;
    /// \brief Returns the Timestamp of the Timer 13 Start Event.
    /**
     *  Returns the Timestamp of the Timer 13 Start Event.
     */
    PropertyI64 eventTimer13StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 13 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 13 Start Event.
     */
    PropertyI64 eventTimer13StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 14 Start type of Event.
    /**
     *  Returns the unique Identifier of the Timer 14 Start type of Event.
     */
    PropertyI64 eventTimer14Start;
    /// \brief Returns the Timestamp of the Timer 14 Start Event.
    /**
     *  Returns the Timestamp of the Timer 14 Start Event.
     */
    PropertyI64 eventTimer14StartTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 14 Start Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 14 Start Event.
     */
    PropertyI64 eventTimer14StartFrameID;
    /// \brief Returns the unique Identifier of the Timer 0 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 0 End type of Event.
     */
    PropertyI64 eventTimer0End;
    /// \brief Returns the Timestamp of the Timer 0 End Event.
    /**
     *  Returns the Timestamp of the Timer 0 End Event.
     */
    PropertyI64 eventTimer0EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 0 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 0 End Event.
     */
    PropertyI64 eventTimer0EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 1 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 1 End type of Event.
     */
    PropertyI64 eventTimer1End;
    /// \brief Returns the Timestamp of the Timer 1 End Event.
    /**
     *  Returns the Timestamp of the Timer 1 End Event.
     */
    PropertyI64 eventTimer1EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 1 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 1 End Event.
     */
    PropertyI64 eventTimer1EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 2 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 2 End type of Event.
     */
    PropertyI64 eventTimer2End;
    /// \brief Returns the Timestamp of the Timer 2 End Event.
    /**
     *  Returns the Timestamp of the Timer 2 End Event.
     */
    PropertyI64 eventTimer2EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 2 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 2 End Event.
     */
    PropertyI64 eventTimer2EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 3 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 3 End type of Event.
     */
    PropertyI64 eventTimer3End;
    /// \brief Returns the Timestamp of the Timer 3 End Event.
    /**
     *  Returns the Timestamp of the Timer 3 End Event.
     */
    PropertyI64 eventTimer3EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 3 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 3 End Event.
     */
    PropertyI64 eventTimer3EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 4 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 4 End type of Event.
     */
    PropertyI64 eventTimer4End;
    /// \brief Returns the Timestamp of the Timer 4 End Event.
    /**
     *  Returns the Timestamp of the Timer 4 End Event.
     */
    PropertyI64 eventTimer4EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 4 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 4 End Event.
     */
    PropertyI64 eventTimer4EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 5 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 5 End type of Event.
     */
    PropertyI64 eventTimer5End;
    /// \brief Returns the Timestamp of the Timer 5 End Event.
    /**
     *  Returns the Timestamp of the Timer 5 End Event.
     */
    PropertyI64 eventTimer5EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 5 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 5 End Event.
     */
    PropertyI64 eventTimer5EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 6 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 6 End type of Event.
     */
    PropertyI64 eventTimer6End;
    /// \brief Returns the Timestamp of the Timer 6 End Event.
    /**
     *  Returns the Timestamp of the Timer 6 End Event.
     */
    PropertyI64 eventTimer6EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 6 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 6 End Event.
     */
    PropertyI64 eventTimer6EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 7 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 7 End type of Event.
     */
    PropertyI64 eventTimer7End;
    /// \brief Returns the Timestamp of the Timer 7 End Event.
    /**
     *  Returns the Timestamp of the Timer 7 End Event.
     */
    PropertyI64 eventTimer7EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 7 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 7 End Event.
     */
    PropertyI64 eventTimer7EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 8 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 8 End type of Event.
     */
    PropertyI64 eventTimer8End;
    /// \brief Returns the Timestamp of the Timer 8 End Event.
    /**
     *  Returns the Timestamp of the Timer 8 End Event.
     */
    PropertyI64 eventTimer8EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 8 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 8 End Event.
     */
    PropertyI64 eventTimer8EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 9 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 9 End type of Event.
     */
    PropertyI64 eventTimer9End;
    /// \brief Returns the Timestamp of the Timer 9 End Event.
    /**
     *  Returns the Timestamp of the Timer 9 End Event.
     */
    PropertyI64 eventTimer9EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 9 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 9 End Event.
     */
    PropertyI64 eventTimer9EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 10 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 10 End type of Event.
     */
    PropertyI64 eventTimer10End;
    /// \brief Returns the Timestamp of the Timer 10 End Event.
    /**
     *  Returns the Timestamp of the Timer 10 End Event.
     */
    PropertyI64 eventTimer10EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 10 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 10 End Event.
     */
    PropertyI64 eventTimer10EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 11 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 11 End type of Event.
     */
    PropertyI64 eventTimer11End;
    /// \brief Returns the Timestamp of the Timer 11 End Event.
    /**
     *  Returns the Timestamp of the Timer 11 End Event.
     */
    PropertyI64 eventTimer11EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 11 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 11 End Event.
     */
    PropertyI64 eventTimer11EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 12 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 12 End type of Event.
     */
    PropertyI64 eventTimer12End;
    /// \brief Returns the Timestamp of the Timer 12 End Event.
    /**
     *  Returns the Timestamp of the Timer 12 End Event.
     */
    PropertyI64 eventTimer12EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 12 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 12 End Event.
     */
    PropertyI64 eventTimer12EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 13 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 13 End type of Event.
     */
    PropertyI64 eventTimer13End;
    /// \brief Returns the Timestamp of the Timer 13 End Event.
    /**
     *  Returns the Timestamp of the Timer 13 End Event.
     */
    PropertyI64 eventTimer13EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 13 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 13 End Event.
     */
    PropertyI64 eventTimer13EndFrameID;
    /// \brief Returns the unique Identifier of the Timer 14 End type of Event.
    /**
     *  Returns the unique Identifier of the Timer 14 End type of Event.
     */
    PropertyI64 eventTimer14End;
    /// \brief Returns the Timestamp of the Timer 14 End Event.
    /**
     *  Returns the Timestamp of the Timer 14 End Event.
     */
    PropertyI64 eventTimer14EndTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Timer 14 End Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Timer 14 End Event.
     */
    PropertyI64 eventTimer14EndFrameID;
    /// \brief Returns the unique Identifier of the Line 0 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 0 Rising Edge type of Event.
     */
    PropertyI64 eventLine0RisingEdge;
    /// \brief Returns the Timestamp of the Line 0 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 0 Rising Edge Event.
     */
    PropertyI64 eventLine0RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 0 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 0 Rising Edge Event.
     */
    PropertyI64 eventLine0RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 1 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 1 Rising Edge type of Event.
     */
    PropertyI64 eventLine1RisingEdge;
    /// \brief Returns the Timestamp of the Line 1 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 1 Rising Edge Event.
     */
    PropertyI64 eventLine1RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 1 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 1 Rising Edge Event.
     */
    PropertyI64 eventLine1RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 2 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 2 Rising Edge type of Event.
     */
    PropertyI64 eventLine2RisingEdge;
    /// \brief Returns the Timestamp of the Line 2 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 2 Rising Edge Event.
     */
    PropertyI64 eventLine2RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 2 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 2 Rising Edge Event.
     */
    PropertyI64 eventLine2RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 3 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 3 Rising Edge type of Event.
     */
    PropertyI64 eventLine3RisingEdge;
    /// \brief Returns the Timestamp of the Line 3 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 3 Rising Edge Event.
     */
    PropertyI64 eventLine3RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 3 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 3 Rising Edge Event.
     */
    PropertyI64 eventLine3RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 4 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 4 Rising Edge type of Event.
     */
    PropertyI64 eventLine4RisingEdge;
    /// \brief Returns the Timestamp of the Line 4 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 4 Rising Edge Event.
     */
    PropertyI64 eventLine4RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 4 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 4 Rising Edge Event.
     */
    PropertyI64 eventLine4RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 5 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 5 Rising Edge type of Event.
     */
    PropertyI64 eventLine5RisingEdge;
    /// \brief Returns the Timestamp of the Line 5 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 5 Rising Edge Event.
     */
    PropertyI64 eventLine5RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 5 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 5 Rising Edge Event.
     */
    PropertyI64 eventLine5RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 6 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 6 Rising Edge type of Event.
     */
    PropertyI64 eventLine6RisingEdge;
    /// \brief Returns the Timestamp of the Line 6 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 6 Rising Edge Event.
     */
    PropertyI64 eventLine6RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 6 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 6 Rising Edge Event.
     */
    PropertyI64 eventLine6RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 7 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 7 Rising Edge type of Event.
     */
    PropertyI64 eventLine7RisingEdge;
    /// \brief Returns the Timestamp of the Line 7 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 7 Rising Edge Event.
     */
    PropertyI64 eventLine7RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 7 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 7 Rising Edge Event.
     */
    PropertyI64 eventLine7RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 8 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 8 Rising Edge type of Event.
     */
    PropertyI64 eventLine8RisingEdge;
    /// \brief Returns the Timestamp of the Line 8 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 8 Rising Edge Event.
     */
    PropertyI64 eventLine8RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 8 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 8 Rising Edge Event.
     */
    PropertyI64 eventLine8RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 9 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 9 Rising Edge type of Event.
     */
    PropertyI64 eventLine9RisingEdge;
    /// \brief Returns the Timestamp of the Line 9 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 9 Rising Edge Event.
     */
    PropertyI64 eventLine9RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 9 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 9 Rising Edge Event.
     */
    PropertyI64 eventLine9RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 10 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 10 Rising Edge type of Event.
     */
    PropertyI64 eventLine10RisingEdge;
    /// \brief Returns the Timestamp of the Line 10 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 10 Rising Edge Event.
     */
    PropertyI64 eventLine10RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 10 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 10 Rising Edge Event.
     */
    PropertyI64 eventLine10RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 11 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 11 Rising Edge type of Event.
     */
    PropertyI64 eventLine11RisingEdge;
    /// \brief Returns the Timestamp of the Line 11 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 11 Rising Edge Event.
     */
    PropertyI64 eventLine11RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 11 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 11 Rising Edge Event.
     */
    PropertyI64 eventLine11RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 12 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 12 Rising Edge type of Event.
     */
    PropertyI64 eventLine12RisingEdge;
    /// \brief Returns the Timestamp of the Line 12 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 12 Rising Edge Event.
     */
    PropertyI64 eventLine12RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 12 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 12 Rising Edge Event.
     */
    PropertyI64 eventLine12RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 13 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 13 Rising Edge type of Event.
     */
    PropertyI64 eventLine13RisingEdge;
    /// \brief Returns the Timestamp of the Line 13 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 13 Rising Edge Event.
     */
    PropertyI64 eventLine13RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 13 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 13 Rising Edge Event.
     */
    PropertyI64 eventLine13RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 14 Rising Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 14 Rising Edge type of Event.
     */
    PropertyI64 eventLine14RisingEdge;
    /// \brief Returns the Timestamp of the Line 14 Rising Edge Event.
    /**
     *  Returns the Timestamp of the Line 14 Rising Edge Event.
     */
    PropertyI64 eventLine14RisingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 14 Rising Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 14 Rising Edge Event.
     */
    PropertyI64 eventLine14RisingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 0 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 0 Falling Edge type of Event.
     */
    PropertyI64 eventLine0FallingEdge;
    /// \brief Returns the Timestamp of the Line 0 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 0 Falling Edge Event.
     */
    PropertyI64 eventLine0FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 0 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 0 Falling Edge Event.
     */
    PropertyI64 eventLine0FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 1 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 1 Falling Edge type of Event.
     */
    PropertyI64 eventLine1FallingEdge;
    /// \brief Returns the Timestamp of the Line 1 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 1 Falling Edge Event.
     */
    PropertyI64 eventLine1FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 1 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 1 Falling Edge Event.
     */
    PropertyI64 eventLine1FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 2 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 2 Falling Edge type of Event.
     */
    PropertyI64 eventLine2FallingEdge;
    /// \brief Returns the Timestamp of the Line 2 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 2 Falling Edge Event.
     */
    PropertyI64 eventLine2FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 2 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 2 Falling Edge Event.
     */
    PropertyI64 eventLine2FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 3 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 3 Falling Edge type of Event.
     */
    PropertyI64 eventLine3FallingEdge;
    /// \brief Returns the Timestamp of the Line 3 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 3 Falling Edge Event.
     */
    PropertyI64 eventLine3FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 3 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 3 Falling Edge Event.
     */
    PropertyI64 eventLine3FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 4 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 4 Falling Edge type of Event.
     */
    PropertyI64 eventLine4FallingEdge;
    /// \brief Returns the Timestamp of the Line 4 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 4 Falling Edge Event.
     */
    PropertyI64 eventLine4FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 4 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 4 Falling Edge Event.
     */
    PropertyI64 eventLine4FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 5 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 5 Falling Edge type of Event.
     */
    PropertyI64 eventLine5FallingEdge;
    /// \brief Returns the Timestamp of the Line 5 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 5 Falling Edge Event.
     */
    PropertyI64 eventLine5FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 5 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 5 Falling Edge Event.
     */
    PropertyI64 eventLine5FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 6 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 6 Falling Edge type of Event.
     */
    PropertyI64 eventLine6FallingEdge;
    /// \brief Returns the Timestamp of the Line 6 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 6 Falling Edge Event.
     */
    PropertyI64 eventLine6FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 6 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 6 Falling Edge Event.
     */
    PropertyI64 eventLine6FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 7 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 7 Falling Edge type of Event.
     */
    PropertyI64 eventLine7FallingEdge;
    /// \brief Returns the Timestamp of the Line 7 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 7 Falling Edge Event.
     */
    PropertyI64 eventLine7FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 7 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 7 Falling Edge Event.
     */
    PropertyI64 eventLine7FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 8 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 8 Falling Edge type of Event.
     */
    PropertyI64 eventLine8FallingEdge;
    /// \brief Returns the Timestamp of the Line 8 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 8 Falling Edge Event.
     */
    PropertyI64 eventLine8FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 8 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 8 Falling Edge Event.
     */
    PropertyI64 eventLine8FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 9 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 9 Falling Edge type of Event.
     */
    PropertyI64 eventLine9FallingEdge;
    /// \brief Returns the Timestamp of the Line 9 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 9 Falling Edge Event.
     */
    PropertyI64 eventLine9FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 9 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 9 Falling Edge Event.
     */
    PropertyI64 eventLine9FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 10 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 10 Falling Edge type of Event.
     */
    PropertyI64 eventLine10FallingEdge;
    /// \brief Returns the Timestamp of the Line 10 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 10 Falling Edge Event.
     */
    PropertyI64 eventLine10FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 10 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 10 Falling Edge Event.
     */
    PropertyI64 eventLine10FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 11 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 11 Falling Edge type of Event.
     */
    PropertyI64 eventLine11FallingEdge;
    /// \brief Returns the Timestamp of the Line 11 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 11 Falling Edge Event.
     */
    PropertyI64 eventLine11FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 11 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 11 Falling Edge Event.
     */
    PropertyI64 eventLine11FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 12 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 12 Falling Edge type of Event.
     */
    PropertyI64 eventLine12FallingEdge;
    /// \brief Returns the Timestamp of the Line 12 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 12 Falling Edge Event.
     */
    PropertyI64 eventLine12FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 12 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 12 Falling Edge Event.
     */
    PropertyI64 eventLine12FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 13 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 13 Falling Edge type of Event.
     */
    PropertyI64 eventLine13FallingEdge;
    /// \brief Returns the Timestamp of the Line 13 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 13 Falling Edge Event.
     */
    PropertyI64 eventLine13FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 13 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 13 Falling Edge Event.
     */
    PropertyI64 eventLine13FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 14 Falling Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 14 Falling Edge type of Event.
     */
    PropertyI64 eventLine14FallingEdge;
    /// \brief Returns the Timestamp of the Line 14 Falling Edge Event.
    /**
     *  Returns the Timestamp of the Line 14 Falling Edge Event.
     */
    PropertyI64 eventLine14FallingEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 14 Falling Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 14 Falling Edge Event.
     */
    PropertyI64 eventLine14FallingEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 0 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 0 Any Edge type of Event.
     */
    PropertyI64 eventLine0AnyEdge;
    /// \brief Returns the Timestamp of the Line 0 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 0 Any Edge Event.
     */
    PropertyI64 eventLine0AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 0 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 0 Any Edge Event.
     */
    PropertyI64 eventLine0AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 1 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 1 Any Edge type of Event.
     */
    PropertyI64 eventLine1AnyEdge;
    /// \brief Returns the Timestamp of the Line 1 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 1 Any Edge Event.
     */
    PropertyI64 eventLine1AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 1 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 1 Any Edge Event.
     */
    PropertyI64 eventLine1AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 2 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 2 Any Edge type of Event.
     */
    PropertyI64 eventLine2AnyEdge;
    /// \brief Returns the Timestamp of the Line 2 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 2 Any Edge Event.
     */
    PropertyI64 eventLine2AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 2 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 2 Any Edge Event.
     */
    PropertyI64 eventLine2AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 3 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 3 Any Edge type of Event.
     */
    PropertyI64 eventLine3AnyEdge;
    /// \brief Returns the Timestamp of the Line 3 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 3 Any Edge Event.
     */
    PropertyI64 eventLine3AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 3 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 3 Any Edge Event.
     */
    PropertyI64 eventLine3AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 4 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 4 Any Edge type of Event.
     */
    PropertyI64 eventLine4AnyEdge;
    /// \brief Returns the Timestamp of the Line 4 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 4 Any Edge Event.
     */
    PropertyI64 eventLine4AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 4 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 4 Any Edge Event.
     */
    PropertyI64 eventLine4AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 5 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 5 Any Edge type of Event.
     */
    PropertyI64 eventLine5AnyEdge;
    /// \brief Returns the Timestamp of the Line 5 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 5 Any Edge Event.
     */
    PropertyI64 eventLine5AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 5 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 5 Any Edge Event.
     */
    PropertyI64 eventLine5AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 6 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 6 Any Edge type of Event.
     */
    PropertyI64 eventLine6AnyEdge;
    /// \brief Returns the Timestamp of the Line 6 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 6 Any Edge Event.
     */
    PropertyI64 eventLine6AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 6 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 6 Any Edge Event.
     */
    PropertyI64 eventLine6AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 7 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 7 Any Edge type of Event.
     */
    PropertyI64 eventLine7AnyEdge;
    /// \brief Returns the Timestamp of the Line 7 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 7 Any Edge Event.
     */
    PropertyI64 eventLine7AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 7 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 7 Any Edge Event.
     */
    PropertyI64 eventLine7AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 8 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 8 Any Edge type of Event.
     */
    PropertyI64 eventLine8AnyEdge;
    /// \brief Returns the Timestamp of the Line 8 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 8 Any Edge Event.
     */
    PropertyI64 eventLine8AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 8 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 8 Any Edge Event.
     */
    PropertyI64 eventLine8AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 9 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 9 Any Edge type of Event.
     */
    PropertyI64 eventLine9AnyEdge;
    /// \brief Returns the Timestamp of the Line 9 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 9 Any Edge Event.
     */
    PropertyI64 eventLine9AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 9 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 9 Any Edge Event.
     */
    PropertyI64 eventLine9AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 10 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 10 Any Edge type of Event.
     */
    PropertyI64 eventLine10AnyEdge;
    /// \brief Returns the Timestamp of the Line 10 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 10 Any Edge Event.
     */
    PropertyI64 eventLine10AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 10 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 10 Any Edge Event.
     */
    PropertyI64 eventLine10AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 11 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 11 Any Edge type of Event.
     */
    PropertyI64 eventLine11AnyEdge;
    /// \brief Returns the Timestamp of the Line 11 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 11 Any Edge Event.
     */
    PropertyI64 eventLine11AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 11 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 11 Any Edge Event.
     */
    PropertyI64 eventLine11AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 12 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 12 Any Edge type of Event.
     */
    PropertyI64 eventLine12AnyEdge;
    /// \brief Returns the Timestamp of the Line 12 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 12 Any Edge Event.
     */
    PropertyI64 eventLine12AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 12 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 12 Any Edge Event.
     */
    PropertyI64 eventLine12AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 13 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 13 Any Edge type of Event.
     */
    PropertyI64 eventLine13AnyEdge;
    /// \brief Returns the Timestamp of the Line 13 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 13 Any Edge Event.
     */
    PropertyI64 eventLine13AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 13 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 13 Any Edge Event.
     */
    PropertyI64 eventLine13AnyEdgeFrameID;
    /// \brief Returns the unique Identifier of the Line 14 Any Edge type of Event.
    /**
     *  Returns the unique Identifier of the Line 14 Any Edge type of Event.
     */
    PropertyI64 eventLine14AnyEdge;
    /// \brief Returns the Timestamp of the Line 14 Any Edge Event.
    /**
     *  Returns the Timestamp of the Line 14 Any Edge Event.
     */
    PropertyI64 eventLine14AnyEdgeTimestamp;
    /// \brief Returns the unique Identifier of the Frame (or image) that generated the Line 14 Any Edge Event.
    /**
     *  Returns the unique Identifier of the Frame (or image) that generated the Line 14 Any Edge Event.
     */
    PropertyI64 eventLine14AnyEdgeFrameID;
    /// \brief Returns the unique identifier of the Error type of Event.
    /**
     *  Returns the unique identifier of the Error type of Event. It can be used to register a callback function to be notified of the Error event occurrence. Its value uniquely identifies that the event received was an Error.
     */
    PropertyI64 eventError;
    /// \brief Returns the Timestamp of the Error Event.
    /**
     *  Returns the Timestamp of the Error Event. It can be used to determine when the event occurred.
     */
    PropertyI64 eventErrorTimestamp;
    /// \brief If applicable, returns the unique Identifier of the Frame (or image) that generated the Error Event.
    /**
     *  If applicable, returns the unique Identifier of the Frame (or image) that generated the Error Event.
     */
    PropertyI64 eventErrorFrameID;
    /// \brief Returns an error code for the error(s) that happened.
    /**
     *  Returns an error code for the error(s) that happened.
     */
    PropertyI64 eventErrorCode;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the User Set control features.
/**
 *  A category that contains the User Set control features.
 */
class UserSetControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::UserSetControl</b> object.
    explicit UserSetControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        userSetSelector(),
        userSetLoad(),
        userSetSave(),
        userSetDefault(),
        userSetDefaultSelector(),
        userSetFeatureSelector(),
        userSetFeatureEnable(),
        mvUserData()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( userSetSelector, "UserSetSelector" );
        locator.bindComponent( userSetLoad, "UserSetLoad@i" );
        locator.bindComponent( userSetSave, "UserSetSave@i" );
        locator.bindComponent( userSetDefault, "UserSetDefault" );
        locator.bindComponent( userSetDefaultSelector, "UserSetDefaultSelector" );
        locator.bindComponent( userSetFeatureSelector, "UserSetFeatureSelector" );
        locator.bindComponent( userSetFeatureEnable, "UserSetFeatureEnable" );
        locator.bindComponent( mvUserData, "mvUserData" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects the feature User Set to load, save or configure.
    /**
     *  Selects the feature User Set to load, save or configure.
     */
    PropertyI64 userSetSelector;
    /// \brief Loads the User Set specified by UserSetSelector to the device and makes it active.
    /**
     *  Loads the User Set specified by UserSetSelector to the device and makes it active.
     */
    Method userSetLoad;
    /// \brief Save the User Set specified by UserSetSelector to the non-volatile memory of the device.
    /**
     *  Save the User Set specified by UserSetSelector to the non-volatile memory of the device.
     */
    Method userSetSave;
    /// \brief Selects the feature User Set to load and make active by default when the device is reset.
    /**
     *  Selects the feature User Set to load and make active by default when the device is reset.
     */
    PropertyI64 userSetDefault;
    /// \brief This feature is deprecated (See UserSetDefault).
    /**
     *  \deprecated
     *  This feature is deprecated (See UserSetDefault). Selects the feature User Set to load and make active when the device is reset.
     */
    PropertyI64 userSetDefaultSelector;
    /// \brief Selects which individual UserSet feature to control.
    /**
     *  Selects which individual UserSet feature to control.
     */
    PropertyI64 userSetFeatureSelector;
    /// \brief Enables the selected feature and make it active in all the UserSets.
    /**
     *  Enables the selected feature and make it active in all the UserSets.
     */
    PropertyIBoolean userSetFeatureEnable;
    /// \brief A register to store arbitrary user data into the devices non-volatile memory.
    /**
     *  A register to store arbitrary user data into the devices non-volatile memory
     */
    PropertyS mvUserData;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category for the Sequencer Control features.
/**
 *  A category for the Sequencer Control features.
 */
class SequencerControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::SequencerControl</b> object.
    explicit SequencerControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        sequencerMode(),
        sequencerConfigurationMode(),
        sequencerFeatureSelector(),
        sequencerFeatureEnable(),
        sequencerSetSelector(),
        sequencerSetSave(),
        sequencerSetLoad(),
        sequencerSetActive(),
        sequencerSetStart(),
        sequencerPathSelector(),
        sequencerSetNext(),
        sequencerTriggerSource(),
        sequencerTriggerActivation()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( sequencerMode, "SequencerMode" );
        locator.bindComponent( sequencerConfigurationMode, "SequencerConfigurationMode" );
        locator.bindComponent( sequencerFeatureSelector, "SequencerFeatureSelector" );
        locator.bindComponent( sequencerFeatureEnable, "SequencerFeatureEnable" );
        locator.bindComponent( sequencerSetSelector, "SequencerSetSelector" );
        locator.bindComponent( sequencerSetSave, "SequencerSetSave@i" );
        locator.bindComponent( sequencerSetLoad, "SequencerSetLoad@i" );
        locator.bindComponent( sequencerSetActive, "SequencerSetActive" );
        locator.bindComponent( sequencerSetStart, "SequencerSetStart" );
        locator.bindComponent( sequencerPathSelector, "SequencerPathSelector" );
        locator.bindComponent( sequencerSetNext, "SequencerSetNext" );
        locator.bindComponent( sequencerTriggerSource, "SequencerTriggerSource" );
        locator.bindComponent( sequencerTriggerActivation, "SequencerTriggerActivation" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Controls if the sequencer mechanism is active.
    /**
     *  Controls if the sequencer mechanism is active.
     */
    PropertyI64 sequencerMode;
    /// \brief Controls if the sequencer configuration mode is active.
    /**
     *  Controls if the sequencer configuration mode is active.
     */
    PropertyI64 sequencerConfigurationMode;
    /// \brief Selects which sequencer features to control.
    /**
     *  Selects which sequencer features to control.
     */
    PropertyI64 sequencerFeatureSelector;
    /// \brief Enables the selected feature and make it active in all the sequencer sets.
    /**
     *  Enables the selected feature and make it active in all the sequencer sets.
     */
    PropertyIBoolean sequencerFeatureEnable;
    /// \brief Selects the sequencer set to which further feature settings applies.
    /**
     *  Selects the sequencer set to which further feature settings applies.
     */
    PropertyI64 sequencerSetSelector;
    /// \brief Saves the current device state to the sequencer set selected by the SequencerSetSelector.
    /**
     *  Saves the current device state to the sequencer set selected by the SequencerSetSelector.
     */
    Method sequencerSetSave;
    /// \brief Loads the sequencer set selected by SequencerSetSelector in the device.
    /**
     *  Loads the sequencer set selected by SequencerSetSelector in the device. Even if SequencerMode is off, this will change the device state to the configuration of the selected set.
     */
    Method sequencerSetLoad;
    /// \brief Contains the currently active sequencer set.
    /**
     *  Contains the currently active sequencer set.
     */
    PropertyI64 sequencerSetActive;
    /// \brief Sets the initial/start sequencer set, which is the first set used within a sequencer.
    /**
     *  Sets the initial/start sequencer set, which is the first set used within a sequencer.
     */
    PropertyI64 sequencerSetStart;
    /// \brief Selects to which branching path further path settings applies.
    /**
     *  Selects to which branching path further path settings applies.
     */
    PropertyI64 sequencerPathSelector;
    /// \brief Specifies the next sequencer set.
    /**
     *  Specifies the next sequencer set.
     */
    PropertyI64 sequencerSetNext;
    /// \brief Specifies the internal signal or physical input line to use as the sequencer trigger source.
    /**
     *  Specifies the internal signal or physical input line to use as the sequencer trigger source.
     */
    PropertyI64 sequencerTriggerSource;
    /// \brief Specifies the activation mode of the sequencer trigger.
    /**
     *  Specifies the activation mode of the sequencer trigger.
     */
    PropertyI64 sequencerTriggerActivation;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the File Access control features.
/**
 *  A category that contains the File Access control features.
 */
class FileAccessControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::FileAccessControl</b> object.
    explicit FileAccessControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        fileSelector(),
        fileOperationSelector(),
        fileOperationExecute(),
        fileOpenMode(),
        fileAccessBuffer(),
        fileAccessOffset(),
        fileAccessLength(),
        fileOperationStatus(),
        fileOperationResult(),
        fileSize()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( fileSelector, "FileSelector" );
        locator.bindComponent( fileOperationSelector, "FileOperationSelector" );
        locator.bindComponent( fileOperationExecute, "FileOperationExecute@i" );
        locator.bindComponent( fileOpenMode, "FileOpenMode" );
        locator.bindComponent( fileAccessBuffer, "FileAccessBuffer" );
        locator.bindComponent( fileAccessOffset, "FileAccessOffset" );
        locator.bindComponent( fileAccessLength, "FileAccessLength" );
        locator.bindComponent( fileOperationStatus, "FileOperationStatus" );
        locator.bindComponent( fileOperationResult, "FileOperationResult" );
        locator.bindComponent( fileSize, "FileSize" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects the target file in the device.
    /**
     *  Selects the target file in the device.
     */
    PropertyI64 fileSelector;
    /// \brief Selects the target operation for the selected file in the device.
    /**
     *  Selects the target operation for the selected file in the device. This Operation is executed when the FileOperationExecute feature is called.
     */
    PropertyI64 fileOperationSelector;
    /// \brief Executes the operation selected by FileOperationSelector on the selected file.
    /**
     *  Executes the operation selected by FileOperationSelector on the selected file.
     */
    Method fileOperationExecute;
    /// \brief Selects the access mode in which a file is opened in the device.
    /**
     *  Selects the access mode in which a file is opened in the device.
     */
    PropertyI64 fileOpenMode;
    /// \brief Defines the intermediate access buffer that allows the exchange of data between the device file storage and the application.
    /**
     *  Defines the intermediate access buffer that allows the exchange of data between the device file storage and the application.
     */
    PropertyS fileAccessBuffer;
    /// \brief Controls the Offset of the mapping between the device file storage and the FileAccessBuffer.
    /**
     *  Controls the Offset of the mapping between the device file storage and the FileAccessBuffer.
     */
    PropertyI64 fileAccessOffset;
    /// \brief Controls the Length of the mapping between the device file storage and the FileAccessBuffer.
    /**
     *  Controls the Length of the mapping between the device file storage and the FileAccessBuffer.
     */
    PropertyI64 fileAccessLength;
    /// \brief Represents the file operation execution status.
    /**
     *  Represents the file operation execution status.
     */
    PropertyI64 fileOperationStatus;
    /// \brief Represents the file operation result.
    /**
     *  Represents the file operation result. For Read or Write operations, the number of successfully read/written bytes is returned.
     */
    PropertyI64 fileOperationResult;
    /// \brief Represents the size of the selected file in bytes.
    /**
     *  Represents the size of the selected file in bytes.
     */
    PropertyI64 fileSize;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the source control features.
/**
 *  A category that contains the source control features.
 */
class SourceControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::SourceControl</b> object.
    explicit SourceControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        sourceCount(),
        sourceSelector()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( sourceCount, "SourceCount" );
        locator.bindComponent( sourceSelector, "SourceSelector" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Controls or returns the number of sources supported by the device.
    /**
     *  Controls or returns the number of sources supported by the device.
     */
    PropertyI64 sourceCount;
    /// \brief Selects the source to control.
    /**
     *  Selects the source to control.
     */
    PropertyI64 sourceSelector;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category for the data Transfer Control features.
/**
 *  A category for the data Transfer Control features.
 */
class TransferControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::TransferControl</b> object.
    explicit TransferControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        transferSelector(),
        transferControlMode(),
        transferOperationMode(),
        transferBlockCount(),
        transferBurstCount(),
        transferQueueMaxBlockCount(),
        transferQueueCurrentBlockCount(),
        transferQueueMode(),
        transferStart(),
        transferStop(),
        transferAbort(),
        transferPause(),
        transferResume(),
        transferTriggerSelector(),
        transferTriggerMode(),
        transferTriggerSource(),
        transferTriggerActivation(),
        transferStatusSelector(),
        transferStatus(),
        transferComponentSelector(),
        transferStreamChannel()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( transferSelector, "TransferSelector" );
        locator.bindComponent( transferControlMode, "TransferControlMode" );
        locator.bindComponent( transferOperationMode, "TransferOperationMode" );
        locator.bindComponent( transferBlockCount, "TransferBlockCount" );
        locator.bindComponent( transferBurstCount, "TransferBurstCount" );
        locator.bindComponent( transferQueueMaxBlockCount, "TransferQueueMaxBlockCount" );
        locator.bindComponent( transferQueueCurrentBlockCount, "TransferQueueCurrentBlockCount" );
        locator.bindComponent( transferQueueMode, "TransferQueueMode" );
        locator.bindComponent( transferStart, "TransferStart@i" );
        locator.bindComponent( transferStop, "TransferStop@i" );
        locator.bindComponent( transferAbort, "TransferAbort@i" );
        locator.bindComponent( transferPause, "TransferPause@i" );
        locator.bindComponent( transferResume, "TransferResume@i" );
        locator.bindComponent( transferTriggerSelector, "TransferTriggerSelector" );
        locator.bindComponent( transferTriggerMode, "TransferTriggerMode" );
        locator.bindComponent( transferTriggerSource, "TransferTriggerSource" );
        locator.bindComponent( transferTriggerActivation, "TransferTriggerActivation" );
        locator.bindComponent( transferStatusSelector, "TransferStatusSelector" );
        locator.bindComponent( transferStatus, "TransferStatus" );
        locator.bindComponent( transferComponentSelector, "TransferComponentSelector" );
        locator.bindComponent( transferStreamChannel, "TransferStreamChannel" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects which stream transfers are currently controlled by the selected Transfer features.
    /**
     *  Selects which stream transfers are currently controlled by the selected Transfer features.
     */
    PropertyI64 transferSelector;
    /// \brief Selects the control method for the transfers.
    /**
     *  Selects the control method for the transfers.
     */
    PropertyI64 transferControlMode;
    /// \brief Selects the operation mode of the transfer.
    /**
     *  Selects the operation mode of the transfer.
     */
    PropertyI64 transferOperationMode;
    /// \brief Specifies the number of data Blocks that the device should stream before stopping.
    /**
     *  Specifies the number of data Blocks that the device should stream before stopping. This feature is only active if the TransferOperationMode is set to MultiBlock.
     */
    PropertyI64 transferBlockCount;
    /// \brief Number of Block(s) to transfer for each TransferBurstStart trigger.
    /**
     *  Number of Block(s) to transfer for each TransferBurstStart trigger.
     */
    PropertyI64 transferBurstCount;
    /// \brief Controls the maximum number of data blocks that can be stored in the block queue of the selected stream.
    /**
     *  Controls the maximum number of data blocks that can be stored in the block queue of the selected stream.
     */
    PropertyI64 transferQueueMaxBlockCount;
    /// \brief Returns the number of Block(s) currently in the transfer queue.
    /**
     *  Returns the number of Block(s) currently in the transfer queue.
     */
    PropertyI64 transferQueueCurrentBlockCount;
    /// \brief Specifies the operation mode of the transfer queue.
    /**
     *  Specifies the operation mode of the transfer queue.
     */
    PropertyI64 transferQueueMode;
    /// \brief Starts the streaming of data blocks out of the device.
    /**
     *  Starts the streaming of data blocks out of the device. This feature must be available when the TransferControlMode is set to 'UserControled'. If the TransferStart feature is not writable (locked), the application should not start the transfer and should avoid using the feature until it becomes writable again.
     */
    Method transferStart;
    /// \brief Stops the streaming of data Block(s).
    /**
     *  Stops the streaming of data Block(s). The current block transmission will be completed. This feature must be available when the TransferControlMode is set to 'UserControlled'.
     */
    Method transferStop;
    /// \brief Aborts immediately the streaming of data block(s).
    /**
     *  Aborts immediately the streaming of data block(s). Aborting the transfer will result in the lost of the data that is present or currently entering in the block queue. However, the next new block received will be stored in the queue and transferred to the host when the streaming is restarted. If implemented, this feature should be available when the TransferControlMode is set to 'UserControlled'.
     */
    Method transferAbort;
    /// \brief Pauses the streaming of data Block(s).
    /**
     *  Pauses the streaming of data Block(s). Pausing the streaming will immediately suspend the ongoing data transfer even if a block is partially transfered. The device will resume its transmission at the reception of a TransferResume command.
     */
    Method transferPause;
    /// \brief Resumes a data Blocks streaming that was previously paused by a TransferPause command.
    /**
     *  Resumes a data Blocks streaming that was previously paused by a TransferPause command.
     */
    Method transferResume;
    /// \brief Selects the type of transfer trigger to configure.
    /**
     *  Selects the type of transfer trigger to configure.
     */
    PropertyI64 transferTriggerSelector;
    /// \brief Controls if the selected trigger is active.
    /**
     *  Controls if the selected trigger is active.
     */
    PropertyI64 transferTriggerMode;
    /// \brief Specifies the signal to use as the trigger source for transfers.
    /**
     *  Specifies the signal to use as the trigger source for transfers.
     */
    PropertyI64 transferTriggerSource;
    /// \brief Specifies the activation mode of the transfer control trigger.
    /**
     *  Specifies the activation mode of the transfer control trigger.
     */
    PropertyI64 transferTriggerActivation;
    /// \brief Selects which status of the transfer module to read.
    /**
     *  Selects which status of the transfer module to read.
     */
    PropertyI64 transferStatusSelector;
    /// \brief Reads the status of the Transfer module signal selected by TransferStatusSelector.
    /**
     *  Reads the status of the Transfer module signal selected by TransferStatusSelector.
     */
    PropertyIBoolean transferStatus;
    /// \brief Selects the color component for the control of the TransferStreamChannel feature.
    /**
     *  Selects the color component for the control of the TransferStreamChannel feature.
     */
    PropertyI64 transferComponentSelector;
    /// \brief Selects the streaming channel that will be used to transfer the selected stream of data.
    /**
     *  Selects the streaming channel that will be used to transfer the selected stream of data. In general, this feature can be omitted and the default streaming channel will be used.
     */
    PropertyI64 transferStreamChannel;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category for control of 3D camera specific features.
/**
 *  A category for control of 3D camera specific features.
 */
class Scan3dControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::Scan3dControl</b> object.
    explicit Scan3dControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        scan3dDistanceUnit(),
        scan3dCoordinateSystem(),
        scan3dOutputMode(),
        scan3dCoordinateSystemReference(),
        scan3dCoordinateSelector(),
        scan3dCoordinateScale(),
        scan3dCoordinateOffset(),
        scan3dInvalidDataFlag(),
        scan3dInvalidDataValue(),
        scan3dAxisMin(),
        scan3dAxisMax(),
        scan3dCoordinateTransformSelector(),
        scan3dTransformValue(),
        scan3dCoordinateReferenceSelector(),
        scan3dCoordinateReferenceValue()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( scan3dDistanceUnit, "Scan3dDistanceUnit" );
        locator.bindComponent( scan3dCoordinateSystem, "Scan3dCoordinateSystem" );
        locator.bindComponent( scan3dOutputMode, "Scan3dOutputMode" );
        locator.bindComponent( scan3dCoordinateSystemReference, "Scan3dCoordinateSystemReference" );
        locator.bindComponent( scan3dCoordinateSelector, "Scan3dCoordinateSelector" );
        locator.bindComponent( scan3dCoordinateScale, "Scan3dCoordinateScale" );
        locator.bindComponent( scan3dCoordinateOffset, "Scan3dCoordinateOffset" );
        locator.bindComponent( scan3dInvalidDataFlag, "Scan3dInvalidDataFlag" );
        locator.bindComponent( scan3dInvalidDataValue, "Scan3dInvalidDataValue" );
        locator.bindComponent( scan3dAxisMin, "Scan3dAxisMin" );
        locator.bindComponent( scan3dAxisMax, "Scan3dAxisMax" );
        locator.bindComponent( scan3dCoordinateTransformSelector, "Scan3dCoordinateTransformSelector" );
        locator.bindComponent( scan3dTransformValue, "Scan3dTransformValue" );
        locator.bindComponent( scan3dCoordinateReferenceSelector, "Scan3dCoordinateReferenceSelector" );
        locator.bindComponent( scan3dCoordinateReferenceValue, "Scan3dCoordinateReferenceValue" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Specifies the unit used when delivering calibrated distance data.
    /**
     *  Specifies the unit used when delivering calibrated distance data.
     */
    PropertyI64 scan3dDistanceUnit;
    /// \brief Specifies the Coordinate system to use for the device.
    /**
     *  Specifies the Coordinate system to use for the device.
     */
    PropertyI64 scan3dCoordinateSystem;
    /// \brief Controls the Calibration and data organization of the device, naming the coordinates transmitted.
    /**
     *  Controls the Calibration and data organization of the device, naming the coordinates transmitted.
     */
    PropertyI64 scan3dOutputMode;
    /// \brief Defines coordinate system reference location.
    /**
     *  Defines coordinate system reference location.
     */
    PropertyI64 scan3dCoordinateSystemReference;
    /// \brief Selects the individual coordinates in the vectors for 3D information/transformation.
    /**
     *  Selects the individual coordinates in the vectors for 3D information/transformation.
     */
    PropertyI64 scan3dCoordinateSelector;
    /// \brief Scale factor when transforming a pixel from relative coordinates to world coordinates.
    /**
     *  Scale factor when transforming a pixel from relative coordinates to world coordinates.
     */
    PropertyF scan3dCoordinateScale;
    /// \brief Offset when transforming a pixel from relative coordinates to world coordinates.
    /**
     *  Offset when transforming a pixel from relative coordinates to world coordinates.
     */
    PropertyF scan3dCoordinateOffset;
    /// \brief Enables the definition of a non-valid flag value in the data stream.
    /**
     *  Enables the definition of a non-valid flag value in the data stream. Note that the confidence output is an alternate recommended way to identify non-valid pixels. Using an Scan3dInvalidDataValue may give processing penalties due to special handling.
     */
    PropertyIBoolean scan3dInvalidDataFlag;
    /// \brief Value which identifies a non-valid pixel if Scan3dInvalidDataFlag is enabled.
    /**
     *  Value which identifies a non-valid pixel if Scan3dInvalidDataFlag is enabled.
     */
    PropertyF scan3dInvalidDataValue;
    /// \brief Minimum valid transmitted coordinate value of the selected Axis.
    /**
     *  Minimum valid transmitted coordinate value of the selected Axis.
     */
    PropertyF scan3dAxisMin;
    /// \brief Maximum valid transmitted coordinate value of the selected Axis.
    /**
     *  Maximum valid transmitted coordinate value of the selected Axis.
     */
    PropertyF scan3dAxisMax;
    /// \brief Sets the index to read/write a coordinate transform value.
    /**
     *  Sets the index to read/write a coordinate transform value.
     */
    PropertyI64 scan3dCoordinateTransformSelector;
    /// \brief Specifies the transform value selected.
    /**
     *  Specifies the transform value selected. For translations (Scan3dCoordinateTransformSelector = TranslationX/Y/Z) it is expressed in the distance unit of the system, for rotations (Scan3dCoordinateTransformSelector =RotationX/Y/Z) in degrees.
     */
    PropertyF scan3dTransformValue;
    /// \brief Sets the index to read a coordinate system reference value defining the transform of a point from the current (Anchor or Transformed) system to the reference system.
    /**
     *  Sets the index to read a coordinate system reference value defining the transform of a point from the current (Anchor or Transformed) system to the reference system.
     */
    PropertyI64 scan3dCoordinateReferenceSelector;
    /// \brief Returns the reference value selected.
    /**
     *  Returns the reference value selected. Reads the value of a rotation or translation value for the current (Anchor or Transformed) coordinate system transformation to the Reference system.
     */
    PropertyF scan3dCoordinateReferenceValue;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the Chunk Data control features.
/**
 *  A category that contains the Chunk Data control features.
 */
class ChunkDataControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::ChunkDataControl</b> object.
    explicit ChunkDataControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        chunkModeActive(),
        chunkSelector(),
        chunkEnable(),
        chunkPartSelector(),
        chunkImageComponent(),
        chunkImage(),
        chunkOffsetX(),
        chunkOffsetY(),
        chunkWidth(),
        chunkHeight(),
        chunkPixelFormat(),
        chunkPixelDynamicRangeMin(),
        chunkPixelDynamicRangeMax(),
        chunkTimestamp(),
        chunkTimestampLatchValue(),
        chunkLineStatusAll(),
        chunkCounterSelector(),
        chunkCounterValue(),
        chunkTimerSelector(),
        chunkEncoderSelector(),
        chunkScanLineSelector(),
        chunkEncoderValue(),
        chunkEncoderStatus(),
        chunkExposureTimeSelector(),
        chunkTimerValue(),
        chunkExposureTime(),
        chunkGainSelector(),
        chunkGain(),
        chunkBlackLevelSelector(),
        chunkBlackLevel(),
        chunkLinePitch(),
        chunkFrameID(),
        chunkSourceID(),
        chunkRegionID(),
        chunkTransferBlockID(),
        chunkTransferStreamID(),
        chunkTransferQueueCurrentBlockCount(),
        chunkStreamChannelID(),
        chunkSequencerSetActive(),
        chunkScan3dDistanceUnit(),
        chunkScan3dOutputMode(),
        chunkScan3dCoordinateSystem(),
        chunkScan3dCoordinateSystemReference(),
        chunkScan3dCoordinateSelector(),
        chunkScan3dCoordinateScale(),
        chunkScan3dCoordinateOffset(),
        chunkScan3dInvalidDataFlag(),
        chunkScan3dInvalidDataValue(),
        chunkScan3dAxisMin(),
        chunkScan3dAxisMax(),
        chunkScan3dCoordinateTransformSelector(),
        chunkScan3dTransformValue(),
        chunkScan3dCoordinateReferenceSelector(),
        chunkScan3dCoordinateReferenceValue()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( chunkModeActive, "ChunkModeActive" );
        locator.bindComponent( chunkSelector, "ChunkSelector" );
        locator.bindComponent( chunkEnable, "ChunkEnable" );
        locator.bindComponent( chunkPartSelector, "ChunkPartSelector" );
        locator.bindComponent( chunkImageComponent, "ChunkImageComponent" );
        locator.bindComponent( chunkImage, "ChunkImage" );
        locator.bindComponent( chunkOffsetX, "ChunkOffsetX" );
        locator.bindComponent( chunkOffsetY, "ChunkOffsetY" );
        locator.bindComponent( chunkWidth, "ChunkWidth" );
        locator.bindComponent( chunkHeight, "ChunkHeight" );
        locator.bindComponent( chunkPixelFormat, "ChunkPixelFormat" );
        locator.bindComponent( chunkPixelDynamicRangeMin, "ChunkPixelDynamicRangeMin" );
        if( !chunkPixelDynamicRangeMin.isValid() )
        {
            locator.bindComponent( chunkPixelDynamicRangeMin, "ChunkDynamicRangeMin" );
        }
        locator.bindComponent( chunkPixelDynamicRangeMax, "ChunkPixelDynamicRangeMax" );
        if( !chunkPixelDynamicRangeMax.isValid() )
        {
            locator.bindComponent( chunkPixelDynamicRangeMax, "ChunkDynamicRangeMax" );
        }
        locator.bindComponent( chunkTimestamp, "ChunkTimestamp" );
        locator.bindComponent( chunkTimestampLatchValue, "ChunkTimestampLatchValue" );
        locator.bindComponent( chunkLineStatusAll, "ChunkLineStatusAll" );
        locator.bindComponent( chunkCounterSelector, "ChunkCounterSelector" );
        locator.bindComponent( chunkCounterValue, "ChunkCounterValue" );
        if( !chunkCounterValue.isValid() )
        {
            locator.bindComponent( chunkCounterValue, "ChunkCounter" );
        }
        locator.bindComponent( chunkTimerSelector, "ChunkTimerSelector" );
        locator.bindComponent( chunkEncoderSelector, "ChunkEncoderSelector" );
        locator.bindComponent( chunkScanLineSelector, "ChunkScanLineSelector" );
        locator.bindComponent( chunkEncoderValue, "ChunkEncoderValue" );
        locator.bindComponent( chunkEncoderStatus, "ChunkEncoderStatus" );
        locator.bindComponent( chunkExposureTimeSelector, "ChunkExposureTimeSelector" );
        locator.bindComponent( chunkTimerValue, "ChunkTimerValue" );
        if( !chunkTimerValue.isValid() )
        {
            locator.bindComponent( chunkTimerValue, "ChunkTimer" );
        }
        locator.bindComponent( chunkExposureTime, "ChunkExposureTime" );
        locator.bindComponent( chunkGainSelector, "ChunkGainSelector" );
        locator.bindComponent( chunkGain, "ChunkGain" );
        locator.bindComponent( chunkBlackLevelSelector, "ChunkBlackLevelSelector" );
        locator.bindComponent( chunkBlackLevel, "ChunkBlackLevel" );
        locator.bindComponent( chunkLinePitch, "ChunkLinePitch" );
        locator.bindComponent( chunkFrameID, "ChunkFrameID" );
        locator.bindComponent( chunkSourceID, "ChunkSourceID" );
        locator.bindComponent( chunkRegionID, "ChunkRegionID" );
        locator.bindComponent( chunkTransferBlockID, "ChunkTransferBlockID" );
        locator.bindComponent( chunkTransferStreamID, "ChunkTransferStreamID" );
        locator.bindComponent( chunkTransferQueueCurrentBlockCount, "ChunkTransferQueueCurrentBlockCount" );
        locator.bindComponent( chunkStreamChannelID, "ChunkStreamChannelID" );
        locator.bindComponent( chunkSequencerSetActive, "ChunkSequencerSetActive" );
        locator.bindComponent( chunkScan3dDistanceUnit, "ChunkScan3dDistanceUnit" );
        locator.bindComponent( chunkScan3dOutputMode, "ChunkScan3dOutputMode" );
        locator.bindComponent( chunkScan3dCoordinateSystem, "ChunkScan3dCoordinateSystem" );
        locator.bindComponent( chunkScan3dCoordinateSystemReference, "ChunkScan3dCoordinateSystemReference" );
        locator.bindComponent( chunkScan3dCoordinateSelector, "ChunkScan3dCoordinateSelector" );
        locator.bindComponent( chunkScan3dCoordinateScale, "ChunkScan3dCoordinateScale" );
        locator.bindComponent( chunkScan3dCoordinateOffset, "ChunkScan3dCoordinateOffset" );
        locator.bindComponent( chunkScan3dInvalidDataFlag, "ChunkScan3dInvalidDataFlag" );
        locator.bindComponent( chunkScan3dInvalidDataValue, "ChunkScan3dInvalidDataValue" );
        locator.bindComponent( chunkScan3dAxisMin, "ChunkScan3dAxisMin" );
        locator.bindComponent( chunkScan3dAxisMax, "ChunkScan3dAxisMax" );
        locator.bindComponent( chunkScan3dCoordinateTransformSelector, "ChunkScan3dCoordinateTransformSelector" );
        locator.bindComponent( chunkScan3dTransformValue, "ChunkScan3dTransformValue" );
        locator.bindComponent( chunkScan3dCoordinateReferenceSelector, "ChunkScan3dCoordinateReferenceSelector" );
        locator.bindComponent( chunkScan3dCoordinateReferenceValue, "ChunkScan3dCoordinateReferenceValue" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Activates the inclusion of Chunk data in the payload of the image.
    /**
     *  Activates the inclusion of Chunk data in the payload of the image.
     */
    PropertyIBoolean chunkModeActive;
    /// \brief Selects which Chunk to enable or control.
    /**
     *  Selects which Chunk to enable or control.
     */
    PropertyI64 chunkSelector;
    /// \brief Enables the inclusion of the selected Chunk data in the payload of the image.
    /**
     *  Enables the inclusion of the selected Chunk data in the payload of the image.
     */
    PropertyIBoolean chunkEnable;
    /// \brief Selects the part to access in chunk data in a multipart transmission.
    /**
     *  Selects the part to access in chunk data in a multipart transmission.
     */
    PropertyI64 chunkPartSelector;
    /// \brief Returns the component of the payload image.
    /**
     *  Returns the component of the payload image. This can be used to identify the image component of a generic part in a multipart transfer.
     */
    PropertyI64 chunkImageComponent;
    /// \brief Returns the entire image data included in the payload.
    /**
     *  Returns the entire image data included in the payload.
     */
    PropertyS chunkImage;
    /// \brief Returns the OffsetX of the image included in the payload.
    /**
     *  Returns the OffsetX of the image included in the payload.
     */
    PropertyI64 chunkOffsetX;
    /// \brief Returns the OffsetY of the image included in the payload.
    /**
     *  Returns the OffsetY of the image included in the payload.
     */
    PropertyI64 chunkOffsetY;
    /// \brief Returns the Width of the image included in the payload.
    /**
     *  Returns the Width of the image included in the payload.
     */
    PropertyI64 chunkWidth;
    /// \brief Returns the Height of the image included in the payload.
    /**
     *  Returns the Height of the image included in the payload.
     */
    PropertyI64 chunkHeight;
    /// \brief Returns the PixelFormat of the image included in the payload.
    /**
     *  Returns the PixelFormat of the image included in the payload.
     */
    PropertyI64 chunkPixelFormat;
    /// \brief Returns the minimum value of dynamic range of the image included in the payload.
    /**
     *  Returns the minimum value of dynamic range of the image included in the payload.
     */
    PropertyI64 chunkPixelDynamicRangeMin;
    /// \brief Returns the maximum value of dynamic range of the image included in the payload.
    /**
     *  Returns the maximum value of dynamic range of the image included in the payload.
     */
    PropertyI64 chunkPixelDynamicRangeMax;
    /// \brief Returns the Timestamp of the image included in the payload at the time of the FrameStart internal event.
    /**
     *  Returns the Timestamp of the image included in the payload at the time of the FrameStart internal event.
     */
    PropertyI64 chunkTimestamp;
    /// \brief Returns the last Timestamp latched with the TimestampLatch command.
    /**
     *  Returns the last Timestamp latched with the TimestampLatch command.
     */
    PropertyI64 chunkTimestampLatchValue;
    /// \brief Returns the status of all the I/O lines at the time of the FrameStart internal event.
    /**
     *  Returns the status of all the I/O lines at the time of the FrameStart internal event.
     */
    PropertyI64 chunkLineStatusAll;
    /// \brief Selects which counter to retrieve data from.
    /**
     *  Selects which counter to retrieve data from.
     */
    PropertyI64 chunkCounterSelector;
    /// \brief Returns the value of the selected Chunk counter at the time of the FrameStart event.
    /**
     *  Returns the value of the selected Chunk counter at the time of the FrameStart event.
     */
    PropertyI64 chunkCounterValue;
    /// \brief Selects which Timer to retrieve data from.
    /**
     *  Selects which Timer to retrieve data from.
     */
    PropertyI64 chunkTimerSelector;
    /// \brief Selects which Encoder to retrieve data from.
    /**
     *  Selects which Encoder to retrieve data from.
     */
    PropertyI64 chunkEncoderSelector;
    /// \brief Index for vector representation of one chunk value per line in an image.
    /**
     *  Index for vector representation of one chunk value per line in an image.
     */
    PropertyI64 chunkScanLineSelector;
    /// \brief Returns the counter's value of the selected Encoder at the time of the FrameStart in area scan mode or the counter's value at the time of the LineStart selected by ChunkScanLineSelector in LineScan mode.
    /**
     *  Returns the counter's value of the selected Encoder at the time of the FrameStart in area scan mode or the counter's value at the time of the LineStart selected by ChunkScanLineSelector in LineScan mode.
     */
    PropertyI64 chunkEncoderValue;
    /// \brief Returns the motion status of the selected encoder.
    /**
     *  Returns the motion status of the selected encoder.
     */
    PropertyI64 chunkEncoderStatus;
    /// \brief Selects which exposure time is read by the ChunkExposureTime feature.
    /**
     *  Selects which exposure time is read by the ChunkExposureTime feature.
     */
    PropertyI64 chunkExposureTimeSelector;
    /// \brief Returns the value of the selected Timer at the time of the FrameStart internal event.
    /**
     *  Returns the value of the selected Timer at the time of the FrameStart internal event.
     */
    PropertyF chunkTimerValue;
    /// \brief Returns the exposure time used to capture the image.
    /**
     *  Returns the exposure time used to capture the image.
     */
    PropertyF chunkExposureTime;
    /// \brief Selects which Gain to return.
    /**
     *  Selects which Gain to return.
     */
    PropertyI64 chunkGainSelector;
    /// \brief Returns the gain used to capture the image.
    /**
     *  Returns the gain used to capture the image.
     */
    PropertyF chunkGain;
    /// \brief Selects which Black Level to return.
    /**
     *  Selects which Black Level to return. Possible values are:
     */
    PropertyI64 chunkBlackLevelSelector;
    /// \brief Returns the black level used to capture the image included in the payload.
    /**
     *  Returns the black level used to capture the image included in the payload.
     */
    PropertyF chunkBlackLevel;
    /// \brief Returns the LinePitch of the image included in the payload.
    /**
     *  Returns the LinePitch of the image included in the payload.
     */
    PropertyI64 chunkLinePitch;
    /// \brief Returns the unique Identifier of the frame (or image) included in the payload.
    /**
     *  Returns the unique Identifier of the frame (or image) included in the payload.
     */
    PropertyI64 chunkFrameID;
    /// \brief Returns the identifier of Source that the image comes from.
    /**
     *  Returns the identifier of Source that the image comes from.
     */
    PropertyI64 chunkSourceID;
    /// \brief Returns the identifier of Region that the image comes from.
    /**
     *  Returns the identifier of Region that the image comes from.
     */
    PropertyI64 chunkRegionID;
    /// \brief Returns the unique identifier of the transfer block used to transport the payload.
    /**
     *  Returns the unique identifier of the transfer block used to transport the payload.
     */
    PropertyI64 chunkTransferBlockID;
    /// \brief Returns identifier of the stream that generated this block.
    /**
     *  Returns identifier of the stream that generated this block.
     */
    PropertyI64 chunkTransferStreamID;
    /// \brief Returns the current number of blocks in the transfer queue.
    /**
     *  Returns the current number of blocks in the transfer queue.
     */
    PropertyI64 chunkTransferQueueCurrentBlockCount;
    /// \brief Returns identifier of the stream channel used to carry the block.
    /**
     *  Returns identifier of the stream channel used to carry the block.
     */
    PropertyI64 chunkStreamChannelID;
    /// \brief Return the index of the active set of the running sequencer included in the payload.
    /**
     *  Return the index of the active set of the running sequencer included in the payload.
     */
    PropertyI64 chunkSequencerSetActive;
    /// \brief Returns the Distance Unit of the payload image.
    /**
     *  Returns the Distance Unit of the payload image.
     */
    PropertyI64 chunkScan3dDistanceUnit;
    /// \brief Returns the Calibrated Mode of the payload image.
    /**
     *  Returns the Calibrated Mode of the payload image.
     */
    PropertyI64 chunkScan3dOutputMode;
    /// \brief Returns the Coordinate System of the image included in the payload.
    /**
     *  Returns the Coordinate System of the image included in the payload.
     */
    PropertyI64 chunkScan3dCoordinateSystem;
    /// \brief Returns the Coordinate System Position of the image included in the payload.
    /**
     *  Returns the Coordinate System Position of the image included in the payload.
     */
    PropertyI64 chunkScan3dCoordinateSystemReference;
    /// \brief Selects which Coordinate to retrieve data from.
    /**
     *  Selects which Coordinate to retrieve data from.
     */
    PropertyI64 chunkScan3dCoordinateSelector;
    /// \brief Returns the Scale for the selected coordinate axis of the image included in the payload.
    /**
     *  Returns the Scale for the selected coordinate axis of the image included in the payload.
     */
    PropertyF chunkScan3dCoordinateScale;
    /// \brief Returns the Offset for the selected coordinate axis of the image included in the payload.
    /**
     *  Returns the Offset for the selected coordinate axis of the image included in the payload.
     */
    PropertyF chunkScan3dCoordinateOffset;
    /// \brief Returns if a specific non-valid data flag is used in the data stream.
    /**
     *  Returns if a specific non-valid data flag is used in the data stream.
     */
    PropertyIBoolean chunkScan3dInvalidDataFlag;
    /// \brief Returns the Invalid Data Value used for the image included in the payload.
    /**
     *  Returns the Invalid Data Value used for the image included in the payload.
     */
    PropertyF chunkScan3dInvalidDataValue;
    /// \brief Returns the Minimum Axis value for the selected coordinate axis of the image included in the payload.
    /**
     *  Returns the Minimum Axis value for the selected coordinate axis of the image included in the payload.
     */
    PropertyF chunkScan3dAxisMin;
    /// \brief Returns the Maximum Axis value for the selected coordinate axis of the image included in the payload.
    /**
     *  Returns the Maximum Axis value for the selected coordinate axis of the image included in the payload.
     */
    PropertyF chunkScan3dAxisMax;
    /// \brief Selector for transform values.
    /**
     *  Selector for transform values.
     */
    PropertyI64 chunkScan3dCoordinateTransformSelector;
    /// \brief Returns the transform value.
    /**
     *  Returns the transform value.
     */
    PropertyF chunkScan3dTransformValue;
    /// \brief Selector to read a coordinate system reference value defining the transform of a point from one system to the other.
    /**
     *  Selector to read a coordinate system reference value defining the transform of a point from one system to the other.
     */
    PropertyI64 chunkScan3dCoordinateReferenceSelector;
    /// \brief Reads the value of a position or pose coordinate for the anchor or transformed coordinate systems relative to the reference point.
    /**
     *  Reads the value of a position or pose coordinate for the anchor or transformed coordinate systems relative to the reference point.
     */
    PropertyF chunkScan3dCoordinateReferenceValue;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category for Test Control features.
/**
 *  A category for Test Control features.
 */
class TestControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::TestControl</b> object.
    explicit TestControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        testPendingAck(),
        testEventGenerate()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( testPendingAck, "TestPendingAck" );
        locator.bindComponent( testEventGenerate, "TestEventGenerate@i" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Tests the device's pending acknowledge feature.
    /**
     *  Tests the device's pending acknowledge feature. When this feature is written, the device waits a time period corresponding to the value of TestPendingAck before acknowledging the write.
     */
    PropertyI64 testPendingAck;
    /// \brief Generates a Test Event.
    /**
     *  Generates a Test Event.
     */
    Method testEventGenerate;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains the transport Layer control features.
/**
 *  A category that contains the transport Layer control features.
 */
class TransportLayerControl
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::TransportLayerControl</b> object.
    explicit TransportLayerControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        payloadSize(),
        deviceTapGeometry(),
        gevVersionMajor(),
        gevVersionMinor(),
        gevDeviceModeIsBigEndian(),
        gevDeviceClass(),
        gevDeviceModeCharacterSet(),
        gevPhysicalLinkConfiguration(),
        gevCurrentPhysicalLinkConfiguration(),
        gevActiveLinkCount(),
        gevInterfaceSelector(),
        gevLinkSpeed(),
        gevMACAddress(),
        gevSupportedOptionSelector(),
        gevSupportedOption(),
        gevSupportedIPConfigurationLLA(),
        gevSupportedIPConfigurationDHCP(),
        gevSupportedIPConfigurationPersistentIP(),
        gevPAUSEFrameReception(),
        gevPAUSEFrameTransmission(),
        gevCurrentIPConfiguration(),
        gevCurrentIPConfigurationLLA(),
        gevCurrentIPConfigurationDHCP(),
        gevCurrentIPConfigurationPersistentIP(),
        gevCurrentIPAddress(),
        gevCurrentSubnetMask(),
        gevCurrentDefaultGateway(),
        gevIPConfigurationStatus(),
        gevFirstURL(),
        gevSecondURL(),
        gevNumberOfInterfaces(),
        gevPersistentIPAddress(),
        gevPersistentSubnetMask(),
        gevPersistentDefaultGateway(),
        gevMessageChannelCount(),
        gevStreamChannelCount(),
        gevSupportedOptionalCommandsUserDefinedName(),
        gevSupportedOptionalCommandsSerialNumber(),
        gevSupportedOptionalCommandsEVENTDATA(),
        gevSupportedOptionalCommandsEVENT(),
        gevSupportedOptionalCommandsPACKETRESEND(),
        gevSupportedOptionalCommandsWRITEMEM(),
        gevSupportedOptionalCommandsConcatenation(),
        gevHeartbeatTimeout(),
        gevTimestampTickFrequency(),
        gevTimestampControlLatch(),
        gevTimestampControlReset(),
        gevTimestampValue(),
        gevDiscoveryAckDelay(),
        gevIEEE1588(),
        gevIEEE1588ClockAccuracy(),
        gevIEEE1588Status(),
        gevGVCPExtendedStatusCodesSelector(),
        gevGVCPExtendedStatusCodes(),
        gevGVCPPendingAck(),
        gevGVCPHeartbeatDisable(),
        gevGVCPPendingTimeout(),
        gevPrimaryApplicationSwitchoverKey(),
        gevGVSPExtendedIDMode(),
        gevCCP(),
        gevPrimaryApplicationSocket(),
        gevPrimaryApplicationIPAddress(),
        gevMCPHostPort(),
        gevMCDA(),
        gevMCTT(),
        gevMCRC(),
        gevMCSP(),
        gevStreamChannelSelector(),
        gevSCCFGPacketResendDestination(),
        gevSCCFGAllInTransmission(),
        gevSCCFGUnconditionalStreaming(),
        gevSCCFGExtendedChunkData(),
        gevSCPDirection(),
        gevSCPInterfaceIndex(),
        gevSCPHostPort(),
        gevSCPSFireTestPacket(),
        gevSCPSDoNotFragment(),
        gevSCPSBigEndian(),
        gevSCPSPacketSize(),
        gevSCPD(),
        gevSCDA(),
        gevSCSP(),
        gevSCZoneCount(),
        gevSCZoneDirectionAll(),
        gevSCZoneConfigurationLock(),
        gevManifestEntrySelector(),
        gevManifestXMLMajorVersion(),
        gevManifestXMLMinorVersion(),
        gevManifestXMLSubMinorVersion(),
        gevManifestSchemaMajorVersion(),
        gevManifestSchemaMinorVersion(),
        gevManifestPrimaryURL(),
        gevManifestSecondaryURL(),
        aPAUSEMACCtrlFramesTransmitted(),
        aPAUSEMACCtrlFramesReceived(),
        clConfiguration(),
        clTimeSlotsCount(),
        cxpLinkConfigurationStatus(),
        cxpLinkConfigurationPreferred(),
        cxpLinkConfiguration(),
        cxpConnectionSelector(),
        cxpConnectionTestMode(),
        cxpConnectionTestErrorCount(),
        cxpConnectionTestPacketCount(),
        cxpPoCxpAuto(),
        cxpPoCxpTurnOff(),
        cxpPoCxpTripReset(),
        cxpPoCxpStatus(),
        mvGevSCBWControl(),
        mvGevSCBW()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( payloadSize, "PayloadSize" );
        locator.bindComponent( deviceTapGeometry, "DeviceTapGeometry" );
        locator.bindComponent( gevVersionMajor, "GevVersionMajor" );
        locator.bindComponent( gevVersionMinor, "GevVersionMinor" );
        locator.bindComponent( gevDeviceModeIsBigEndian, "GevDeviceModeIsBigEndian" );
        locator.bindComponent( gevDeviceClass, "GevDeviceClass" );
        locator.bindComponent( gevDeviceModeCharacterSet, "GevDeviceModeCharacterSet" );
        locator.bindComponent( gevPhysicalLinkConfiguration, "GevPhysicalLinkConfiguration" );
        locator.bindComponent( gevCurrentPhysicalLinkConfiguration, "GevCurrentPhysicalLinkConfiguration" );
        locator.bindComponent( gevActiveLinkCount, "GevActiveLinkCount" );
        locator.bindComponent( gevInterfaceSelector, "GevInterfaceSelector" );
        locator.bindComponent( gevLinkSpeed, "GevLinkSpeed" );
        locator.bindComponent( gevMACAddress, "GevMACAddress" );
        locator.bindComponent( gevSupportedOptionSelector, "GevSupportedOptionSelector" );
        locator.bindComponent( gevSupportedOption, "GevSupportedOption" );
        locator.bindComponent( gevSupportedIPConfigurationLLA, "GevSupportedIPConfigurationLLA" );
        locator.bindComponent( gevSupportedIPConfigurationDHCP, "GevSupportedIPConfigurationDHCP" );
        locator.bindComponent( gevSupportedIPConfigurationPersistentIP, "GevSupportedIPConfigurationPersistentIP" );
        locator.bindComponent( gevPAUSEFrameReception, "GevPAUSEFrameReception" );
        locator.bindComponent( gevPAUSEFrameTransmission, "GevPAUSEFrameTransmission" );
        locator.bindComponent( gevCurrentIPConfiguration, "GevCurrentIPConfiguration" );
        locator.bindComponent( gevCurrentIPConfigurationLLA, "GevCurrentIPConfigurationLLA" );
        locator.bindComponent( gevCurrentIPConfigurationDHCP, "GevCurrentIPConfigurationDHCP" );
        locator.bindComponent( gevCurrentIPConfigurationPersistentIP, "GevCurrentIPConfigurationPersistentIP" );
        locator.bindComponent( gevCurrentIPAddress, "GevCurrentIPAddress" );
        locator.bindComponent( gevCurrentSubnetMask, "GevCurrentSubnetMask" );
        locator.bindComponent( gevCurrentDefaultGateway, "GevCurrentDefaultGateway" );
        locator.bindComponent( gevIPConfigurationStatus, "GevIPConfigurationStatus" );
        locator.bindComponent( gevFirstURL, "GevFirstURL" );
        locator.bindComponent( gevSecondURL, "GevSecondURL" );
        locator.bindComponent( gevNumberOfInterfaces, "GevNumberOfInterfaces" );
        locator.bindComponent( gevPersistentIPAddress, "GevPersistentIPAddress" );
        locator.bindComponent( gevPersistentSubnetMask, "GevPersistentSubnetMask" );
        locator.bindComponent( gevPersistentDefaultGateway, "GevPersistentDefaultGateway" );
        locator.bindComponent( gevMessageChannelCount, "GevMessageChannelCount" );
        locator.bindComponent( gevStreamChannelCount, "GevStreamChannelCount" );
        locator.bindComponent( gevSupportedOptionalCommandsUserDefinedName, "GevSupportedOptionalCommandsUserDefinedName" );
        locator.bindComponent( gevSupportedOptionalCommandsSerialNumber, "GevSupportedOptionalCommandsSerialNumber" );
        locator.bindComponent( gevSupportedOptionalCommandsEVENTDATA, "GevSupportedOptionalCommandsEVENTDATA" );
        locator.bindComponent( gevSupportedOptionalCommandsEVENT, "GevSupportedOptionalCommandsEVENT" );
        locator.bindComponent( gevSupportedOptionalCommandsPACKETRESEND, "GevSupportedOptionalCommandsPACKETRESEND" );
        locator.bindComponent( gevSupportedOptionalCommandsWRITEMEM, "GevSupportedOptionalCommandsWRITEMEM" );
        locator.bindComponent( gevSupportedOptionalCommandsConcatenation, "GevSupportedOptionalCommandsConcatenation" );
        locator.bindComponent( gevHeartbeatTimeout, "GevHeartbeatTimeout" );
        locator.bindComponent( gevTimestampTickFrequency, "GevTimestampTickFrequency" );
        locator.bindComponent( gevTimestampControlLatch, "GevTimestampControlLatch@i" );
        locator.bindComponent( gevTimestampControlReset, "GevTimestampControlReset@i" );
        locator.bindComponent( gevTimestampValue, "GevTimestampValue" );
        locator.bindComponent( gevDiscoveryAckDelay, "GevDiscoveryAckDelay" );
        locator.bindComponent( gevIEEE1588, "GevIEEE1588" );
        locator.bindComponent( gevIEEE1588ClockAccuracy, "GevIEEE1588ClockAccuracy" );
        locator.bindComponent( gevIEEE1588Status, "GevIEEE1588Status" );
        locator.bindComponent( gevGVCPExtendedStatusCodesSelector, "GevGVCPExtendedStatusCodesSelector" );
        locator.bindComponent( gevGVCPExtendedStatusCodes, "GevGVCPExtendedStatusCodes" );
        locator.bindComponent( gevGVCPPendingAck, "GevGVCPPendingAck" );
        locator.bindComponent( gevGVCPHeartbeatDisable, "GevGVCPHeartbeatDisable" );
        locator.bindComponent( gevGVCPPendingTimeout, "GevGVCPPendingTimeout" );
        locator.bindComponent( gevPrimaryApplicationSwitchoverKey, "GevPrimaryApplicationSwitchoverKey" );
        locator.bindComponent( gevGVSPExtendedIDMode, "GevGVSPExtendedIDMode" );
        locator.bindComponent( gevCCP, "GevCCP" );
        locator.bindComponent( gevPrimaryApplicationSocket, "GevPrimaryApplicationSocket" );
        locator.bindComponent( gevPrimaryApplicationIPAddress, "GevPrimaryApplicationIPAddress" );
        locator.bindComponent( gevMCPHostPort, "GevMCPHostPort" );
        locator.bindComponent( gevMCDA, "GevMCDA" );
        locator.bindComponent( gevMCTT, "GevMCTT" );
        locator.bindComponent( gevMCRC, "GevMCRC" );
        locator.bindComponent( gevMCSP, "GevMCSP" );
        locator.bindComponent( gevStreamChannelSelector, "GevStreamChannelSelector" );
        locator.bindComponent( gevSCCFGPacketResendDestination, "GevSCCFGPacketResendDestination" );
        locator.bindComponent( gevSCCFGAllInTransmission, "GevSCCFGAllInTransmission" );
        locator.bindComponent( gevSCCFGUnconditionalStreaming, "GevSCCFGUnconditionalStreaming" );
        locator.bindComponent( gevSCCFGExtendedChunkData, "GevSCCFGExtendedChunkData" );
        locator.bindComponent( gevSCPDirection, "GevSCPDirection" );
        locator.bindComponent( gevSCPInterfaceIndex, "GevSCPInterfaceIndex" );
        locator.bindComponent( gevSCPHostPort, "GevSCPHostPort" );
        locator.bindComponent( gevSCPSFireTestPacket, "GevSCPSFireTestPacket" );
        locator.bindComponent( gevSCPSDoNotFragment, "GevSCPSDoNotFragment" );
        locator.bindComponent( gevSCPSBigEndian, "GevSCPSBigEndian" );
        locator.bindComponent( gevSCPSPacketSize, "GevSCPSPacketSize" );
        locator.bindComponent( gevSCPD, "GevSCPD" );
        locator.bindComponent( gevSCDA, "GevSCDA" );
        locator.bindComponent( gevSCSP, "GevSCSP" );
        locator.bindComponent( gevSCZoneCount, "GevSCZoneCount" );
        locator.bindComponent( gevSCZoneDirectionAll, "GevSCZoneDirectionAll" );
        locator.bindComponent( gevSCZoneConfigurationLock, "GevSCZoneConfigurationLock" );
        locator.bindComponent( gevManifestEntrySelector, "GevManifestEntrySelector" );
        locator.bindComponent( gevManifestXMLMajorVersion, "GevManifestXMLMajorVersion" );
        locator.bindComponent( gevManifestXMLMinorVersion, "GevManifestXMLMinorVersion" );
        locator.bindComponent( gevManifestXMLSubMinorVersion, "GevManifestXMLSubMinorVersion" );
        locator.bindComponent( gevManifestSchemaMajorVersion, "GevManifestSchemaMajorVersion" );
        locator.bindComponent( gevManifestSchemaMinorVersion, "GevManifestSchemaMinorVersion" );
        locator.bindComponent( gevManifestPrimaryURL, "GevManifestPrimaryURL" );
        locator.bindComponent( gevManifestSecondaryURL, "GevManifestSecondaryURL" );
        locator.bindComponent( aPAUSEMACCtrlFramesTransmitted, "aPAUSEMACCtrlFramesTransmitted" );
        locator.bindComponent( aPAUSEMACCtrlFramesReceived, "aPAUSEMACCtrlFramesReceived" );
        locator.bindComponent( clConfiguration, "ClConfiguration" );
        locator.bindComponent( clTimeSlotsCount, "ClTimeSlotsCount" );
        locator.bindComponent( cxpLinkConfigurationStatus, "CxpLinkConfigurationStatus" );
        locator.bindComponent( cxpLinkConfigurationPreferred, "CxpLinkConfigurationPreferred" );
        locator.bindComponent( cxpLinkConfiguration, "CxpLinkConfiguration" );
        locator.bindComponent( cxpConnectionSelector, "CxpConnectionSelector" );
        locator.bindComponent( cxpConnectionTestMode, "CxpConnectionTestMode" );
        locator.bindComponent( cxpConnectionTestErrorCount, "CxpConnectionTestErrorCount" );
        locator.bindComponent( cxpConnectionTestPacketCount, "CxpConnectionTestPacketCount" );
        locator.bindComponent( cxpPoCxpAuto, "CxpPoCxpAuto@i" );
        locator.bindComponent( cxpPoCxpTurnOff, "CxpPoCxpTurnOff@i" );
        locator.bindComponent( cxpPoCxpTripReset, "CxpPoCxpTripReset@i" );
        locator.bindComponent( cxpPoCxpStatus, "CxpPoCxpStatus" );
        locator.bindComponent( mvGevSCBWControl, "mvGevSCBWControl" );
        locator.bindComponent( mvGevSCBW, "mvGevSCBW" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Provides the number of bytes transferred for each image or chunk on the stream channel.
    /**
     *  Provides the number of bytes transferred for each image or chunk on the stream channel. This includes any end-of-line, end-of-frame statistics or other stamp data. This is the total size of data payload for a data block.
     */
    PropertyI64 payloadSize;
    /// \brief This device tap geometry feature describes the geometrical properties characterizing the taps of a camera as presented at the output of the device.
    /**
     *  This device tap geometry feature describes the geometrical properties characterizing the taps of a camera as presented at the output of the device.
     */
    PropertyI64 deviceTapGeometry;
    /// \brief Major version of the specification.
    /**
     *  Major version of the specification.
     */
    PropertyI64 gevVersionMajor;
    /// \brief Minor version of the specification.
    /**
     *  Minor version of the specification.
     */
    PropertyI64 gevVersionMinor;
    /// \brief Endianess of the device registers.
    /**
     *  Endianess of the device registers.
     */
    PropertyIBoolean gevDeviceModeIsBigEndian;
    /// \brief Returns the class of the device.
    /**
     *  Returns the class of the device.
     */
    PropertyI64 gevDeviceClass;
    /// \brief Character set used by all the strings of the bootstrap registers.
    /**
     *  Character set used by all the strings of the bootstrap registers.
     */
    PropertyI64 gevDeviceModeCharacterSet;
    /// \brief Controls the principal physical link configuration to use on next restart/power-up of the device.
    /**
     *  Controls the principal physical link configuration to use on next restart/power-up of the device.
     */
    PropertyI64 gevPhysicalLinkConfiguration;
    /// \brief Indicates the current physical link configuration of the device.
    /**
     *  Indicates the current physical link configuration of the device.
     */
    PropertyI64 gevCurrentPhysicalLinkConfiguration;
    /// \brief Indicates the current number of active logical links.
    /**
     *  Indicates the current number of active logical links.
     */
    PropertyI64 gevActiveLinkCount;
    /// \brief Selects which logical link to control.
    /**
     *  Selects which logical link to control.
     */
    PropertyI64 gevInterfaceSelector;
    /// \brief Indicates the speed of transmission negotiated by the given logical link.
    /**
     *  Indicates the speed of transmission negotiated by the given logical link.
     */
    PropertyI64 gevLinkSpeed;
    /// \brief MAC address of the logical link.
    /**
     *  MAC address of the logical link.
     */
    PropertyI64 gevMACAddress;
    /// \brief Selects the GEV option to interrogate for existing support.
    /**
     *  Selects the GEV option to interrogate for existing support.
     */
    PropertyI64 gevSupportedOptionSelector;
    /// \brief Returns if the selected GEV option is supported.
    /**
     *  Returns if the selected GEV option is supported.
     */
    PropertyIBoolean gevSupportedOption;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if Link Local Address IP configuration scheme is supported by the given network interface.
     */
    PropertyIBoolean gevSupportedIPConfigurationLLA;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if DHCP IP configuration scheme is supported by the given network interface.
     */
    PropertyIBoolean gevSupportedIPConfigurationDHCP;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if PersistentIP configuration scheme is supported by the given network interface.
     */
    PropertyIBoolean gevSupportedIPConfigurationPersistentIP;
    /// \brief Controls whether incoming PAUSE Frames are handled on the given logical link.
    /**
     *  Controls whether incoming PAUSE Frames are handled on the given logical link.
     */
    PropertyIBoolean gevPAUSEFrameReception;
    /// \brief Controls whether PAUSE Frames can be generated on the given logical link.
    /**
     *  Controls whether PAUSE Frames can be generated on the given logical link.
     */
    PropertyIBoolean gevPAUSEFrameTransmission;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It reports the current IP Configuration scheme. Note that this feature doesn't provision more that one simultaneous IP configuration and should not be used.
     */
    PropertyI64 gevCurrentIPConfiguration;
    /// \brief Controls whether the Link Local Address IP configuration scheme is activated on the given logical link.
    /**
     *  Controls whether the Link Local Address IP configuration scheme is activated on the given logical link.
     */
    PropertyIBoolean gevCurrentIPConfigurationLLA;
    /// \brief Controls whether the DHCP IP configuration scheme is activated on the given logical link.
    /**
     *  Controls whether the DHCP IP configuration scheme is activated on the given logical link.
     */
    PropertyIBoolean gevCurrentIPConfigurationDHCP;
    /// \brief Controls whether the PersistentIP configuration scheme is activated on the given logical link.
    /**
     *  Controls whether the PersistentIP configuration scheme is activated on the given logical link.
     */
    PropertyIBoolean gevCurrentIPConfigurationPersistentIP;
    /// \brief Reports the IP address for the given logical link.
    /**
     *  Reports the IP address for the given logical link.
     */
    PropertyI64 gevCurrentIPAddress;
    /// \brief Reports the subnet mask of the given logical link.
    /**
     *  Reports the subnet mask of the given logical link.
     */
    PropertyI64 gevCurrentSubnetMask;
    /// \brief Reports the default gateway IP address to be used on the given logical link.
    /**
     *  Reports the default gateway IP address to be used on the given logical link.
     */
    PropertyI64 gevCurrentDefaultGateway;
    /// \brief Reports the current IP configuration status.
    /**
     *  Reports the current IP configuration status.
     */
    PropertyI64 gevIPConfigurationStatus;
    /// \brief Indicates the first URL to the GenICam XML device description file.
    /**
     *  Indicates the first URL to the GenICam XML device description file. The First URL is used as the first choice by the application to retrieve the GenICam XML device description file.
     */
    PropertyS gevFirstURL;
    /// \brief Indicates the second URL to the GenICam XML device description file.
    /**
     *  Indicates the second URL to the GenICam XML device description file. This URL is an alternative if the application was unsuccessful to retrieve the device description file using the first URL.
     */
    PropertyS gevSecondURL;
    /// \brief Indicates the number of logical links supported by this device.
    /**
     *  Indicates the number of logical links supported by this device.
     */
    PropertyI64 gevNumberOfInterfaces;
    /// \brief Controls the Persistent IP address for this logical link.
    /**
     *  Controls the Persistent IP address for this logical link. It is only used when the device boots with the Persistent IP configuration scheme.
     */
    PropertyI64 gevPersistentIPAddress;
    /// \brief Controls the Persistent subnet mask associated with the Persistent IP address on this logical link.
    /**
     *  Controls the Persistent subnet mask associated with the Persistent IP address on this logical link. It is only used when the device boots with the Persistent IP configuration scheme.
     */
    PropertyI64 gevPersistentSubnetMask;
    /// \brief Controls the persistent default gateway for this logical link.
    /**
     *  Controls the persistent default gateway for this logical link. It is only used when the device boots with the Persistent IP configuration scheme.Visibility
     */
    PropertyI64 gevPersistentDefaultGateway;
    /// \brief Indicates the number of message channels supported by this device.
    /**
     *  Indicates the number of message channels supported by this device.
     */
    PropertyI64 gevMessageChannelCount;
    /// \brief Indicates the number of stream channels supported by this device.
    /**
     *  Indicates the number of stream channels supported by this device.
     */
    PropertyI64 gevStreamChannelCount;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the User-defined name register is supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsUserDefinedName;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the Serial number register is supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsSerialNumber;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the EVENTDATA_CMD and EVENTDATA_ACK are supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsEVENTDATA;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the EVENT_CMD and EVENT_ACK are supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsEVENT;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the PACKETRESEND_CMD is supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsPACKETRESEND;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the WRITEMEM_CMD and WRITEMEM_ACK are supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsWRITEMEM;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. GevSupportedOption should be used instead. It indicates if the Multiple operations in a single message are supported.
     */
    PropertyIBoolean gevSupportedOptionalCommandsConcatenation;
    /// \brief Controls the current heartbeat timeout in milliseconds.
    /**
     *  Controls the current heartbeat timeout in milliseconds.
     */
    PropertyI64 gevHeartbeatTimeout;
    /// \brief Indicates the number of timestamp ticks in 1 second (frequency in Hz).
    /**
     *  Indicates the number of timestamp ticks in 1 second (frequency in Hz). If IEEE 1588 is used, this feature must return 1,000,000,000 (1 GHz).
     */
    PropertyI64 gevTimestampTickFrequency;
    /// \brief Latches the current timestamp counter into GevTimestampValue.
    /**
     *  Latches the current timestamp counter into GevTimestampValue.
     */
    Method gevTimestampControlLatch;
    /// \brief Resets the timestamp counter to 0.
    /**
     *  Resets the timestamp counter to 0. This feature is not available or as no effect when IEEE 1588 is used.
     */
    Method gevTimestampControlReset;
    /// \brief Returns the latched 64-bit value of the timestamp counter.
    /**
     *  Returns the latched 64-bit value of the timestamp counter.
     */
    PropertyI64 gevTimestampValue;
    /// \brief Indicates the maximum randomized delay the device will wait to acknowledge a discovery command.
    /**
     *  Indicates the maximum randomized delay the device will wait to acknowledge a discovery command.
     */
    PropertyI64 gevDiscoveryAckDelay;
    /// \brief Enables the IEEE 1588 Precision Time Protocol to control the timestamp register.
    /**
     *  Enables the IEEE 1588 Precision Time Protocol to control the timestamp register.
     */
    PropertyIBoolean gevIEEE1588;
    /// \brief Indicates the expected accuracy of the device clock when it is the grandmaster, or in the event it becomes the grandmaster.
    /**
     *  Indicates the expected accuracy of the device clock when it is the grandmaster, or in the event it becomes the grandmaster.
     */
    PropertyI64 gevIEEE1588ClockAccuracy;
    /// \brief Provides the status of the IEEE 1588 clock.
    /**
     *  Provides the status of the IEEE 1588 clock.
     */
    PropertyI64 gevIEEE1588Status;
    /// \brief Selects the GigE Vision version to control extended status codes for.
    /**
     *  Selects the GigE Vision version to control extended status codes for.
     */
    PropertyIBoolean gevGVCPExtendedStatusCodesSelector;
    /// \brief Enables the generation of extended status codes.
    /**
     *  Enables the generation of extended status codes.
     */
    PropertyIBoolean gevGVCPExtendedStatusCodes;
    /// \brief Enables the generation of PENDING_ACK.
    /**
     *  Enables the generation of PENDING_ACK.
     */
    PropertyIBoolean gevGVCPPendingAck;
    /// \brief Disables the GVCP heartbeat.
    /**
     *  Disables the GVCP heartbeat.
     */
    PropertyIBoolean gevGVCPHeartbeatDisable;
    /// \brief Indicates the longest GVCP command execution time before a device returns a PENDING_ACK.
    /**
     *  Indicates the longest GVCP command execution time before a device returns a PENDING_ACK.
     */
    PropertyI64 gevGVCPPendingTimeout;
    /// \brief Controls the key to use to authenticate primary application switchover requests.
    /**
     *  Controls the key to use to authenticate primary application switchover requests.
     */
    PropertyI64 gevPrimaryApplicationSwitchoverKey;
    /// \brief Enables the extended IDs mode.
    /**
     *  Enables the extended IDs mode.
     */
    PropertyI64 gevGVSPExtendedIDMode;
    /// \brief Controls the device access privilege of an application.
    /**
     *  Controls the device access privilege of an application.
     */
    PropertyI64 gevCCP;
    /// \brief Returns the UDP source port of the primary application.
    /**
     *  Returns the UDP source port of the primary application.
     */
    PropertyI64 gevPrimaryApplicationSocket;
    /// \brief Returns the address of the primary application.
    /**
     *  Returns the address of the primary application.
     */
    PropertyI64 gevPrimaryApplicationIPAddress;
    /// \brief Controls the port to which the device must send messages.
    /**
     *  Controls the port to which the device must send messages. Setting this value to 0 closes the message channel.
     */
    PropertyI64 gevMCPHostPort;
    /// \brief Controls the destination IP address for the message channel.
    /**
     *  Controls the destination IP address for the message channel.
     */
    PropertyI64 gevMCDA;
    /// \brief Provides the transmission timeout value in milliseconds.
    /**
     *  Provides the transmission timeout value in milliseconds.
     */
    PropertyI64 gevMCTT;
    /// \brief Controls the number of retransmissions allowed when a message channel message times out.
    /**
     *  Controls the number of retransmissions allowed when a message channel message times out.
     */
    PropertyI64 gevMCRC;
    /// \brief This feature indicates the source port for the message channel.
    /**
     *  This feature indicates the source port for the message channel.
     */
    PropertyI64 gevMCSP;
    /// \brief Selects the stream channel to control.
    /**
     *  Selects the stream channel to control.
     */
    PropertyI64 gevStreamChannelSelector;
    /// \brief Enables the alternate IP destination for stream packets resent due to a packet resend request.
    /**
     *  Enables the alternate IP destination for stream packets resent due to a packet resend request. When True, the source IP address provided in the packet resend command packet is used. When False, the value set in the GevSCDA[GevStreamChannelSelector] feature is used.
     */
    PropertyIBoolean gevSCCFGPacketResendDestination;
    /// \brief Enables the selected GVSP transmitter to use the single packet per data block All-in Transmission mode.
    /**
     *  Enables the selected GVSP transmitter to use the single packet per data block All-in Transmission mode.
     */
    PropertyIBoolean gevSCCFGAllInTransmission;
    /// \brief Enables the camera to continue to stream, for this stream channel, if its control channel is closed or regardless of the reception of any ICMP messages (such as destination unreachable messages).
    /**
     *  Enables the camera to continue to stream, for this stream channel, if its control channel is closed or regardless of the reception of any ICMP messages (such as destination unreachable messages).
     */
    PropertyIBoolean gevSCCFGUnconditionalStreaming;
    /// \brief Enables cameras to use the extended chunk data payload type for this stream channel.
    /**
     *  Enables cameras to use the extended chunk data payload type for this stream channel.
     */
    PropertyIBoolean gevSCCFGExtendedChunkData;
    /// \brief Reports the direction of the stream channel.
    /**
     *  Reports the direction of the stream channel.
     */
    PropertyI64 gevSCPDirection;
    /// \brief Index of the logical link to use.
    /**
     *  Index of the logical link to use.
     */
    PropertyI64 gevSCPInterfaceIndex;
    /// \brief Controls the port of the selected channel to which a GVSP transmitter must send data stream or the port from which a GVSP receiver may receive data stream.
    /**
     *  Controls the port of the selected channel to which a GVSP transmitter must send data stream or the port from which a GVSP receiver may receive data stream. Setting this value to 0 closes the stream channel.
     */
    PropertyI64 gevSCPHostPort;
    /// \brief Sends a test packet.
    /**
     *  Sends a test packet. When this feature is set, the device will fire one test packet.
     */
    PropertyIBoolean gevSCPSFireTestPacket;
    /// \brief The state of this feature is copied into the 'do not fragment' bit of IP header of each stream packet.
    /**
     *  The state of this feature is copied into the 'do not fragment' bit of IP header of each stream packet. It can be used by the application to prevent IP fragmentation of packets on the stream channel.
     */
    PropertyIBoolean gevSCPSDoNotFragment;
    /// \brief Endianess of multi-byte pixel data for this stream.
    /**
     *  Endianess of multi-byte pixel data for this stream.
     */
    PropertyIBoolean gevSCPSBigEndian;
    /// \brief Specifies the stream packet size, in bytes, to send on the selected channel for a GVSP transmitter or specifies the maximum packet size supported by a GVSP receiver.
    /**
     *  Specifies the stream packet size, in bytes, to send on the selected channel for a GVSP transmitter or specifies the maximum packet size supported by a GVSP receiver.
     */
    PropertyI64 gevSCPSPacketSize;
    /// \brief Controls the delay (in timestamp counter unit) to insert between each packet for this stream channel.
    /**
     *  Controls the delay (in timestamp counter unit) to insert between each packet for this stream channel. This can be used as a crude flow-control mechanism if the application or the network infrastructure cannot keep up with the packets coming from the device.
     */
    PropertyI64 gevSCPD;
    /// \brief Controls the destination IP address of the selected stream channel to which a GVSP transmitter must send data stream or the destination IP address from which a GVSP receiver may receive data stream.
    /**
     *  Controls the destination IP address of the selected stream channel to which a GVSP transmitter must send data stream or the destination IP address from which a GVSP receiver may receive data stream.
     */
    PropertyI64 gevSCDA;
    /// \brief Indicates the source port of the stream channel.
    /**
     *  Indicates the source port of the stream channel.
     */
    PropertyI64 gevSCSP;
    /// \brief Reports the number of zones per block transmitted on the selected stream channel.
    /**
     *  Reports the number of zones per block transmitted on the selected stream channel.
     */
    PropertyI64 gevSCZoneCount;
    /// \brief Reports the transmission direction of each zone transmitted on the selected stream channel.
    /**
     *  Reports the transmission direction of each zone transmitted on the selected stream channel.
     */
    PropertyI64 gevSCZoneDirectionAll;
    /// \brief Controls whether the selected stream channel multi-zone configuration is locked.
    /**
     *  Controls whether the selected stream channel multi-zone configuration is locked. When locked, the GVSP transmitter is not allowed to change the number of zones and their direction during block acquisition and transmission.
     */
    PropertyIBoolean gevSCZoneConfigurationLock;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Selects the manifest entry to reference.
     */
    PropertyI64 gevManifestEntrySelector;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Indicates the major version number of the XML file of the selected manifest entry.
     */
    PropertyI64 gevManifestXMLMajorVersion;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Indicates the minor version number of the XML file of the selected manifest entry.
     */
    PropertyI64 gevManifestXMLMinorVersion;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Indicates the subminor version number of the XML file of the selected manifest entry.
     */
    PropertyI64 gevManifestXMLSubMinorVersion;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Indicates the major version number of the schema file of the selected manifest entry.
     */
    PropertyI64 gevManifestSchemaMajorVersion;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent.. Indicates the minor version number of the schema file of the selected manifest entry.
     */
    PropertyI64 gevManifestSchemaMinorVersion;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Indicates the first URL to the XML device description file of the selected manifest entry.
     */
    PropertyS gevManifestPrimaryURL;
    /// \brief This feature is deprecated.
    /**
     *  \deprecated
     *  This feature is deprecated. See the Device Control section for an equivalent. Indicates the second URL to the XML device description file of the selected manifest entry.
     */
    PropertyS gevManifestSecondaryURL;
    /// \brief Reports the number of transmitted PAUSE frames.
    /**
     *  Reports the number of transmitted PAUSE frames.
     */
    PropertyI64 aPAUSEMACCtrlFramesTransmitted;
    /// \brief Reports the number of received PAUSE frames.
    /**
     *  Reports the number of received PAUSE frames.
     */
    PropertyI64 aPAUSEMACCtrlFramesReceived;
    /// \brief This Camera Link specific feature describes the configuration used by the camera.
    /**
     *  This Camera Link specific feature describes the configuration used by the camera. It helps especially when a camera is capable of operation in a non-standard configuration, and when the features PixelSize, SensorDigitizationTaps, and DeviceTapGeometry do not provide enough information for interpretation of the image data provided by the camera.
     */
    PropertyI64 clConfiguration;
    /// \brief This Camera Link specific feature describes the time multiplexing of the camera link connection to transfer more than the configuration allows, in one single clock.
    /**
     *  This Camera Link specific feature describes the time multiplexing of the camera link connection to transfer more than the configuration allows, in one single clock.
     */
    PropertyI64 clTimeSlotsCount;
    /// \brief This feature indicates the current and active Link configuration used by the Device.
    /**
     *  This feature indicates the current and active Link configuration used by the Device.
     */
    PropertyI64 cxpLinkConfigurationStatus;
    /// \brief Provides the Link configuration that allows the Transmitter Device to operate in its default mode.
    /**
     *  Provides the Link configuration that allows the Transmitter Device to operate in its default mode.
     */
    PropertyI64 cxpLinkConfigurationPreferred;
    /// \brief This feature allows specifying the Link configuration for the communication between the Receiver and Transmitter Device.
    /**
     *  This feature allows specifying the Link configuration for the communication between the Receiver and Transmitter Device. In most cases this feature does not need to be written because automatic discovery will set configuration correctly to the value returned by CxpLinkConfigurationPreferred. Note that the currently active configuration of the Link can be read using CxpLinkConfigurationStatus.
     */
    PropertyI64 cxpLinkConfiguration;
    /// \brief Selects the CoaXPress physical connection to control.
    /**
     *  Selects the CoaXPress physical connection to control.
     */
    PropertyI64 cxpConnectionSelector;
    /// \brief Enables the test mode for an individual physical connection of the Device.
    /**
     *  Enables the test mode for an individual physical connection of the Device.
     */
    PropertyI64 cxpConnectionTestMode;
    /// \brief Reports the current connection error count for test packets recieved by the device on the connection selected by CxpConnectionSelector.
    /**
     *  Reports the current connection error count for test packets recieved by the device on the connection selected by CxpConnectionSelector.
     */
    PropertyI64 cxpConnectionTestErrorCount;
    /// \brief Reports the current count for test packets recieved by the device on the connection selected by CxpConnectionSelector.
    /**
     *  Reports the current count for test packets recieved by the device on the connection selected by CxpConnectionSelector.
     */
    PropertyI64 cxpConnectionTestPacketCount;
    /// \brief Activate automatic control of the Power over CoaXPress (PoCXP) for the Link.
    /**
     *  Activate automatic control of the Power over CoaXPress (PoCXP) for the Link.
     */
    Method cxpPoCxpAuto;
    /// \brief Disable Power over CoaXPress (PoCXP) for the Link.
    /**
     *  Disable Power over CoaXPress (PoCXP) for the Link.
     */
    Method cxpPoCxpTurnOff;
    /// \brief Reset the Power over CoaXPress (PoCXP) Link after an over-current trip on the Device connection(s).
    /**
     *  Reset the Power over CoaXPress (PoCXP) Link after an over-current trip on the Device connection(s).
     */
    Method cxpPoCxpTripReset;
    /// \brief Returns the Power over CoaXPress (PoCXP) status of the Device.
    /**
     *  Returns the Power over CoaXPress (PoCXP) status of the Device.
     */
    PropertyI64 cxpPoCxpStatus;
    /// \brief Selects the bandwidth control for the selected stream channel.
    /**
     *  This enumeration selects the bandwidth control for the selected stream channel.
     */
    PropertyI64 mvGevSCBWControl;
    /// \brief Sets the stream channels max. bandwidth in KBps
    /**
     *  This value sets the stream channels max. bandwidth in KBps.
     */
    PropertyI64 mvGevSCBW;
    PYTHON_ONLY( %mutable; )
    /// \brief Calculates the effective number of payload packets (not including leader and trailer) per block of data (e.g. an image) for a GigE Vision data stream when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent accurate as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *  \return The effective number of payload packets (not including leader and trailer) per block of data (e.g. an image) transferred by a GigE Vision device with the current parameters.
     */
    static int64_type gevGetEffectivePayloadPacketsPerImage(
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] The current value of the \a payloadSize property.
        const int64_type payloadSizeValue,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false )
    {
        const int64_type PacketSizeWithoutEthernet = boExtendedID ? 48LL : 36LL; // 20 (IP Header) + 8 (UDP Header) + boExtendedID ? 20 : 8 (GVSP Header)
        const int64_type gevSCPSPacketSizeValue_effective = gevSCPSPacketSizeValue - PacketSizeWithoutEthernet; // The ethernet header is not taken into account here!
        return ( payloadSizeValue + gevSCPSPacketSizeValue_effective - 1LL ) / gevSCPSPacketSizeValue_effective;
    }
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent accurate as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *  \return The effective number of payload packets (not including leader and trailer) per block of data (e.g. an image) transferred by a GigE Vision device with the current parameters.
     */
    int64_type gevGetEffectivePayloadPacketsPerImage(
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false ) const
    {
        return gevGetEffectivePayloadPacketsPerImage( gevSCPSPacketSizeValue, payloadSize.read(), boExtendedID );
    }
    /// \brief Calculates the effective bytes per block of data (e.g. an image) for a GigE Vision data stream when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent accurate as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *  \return The effective bytes per block of data (e.g. an image) transferred by a GigE Vision device with the current parameters.
     */
    static int64_type gevGetEffectiveBytesPerImage(
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] The current value of the \a payloadSize property.
        const int64_type payloadSizeValue,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false )
    {
        const int64_type PacketSizeWithoutEthernet = boExtendedID ? 48LL : 36LL; // 20 (IP Header) + 8 (UDP Header) + boExtendedID ? 20 : 8 (GVSP Header)
        const int64_type GVSPHeaderSize = PacketSizeWithoutEthernet + 14LL; // 14 (Ethernet Header)
        const int64_type GVSPImageLeaderSize = GVSPHeaderSize + 36LL;
        const int64_type GVSPImageTrailerSize = GVSPHeaderSize + 8LL;
        const int64_type protocolOverhead = GVSPImageLeaderSize + ( gevGetEffectivePayloadPacketsPerImage( gevSCPSPacketSizeValue, payloadSizeValue, boExtendedID ) * GVSPHeaderSize ) + GVSPImageTrailerSize;
        return protocolOverhead + payloadSizeValue;
    }
    /// \brief Calculates the effective bytes per block of data (e.g. an image) for a GigE Vision data stream when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent accurate as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *  \return The effective bytes per block of data (e.g. an image) transferred by a GigE Vision device with the current parameters.
     */
    int64_type gevGetEffectiveBytesPerImage(
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false ) const
    {
        return gevGetEffectiveBytesPerImage( gevSCPSPacketSizeValue, payloadSize.read(), boExtendedID );
    }
    /// \brief Calculates the overall resulting bandwidth (in bytes) needed for GigE Vision data streams when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent precise as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *  \return The overall resulting bandwidth (in bytes) needed for GigE Vision data streams when transferring the payload type \a image.
     */
    static int64_type gevGetResultingBandwidth(
        /// [in] The overall current or desired frame rate.
        const double acquisitionFrameRateValue,
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] The current value of the \a payloadSize property.
        const int64_type payloadSizeValue,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false )
    {
        return static_cast<int64_type>( static_cast<double>( gevGetEffectiveBytesPerImage( gevSCPSPacketSizeValue, payloadSizeValue, boExtendedID ) ) * acquisitionFrameRateValue );
    }
    /// \brief Calculates the overall resulting bandwidth (in bytes) needed for GigE Vision data streams when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent precise as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *  \return The overall resulting bandwidth (in bytes) needed for GigE Vision data streams when transferring the payload type \a image.
     */
    int64_type gevGetResultingBandwidth(
        /// [in] The overall current or desired frame rate.
        const double acquisitionFrameRateValue,
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false ) const
    {
        return static_cast<int64_type>( static_cast<double>( gevGetEffectiveBytesPerImage( gevSCPSPacketSizeValue, boExtendedID ) ) * acquisitionFrameRateValue );
    }
    /// \brief Calculates the inter-packet delay needed to achieve a uniform packet and thus payload distribution for for GigE Vision data streams when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent accurate as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *
     *  The result of this function should be written to the property <b>mvIMPACT::acquire::TransportLayerControl::gevSCPD</b> if supported by the device.
     *  \return The \a GevSCPD value for the given input parameters. If this value is negative, this indicates that the overall bandwidth resulting
     *  from the given input parameters is higher than stated by \a bandwidthAvailable. In such a case the inter-packet delay must be set to 0 and
     *  it should be noted that the desired framerate cannot be reached in this configuration.
     */
    static int64_type gevGetResultingPacketDelay(
        /// [in] The overall current or desired frame rate.
        const double acquisitionFrameRateValue,
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] The current value of the \a payloadSize property.
        const int64_type payloadSizeValue,
        /// [in] The timestamp tick frequency of the GEV remote device.
        const int64_type gevTimestampTickFrequencyValue,
        /// [in] The overall bandwidth in bytes that is available on the given link.
        const int64_type bandwidthAvailable,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false )
    {
        const int64_type bandwidthNeeded = gevGetResultingBandwidth( acquisitionFrameRateValue, gevSCPSPacketSizeValue, payloadSizeValue, boExtendedID );
        const int64_type packetsPerImage = gevGetEffectivePayloadPacketsPerImage( gevSCPSPacketSizeValue, payloadSizeValue, boExtendedID ) + 2; // one leader, one trailer
        const double totalDelayTime = 1. - static_cast<double>( bandwidthNeeded ) / static_cast<double>( bandwidthAvailable );
        const double interPacketDelayTime = totalDelayTime / ( static_cast<double>( packetsPerImage ) * acquisitionFrameRateValue );
        return static_cast<int64_type>( interPacketDelayTime * gevTimestampTickFrequencyValue );
    }
    /// \brief Calculates the inter-packet delay needed to achieve a uniform packet and thus payload distribution for for GigE Vision data streams when transferring the payload type \a image.
    /**
     *  This will include all overhead introduced by the network protocol. The value will be correct for payload type image only, thus e.g. when
     *  transferring chunk data the result will not be 100 per cent accurate as then some packets will use a slightly different layout. However
     *  these differences are negligible when working in modes, where individual images are not smaller then roughly 64 by 64 pixels.
     *
     *  The result of this function should be written to the property <b>mvIMPACT::acquire::TransportLayerControl::gevSCPD</b> if supported by the device.
     *  \return The \a GevSCPD value for the given input parameters. If this value is negative, this indicates that the overall bandwidth resulting
     *  from the given input parameters is higher than stated by \a bandwidthAvailable. In such a case the inter-packet delay must be set to 0 and
     *  it should be noted that the desired framerate cannot be reached in this configuration.
     */
    int64_type gevGetResultingPacketDelay(
        /// [in] The overall current or desired frame rate.
        const double acquisitionFrameRateValue,
        /// [in] The current or desired gevSCPSPacketSizeValue. This value depends e.g. on the MTU of the NIC the stream has been created on. See network configuration chapters for details.
        const int64_type gevSCPSPacketSizeValue,
        /// [in] The timestamp tick frequency of the GEV remote device.
        const int64_type gevTimestampTickFrequencyValue,
        /// [in] The overall bandwidth in bytes that is available on the given link.
        const int64_type bandwidthAvailable,
        /// [in] Indicates whether the bandwidth shall be calculated for the extended ID mode (introduced in GigE Vision 2.0) or not.
        /// With \a boExtendedID the protocol overhead will increase slightly.
        const bool boExtendedID = false ) const
    {
        return gevGetResultingPacketDelay( acquisitionFrameRateValue, gevSCPSPacketSizeValue, payloadSize.read(), gevTimestampTickFrequencyValue, bandwidthAvailable, boExtendedID );
    }
};

//-----------------------------------------------------------------------------
/// \brief Custom area.
/**
 *  Custom area.
 */
class mvCustomData
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvCustomData</b> object.
    explicit mvCustomData(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvCustomText(),
        mvWriteCustomData(),
        mvReadCustomData()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam" );
        locator.bindComponent( mvCustomText, "mvCustomText" );
        locator.bindComponent( mvWriteCustomData, "mvWriteCustomData@i" );
        locator.bindComponent( mvReadCustomData, "mvReadCustomData@i" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Custom text.
    /**
     *  Custom text.
     */
    PropertyS mvCustomText;
    /// \brief Function to write custom data.
    /**
     *  Function to write custom data.
     */
    Method mvWriteCustomData;
    /// \brief Function to read custom data.
    /**
     *  Function to read custom data.
     */
    Method mvReadCustomData;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains OMAP Preview Engine specific features.
/**
 *  A category that contains OMAP Preview Engine specific features.
 */
class mvOMAPPreviewConfig : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvOMAPPreviewConfig</b> object.
    explicit mvOMAPPreviewConfig(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvGain(),
        mvBalanceWhiteAuto(),
        mvAutoExposure()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvOMAPPreviewConfig" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvGain, "mvGain" );
        locator.bindComponent( mvBalanceWhiteAuto, "mvBalanceWhiteAuto" );
        locator.bindComponent( mvAutoExposure, "mvAutoExposure" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Changes the current gain.
    /**
     *  Changes the current gain.
     */
    PropertyI64 mvGain;
    /// \brief Controls the white balance engine.
    /**
     *  Controls the white balance engine.
     */
    PropertyI64 mvBalanceWhiteAuto;
    /// \brief Controls the auto exposure engine.
    /**
     *  Controls the auto exposure engine.
     */
    PropertyI64 mvAutoExposure;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Contains X-Lamp specific control paramters.
/**
 *  Contains X-Lamp specific control paramters.
 */
class mvXLampControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvXLampControl</b> object.
    explicit mvXLampControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvXLampSource(),
        mvXLampActivationSourceSelector(),
        mvXLampActivationSource(),
        mvXLampLEDPairSelector(),
        mvXLampActivationSourceModeSelector(),
        mvXLampLEDActivationSourceMode(),
        mvXLampLEDPairCurrent()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvXLampControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvXLampSource, "mvXLampSource" );
        locator.bindComponent( mvXLampActivationSourceSelector, "mvXLampActivationSourceSelector" );
        locator.bindComponent( mvXLampActivationSource, "mvXLampActivationSource" );
        locator.bindComponent( mvXLampLEDPairSelector, "mvXLampLEDPairSelector" );
        locator.bindComponent( mvXLampActivationSourceModeSelector, "mvXLampActivationSourceModeSelector" );
        locator.bindComponent( mvXLampLEDActivationSourceMode, "mvXLampLEDActivationSourceMode" );
        locator.bindComponent( mvXLampLEDPairCurrent, "mvXLampLEDPairCurrent" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Chooses which signal to use for the lamps
    /**
     *  Chooses which signal to use for the lamps
     */
    PropertyI64 mvXLampSource;
    /// \brief Chooses which activation line is to be configured
    /**
     *  Chooses which activation line is to be configured
     */
    PropertyI64 mvXLampActivationSourceSelector;
    /// \brief Chooses which signal to use for the activation line
    /**
     *  Chooses which signal to use for the activation line
     */
    PropertyI64 mvXLampActivationSource;
    /// \brief Chooses which LED pair is to be configured.
    /**
     *  Chooses which LED pair is to be configured.
     */
    PropertyI64 mvXLampLEDPairSelector;
    /// \brief Chooses which LED mode bit is to be configured.
    /**
     *  Chooses which LED mode bit is to be configured.
     */
    PropertyI64 mvXLampActivationSourceModeSelector;
    /// \brief LED mode bit
    /**
     *  LEDD mode bit
     */
    PropertyIBoolean mvXLampLEDActivationSourceMode;
    /// \brief Current per LED pair in mA.
    /**
     *  Current per LED pair in mA.
     */
    PropertyI64 mvXLampLEDPairCurrent;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to control the devices Logic Gate Control parameters.
/**
 *  A category that contains features to control the devices Logic Gate Control parameters.
 */
class mvLogicGateControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvLogicGateControl</b> object.
    explicit mvLogicGateControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvLogicGateANDSelector(),
        mvLogicGateANDSource1(),
        mvANDSource1Inverter(),
        mvLogicGateANDSource2(),
        mvANDSource2Inverter(),
        mvLogicGateORSelector(),
        mvLogicGateORSource1(),
        mvLogicGateORSource2(),
        mvLogicGateORSource3(),
        mvLogicGateORSource4(),
        mvLogicGateSourceSelector(),
        mvLogicGateSource(),
        mvLogicGateSourceInverter(),
        mvLogicGateANDTermSelector(),
        mvLogicGateANDTermSrc0(),
        mvLogicGateANDTermSrc1(),
        mvLogicGateORTermSelector(),
        mvLogicGateORTermSrc0(),
        mvLogicGateORTermSrc1()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvLogicGateControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvLogicGateANDSelector, "mvLogicGateANDSelector" );
        locator.bindComponent( mvLogicGateANDSource1, "mvLogicGateANDSource1" );
        locator.bindComponent( mvANDSource1Inverter, "mvANDSource1Inverter" );
        locator.bindComponent( mvLogicGateANDSource2, "mvLogicGateANDSource2" );
        locator.bindComponent( mvANDSource2Inverter, "mvANDSource2Inverter" );
        locator.bindComponent( mvLogicGateORSelector, "mvLogicGateORSelector" );
        locator.bindComponent( mvLogicGateORSource1, "mvLogicGateORSource1" );
        locator.bindComponent( mvLogicGateORSource2, "mvLogicGateORSource2" );
        locator.bindComponent( mvLogicGateORSource3, "mvLogicGateORSource3" );
        locator.bindComponent( mvLogicGateORSource4, "mvLogicGateORSource4" );
        locator.bindComponent( mvLogicGateSourceSelector, "mvLogicGateSourceSelector" );
        locator.bindComponent( mvLogicGateSource, "mvLogicGateSource" );
        locator.bindComponent( mvLogicGateSourceInverter, "mvLogicGateSourceInverter" );
        locator.bindComponent( mvLogicGateANDTermSelector, "mvLogicGateANDTermSelector" );
        locator.bindComponent( mvLogicGateANDTermSrc0, "mvLogicGateANDTermSrc0" );
        locator.bindComponent( mvLogicGateANDTermSrc1, "mvLogicGateANDTermSrc1" );
        locator.bindComponent( mvLogicGateORTermSelector, "mvLogicGateORTermSelector" );
        locator.bindComponent( mvLogicGateORTermSrc0, "mvLogicGateORTermSrc0" );
        locator.bindComponent( mvLogicGateORTermSrc1, "mvLogicGateORTermSrc1" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects the AND gate to configure.
    /**
     *  This enumeration selects the AND gate to configure.
     */
    PropertyI64 mvLogicGateANDSelector;
    /// \brief Selects the first input signal of the AND gate selected by mvLogicGateANDSelector.
    /**
     *  This enumeration can be used to select the first input signal of the AND gate selected by mvLogicGateANDSelector.
     */
    PropertyI64 mvLogicGateANDSource1;
    /// \brief Inverts the first input signal of the AND gate selected by mvLogicGateANDSelector
    /**
     *  Inverts the first input signal of the AND gate selected by mvLogicGateANDSelector
     */
    PropertyIBoolean mvANDSource1Inverter;
    /// \brief Selects the second input signal of the AND gate selected by mvLogicGateANDSelector.
    /**
     *  This enumeration can be used to select the second input signal of the AND gate selected by mvLogicGateANDSelector.
     */
    PropertyI64 mvLogicGateANDSource2;
    /// \brief Inverts the second input signal of the AND gate selected by mvLogicGateANDSelector
    /**
     *  Inverts the second input signal of the AND gate selected by mvLogicGateANDSelector
     */
    PropertyIBoolean mvANDSource2Inverter;
    /// \brief Selects the OR gate to configure.
    /**
     *  This enumeration selects the OR gate to configure.
     */
    PropertyI64 mvLogicGateORSelector;
    /// \brief Selects the first input signal of the OR gate selected by mvLogicGateORSelector.
    /**
     *  This enumeration can be used to select the first input signal of the OR gate selected by mvLogicGateORSelector.
     */
    PropertyI64 mvLogicGateORSource1;
    /// \brief Selects the second input signal of the OR gate selected by mvLogicGateORSelector.
    /**
     *  This enumeration can be used to select the second input signal of the OR gate selected by mvLogicGateORSelector.
     */
    PropertyI64 mvLogicGateORSource2;
    /// \brief Selects the third input signal of the OR gate selected by mvLogicGateORSelector.
    /**
     *  This enumeration can be used to select the third input signal of the OR gate selected by mvLogicGateORSelector.
     */
    PropertyI64 mvLogicGateORSource3;
    /// \brief Selects the fourth input signal of the OR gate selected by mvLogicGateORSelector.
    /**
     *  This enumeration can be used to select the fourth input signal of the OR gate selected by mvLogicGateORSelector.
     */
    PropertyI64 mvLogicGateORSource4;
    /// \brief Selects the LogicGateSource of the ANDORMatrix.
    /**
     *  Selects the LogicGateSource of the ANDORMatrix.
     */
    PropertyI64 mvLogicGateSourceSelector;
    /// \brief Selects the input signal of the ANDORMatrix selected by mvLogicGateSourceSelector.
    /**
     *  Selects the input signal of the ANDORMatrix selected by mvLogicGateSourceSelector.
     */
    PropertyI64 mvLogicGateSource;
    /// \brief Inverts the input signal.
    /**
     *  Inverts the input signal.
     */
    PropertyIBoolean mvLogicGateSourceInverter;
    /// \brief Selects the AND-term of the AND-OR-matrix.
    /**
     *  Selects the AND-term of the AND-OR-matrix.
     */
    PropertyI64 mvLogicGateANDTermSelector;
    /// \brief Selects the first input signal of the AND-term selected by mvLogicGateANDTermSelector.
    /**
     *  Selects the first input signal of the AND-term selected by mvLogicGateANDTermSelector.
     */
    PropertyI64 mvLogicGateANDTermSrc0;
    /// \brief Selects the second input signal of the AND-term selected by mvLogicGateANDTermSelector.
    /**
     *  Selects the second input signal of the AND-term selected by mvLogicGateANDTermSelector.
     */
    PropertyI64 mvLogicGateANDTermSrc1;
    /// \brief Selects the OR-term of the AND-OR-matrix.
    /**
     *  Selects the OR-term of the AND-OR-matrix.
     */
    PropertyI64 mvLogicGateORTermSelector;
    /// \brief Selects the first input signal of the ORTerm selected by mvLogicGateORTermSelector.
    /**
     *  Selects the first input signal of the ORTerm selected by mvLogicGateORTermSelector.
     */
    PropertyI64 mvLogicGateORTermSrc0;
    /// \brief Selects the second input signal of the ORTerm selected by mvLogicGateORTermSelector.
    /**
     *  Selects the second input signal of the ORTerm selected by mvLogicGateORTermSelector.
     */
    PropertyI64 mvLogicGateORTermSrc1;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to control the devices Current Control parameters.
/**
 *  A category that contains features to control the devices Current Control parameters.
 */
class mvCurrentControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvCurrentControl</b> object.
    explicit mvCurrentControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvCurrentSelector(),
        mvCurrent()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvCurrentControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvCurrentSelector, "mvCurrentSelector" );
        locator.bindComponent( mvCurrent, "mvCurrent" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects the current source to configure.
    /**
     *  Selects the current source to configure.
     */
    PropertyI64 mvCurrentSelector;
    /// \brief Sets the current value for the selected device(e.g.: LED).
    /**
     *  Sets the current value for the selected device(e.g.: LED).
     */
    PropertyI64 mvCurrent;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Contains features to control motorized lenses
/**
 *  Contains features to control motorized lenses.
 */
class mvLensControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvLensControl</b> object.
    explicit mvLensControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvIrisType(),
        mvIrisMode(),
        mvIrisSignalLevelMin(),
        mvIrisSignalLevelMax(),
        mvDriveSelector(),
        mvDriveForward(),
        mvDriveBackward(),
        mvDriveDuration(),
        mvDriveLevel()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvLensControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvIrisType, "mvIrisType" );
        locator.bindComponent( mvIrisMode, "mvIrisMode" );
        locator.bindComponent( mvIrisSignalLevelMin, "mvIrisSignalLevelMin" );
        locator.bindComponent( mvIrisSignalLevelMax, "mvIrisSignalLevelMax" );
        locator.bindComponent( mvDriveSelector, "mvDriveSelector" );
        locator.bindComponent( mvDriveForward, "mvDriveForward@i" );
        locator.bindComponent( mvDriveBackward, "mvDriveBackward@i" );
        locator.bindComponent( mvDriveDuration, "mvDriveDuration" );
        locator.bindComponent( mvDriveLevel, "mvDriveLevel" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Sets the iris type.
    /**
     *  Sets the iris type.
     */
    PropertyI64 mvIrisType;
    /// \brief Sets the iris operating mode.
    /**
     *  Sets the iris operating mode.
     */
    PropertyI64 mvIrisMode;
    /// \brief Sets the the minimum iris signal level in mV.
    /**
     *  Sets the the minimum iris signal level in mV.
     */
    PropertyI64 mvIrisSignalLevelMin;
    /// \brief Sets the the maximum iris signal level in mV.
    /**
     *  Sets the the maximum iris signal level in mV.
     */
    PropertyI64 mvIrisSignalLevelMax;
    /// \brief Selects the lens drive that should be adjusted.
    /**
     *  Selects the lens drive that should be adjusted.
     */
    PropertyI64 mvDriveSelector;
    /// \brief Generates a pulse defined by 'mvDriveDuration' and 'mvDriveLevel' to move the selected motor in forward direction.
    /**
     *  Generates a pulse defined by 'mvDriveDuration' and 'mvDriveLevel' to move the selected motor in forward direction.
     */
    Method mvDriveForward;
    /// \brief Generates a pulse defined by 'mvDriveDuration' and 'mvDriveLevel' to move the selected motor in backward direction.
    /**
     *  Generates a pulse defined by 'mvDriveDuration' and 'mvDriveLevel' to move the selected motor in backward direction.
     */
    Method mvDriveBackward;
    /// \brief Sets the duration of the drive command in us.
    /**
     *  Sets the duration of the drive command in us.
     */
    PropertyI64 mvDriveDuration;
    /// \brief Sets the voltage level of the drive command in mV.
    /**
     *  Sets the voltage level of the drive command in mV.
     */
    PropertyI64 mvDriveLevel;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to control the devices Flat Field Correction parameters.
/**
 *  A category that contains features to control the devices Flat Field Correction parameters.
 */
class mvFFCControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvFFCControl</b> object.
    explicit mvFFCControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvFFCEnable(),
        mvFFCCalibrationImageCount(),
        mvFFCCalibrate()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvFFCControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvFFCEnable, "mvFFCEnable" );
        locator.bindComponent( mvFFCCalibrationImageCount, "mvFFCCalibrationImageCount" );
        locator.bindComponent( mvFFCCalibrate, "mvFFCCalibrate@i" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Enables the Flat Field Correction.
    /**
     *  Enables the Flat Field Correction.
     */
    PropertyIBoolean mvFFCEnable;
    /// \brief The number of images to use for the calculation of the correction image.
    /**
     *  The number of images to use for the calculation of the correction image.
     */
    PropertyI64 mvFFCCalibrationImageCount;
    /// \brief Starts the Calibration of the Flat Field Correction.
    /**
     *  Starts the Calibration of the Flat Field Correction.
     */
    Method mvFFCCalibrate;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to control the frame averaging engine.
/**
 *  A category that contains features to control the frame averaging engine.
 */
class mvFrameAverageControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvFrameAverageControl</b> object.
    explicit mvFrameAverageControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvFrameAverageMode(),
        mvFrameAverageEnable(),
        mvFrameAverageSlope(),
        mvFrameAverageDynamicMode(),
        mvFrameAverageNoiseLimit(),
        mvFrameAverageNoiseGain(),
        mvFrameAverageFrameCount()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvFrameAverageControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvFrameAverageMode, "mvFrameAverageMode" );
        locator.bindComponent( mvFrameAverageEnable, "mvFrameAverageEnable" );
        locator.bindComponent( mvFrameAverageSlope, "mvFrameAverageSlope" );
        locator.bindComponent( mvFrameAverageDynamicMode, "mvFrameAverageDynamicMode" );
        locator.bindComponent( mvFrameAverageNoiseLimit, "mvFrameAverageNoiseLimit" );
        locator.bindComponent( mvFrameAverageNoiseGain, "mvFrameAverageNoiseGain" );
        locator.bindComponent( mvFrameAverageFrameCount, "mvFrameAverageFrameCount" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Sets the frame average operating mode.
    /**
     *  Sets the frame average operating mode.
     */
    PropertyI64 mvFrameAverageMode;
    /// \brief Enables the frame averaging engine.
    /**
     *  Enables the frame averaging engine.
     */
    PropertyIBoolean mvFrameAverageEnable;
    /// \brief Here you specify the noise border for very dark pictures.
    /**
     *  Here you specify the noise border for very dark pictures.
     */
    PropertyI64 mvFrameAverageSlope;
    /// \brief Sets the frame average dynamic operating mode.
    /**
     *  Sets the frame average dynamic operating mode.
     */
    PropertyI64 mvFrameAverageDynamicMode;
    /// \brief Here you specify the noise limit for very bright pictures.
    /**
     *  Here you specify the noise limit for very bright pictures.
     */
    PropertyI64 mvFrameAverageNoiseLimit;
    /// \brief Here you specify the noise border for very bright pictures.
    /**
     *  Here you specify the noise border for very bright pictures.
     */
    PropertyI64 mvFrameAverageNoiseGain;
    /// \brief Here you specify the frame count used for the calculation of the frame average.
    /**
     *  Here you specify the frame count used for the calculation of the frame average.
     */
    PropertyI64 mvFrameAverageFrameCount;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to control the devices High Dynamic Range parameters.
/**
 *  A category that contains features to control the devices High Dynamic Range parameters.
 */
class mvHDRControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvHDRControl</b> object.
    explicit mvHDRControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvHDREnable(),
        mvHDRPreset(),
        mvHDRSelector(),
        mvHDRVoltage1(),
        mvHDRVoltage2(),
        mvHDRExposure1(),
        mvHDRExposure2()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvHDRControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvHDREnable, "mvHDREnable" );
        locator.bindComponent( mvHDRPreset, "mvHDRPreset" );
        locator.bindComponent( mvHDRSelector, "mvHDRSelector" );
        locator.bindComponent( mvHDRVoltage1, "mvHDRVoltage1" );
        locator.bindComponent( mvHDRVoltage2, "mvHDRVoltage2" );
        locator.bindComponent( mvHDRExposure1, "mvHDRExposure1" );
        locator.bindComponent( mvHDRExposure2, "mvHDRExposure2" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Enables the High Dynamic Range Feature.
    /**
     *  Enables the High Dynamic Range Feature.
     */
    PropertyIBoolean mvHDREnable;
    /// \brief Selects the HDR parameter set.
    /**
     *  Selects the HDR parameter set.
     */
    PropertyI64 mvHDRPreset;
    /// \brief Selects the HDR parameter set to configure.
    /**
     *  This enumeration selects the HDR parameter set to configure.
     */
    PropertyI64 mvHDRSelector;
    /// \brief First HDR Voltage in mV.
    /**
     *  First HDR Voltage in mV.
     */
    PropertyI64 mvHDRVoltage1;
    /// \brief Second HDR Voltage in mV.
    /**
     *  Second HDR Voltage in mV.
     */
    PropertyI64 mvHDRVoltage2;
    /// \brief First HDR Exposure in ppm.
    /**
     *  First HDR Exposure in ppm.
     */
    PropertyI64 mvHDRExposure1;
    /// \brief Second HDR Exposure in ppm.
    /**
     *  Second HDR Exposure in ppm.
     */
    PropertyI64 mvHDRExposure2;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to access the device internal SPI bus.
/**
 *  A category that contains features to access the device internal SPI bus.
 */
class mvSPIControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvSPIControl</b> object.
    explicit mvSPIControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvSPIDeviceSelector(),
        mvSPIOperationSelector(),
        mvSPIOperationExecute(),
        mvSPIAccessBuffer(),
        mvSPIAccessLength()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvSPIControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvSPIDeviceSelector, "mvSPIDeviceSelector" );
        locator.bindComponent( mvSPIOperationSelector, "mvSPIOperationSelector" );
        locator.bindComponent( mvSPIOperationExecute, "mvSPIOperationExecute@i" );
        locator.bindComponent( mvSPIAccessBuffer, "mvSPIAccessBuffer" );
        locator.bindComponent( mvSPIAccessLength, "mvSPIAccessLength" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Selects the SPI device.
    /**
     *  Selects the SPI device.
     */
    PropertyI64 mvSPIDeviceSelector;
    /// \brief Selects the operation. Write: mvSPIAccessLength bytes are written to SPI device. Synchronuously read bytes are stored to internal buffer. Read: Reads mvSPIAccessLength from internal buffer. If mvSPIAccessLength > internal buffer size: Additional 'write zeros' will be done.
    /**
     *  Selects the operation. Write: mvSPIAccessLength bytes are written to SPI device. Synchronuously read bytes are stored to internal buffer. Read: Reads mvSPIAccessLength from internal buffer. If mvSPIAccessLength > internal buffer size: Additional 'write zeros' will be done.
     */
    PropertyI64 mvSPIOperationSelector;
    /// \brief Executes the operation selected by mvSPIOperationSelector.
    /**
     *  Executes the operation selected by mvSPIOperationSelector.
     */
    Method mvSPIOperationExecute;
    /// \brief Defines the intermediate access buffer that allows the exchange of data.
    /**
     *  Defines the intermediate access buffer that allows the exchange of data.
     */
    PropertyS mvSPIAccessBuffer;
    /// \brief Controls the length of the data.
    /**
     *  Controls the length of the data.
     */
    PropertyI64 mvSPIAccessLength;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to access DAC devices.
/**
 *  A Category that contains features to access DAC devices.
 */
class mvDACParams : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvDACParams</b> object.
    explicit mvDACParams(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvDACOUTA(),
        mvDACOUTB(),
        mvDACOUTC(),
        mvDACOUTD(),
        DACIndex(),
        DACValue(),
        DACValueAll(),
        mvErrorDetect0(),
        mvErrorDetect1(),
        mvLampDetect()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvDACParams" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvDACOUTA, "mvDACOUTA" );
        locator.bindComponent( mvDACOUTB, "mvDACOUTB" );
        locator.bindComponent( mvDACOUTC, "mvDACOUTC" );
        locator.bindComponent( mvDACOUTD, "mvDACOUTD" );
        locator.bindComponent( DACIndex, "DACIndex" );
        locator.bindComponent( DACValue, "DACValue" );
        locator.bindComponent( DACValueAll, "DACValueAll" );
        locator.bindComponent( mvErrorDetect0, "mvErrorDetect0" );
        locator.bindComponent( mvErrorDetect1, "mvErrorDetect1" );
        locator.bindComponent( mvLampDetect, "mvLampDetect" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Changes the current of the CCDs output signal (Tap1).
    /**
     *  Changes the current of the CCDs output signal (Tap1).
     */
    PropertyI64 mvDACOUTA;
    /// \brief Changes the current of the CCDs output signal (Tap2).
    /**
     *  Changes the current of the CCDs output signal (Tap2).
     */
    PropertyI64 mvDACOUTB;
    /// \brief Currently not used
    /**
     *  Currently not used
     */
    PropertyI64 mvDACOUTC;
    /// \brief Sets the sensor's VSUB voltage.
    /**
     *  Sets the sensor's VSUB voltage.
     */
    PropertyI64 mvDACOUTD;
    /// \brief Selects the digital to analog converter(DAC) DACValue will be written to
    /**
     *  Selects the digital to analog converter(DAC) DACValue will be written to
     */
    PropertyI64 DACIndex;
    /// \brief Register value in hex
    /**
     *  Register value in hex
     */
    PropertyI64 DACValue;
    /// \brief Write all DAcs with a single call.
    /**
     *  Write all DAcs with a single call.
     */
    PropertyS DACValueAll;
    /// \brief Result of the error detection mechanism for lamp0
    /**
     *  Result of the error detection mechanism for lamp0
     */
    PropertyI64 mvErrorDetect0;
    /// \brief Result of the error detection mechanism for lamp1
    /**
     *  Result of the error detection mechanism for lamp1
     */
    PropertyI64 mvErrorDetect1;
    /// \brief Result of lamp detection
    /**
     *  Result of lamp detection
     */
    PropertyIBoolean mvLampDetect;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains features to access accelerometer data.
/**
 *  A category that contains features to access accelerometer data.
 */
class mvACCControl : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::mvACCControl</b> object.
    explicit mvACCControl(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        mvACCEnable(),
        mvXAxis(),
        mvYAxis(),
        mvZAxis()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenICam/mvACCControl" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( mvACCEnable, "mvACCEnable" );
        locator.bindComponent( mvXAxis, "mvXAxis" );
        locator.bindComponent( mvYAxis, "mvYAxis" );
        locator.bindComponent( mvZAxis, "mvZAxis" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Sets ACC in measurement mode.
    /**
     *  Sets ACC in measurement mode.
     */
    PropertyIBoolean mvACCEnable;
    /// \brief The postition in X-direction.
    /**
     *  The postition in X-direction.
     */
    PropertyI64 mvXAxis;
    /// \brief The postition in Y-direction.
    /**
     *  The postition in Y-direction.
     */
    PropertyI64 mvYAxis;
    /// \brief The postition in Z-direction.
    /**
     *  The postition in Z-direction.
     */
    PropertyI64 mvZAxis;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains items that belong to the system module of the transport layer.
/**
 *  The System category contains items that belong to the system module of the transport layer.
 */
class SystemModule : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::SystemModule</b> object.
    explicit SystemModule(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev ) :
        mvIMPACT::acquire::ComponentCollection( INVALID_ID ),
        TLVendorName(),
        TLModelName(),
        TLID(),
        TLVersion(),
        TLPath(),
        TLType(),
        interfaceUpdateList(),
        interfaceSelector(),
        interfaceID(),
        interfaceType(),
        gevInterfaceMACAddress(),
        gevInterfaceDefaultIPAddress(),
        gevInterfaceDefaultSubnetMask(),
        gevInterfaceDefaultGateway(),
        mvGevInterfaceMTU(),
        mvGevInterfaceLinkSpeed(),
        genTLVersionMajor(),
        genTLVersionMinor(),
        genCPVersionMajor(),
        genCPVersionMinor(),
        gevVersionMajor(),
        gevVersionMinor(),
        mvGevChannelDummyPacketSendEnable(),
        mvGevChannelDummyPacketSendInterval(),
        u3vVersionMajor(),
        u3vVersionMinor()
    {
        mvIMPACT::acquire::ComponentLocator locator( pDev->deviceDriverFeatureList() );
        locator.bindSearchBase( locator.searchbase_id(), "GenTL/System" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( TLVendorName, "TLVendorName" );
        locator.bindComponent( TLModelName, "TLModelName" );
        locator.bindComponent( TLID, "TLID" );
        locator.bindComponent( TLVersion, "TLVersion" );
        locator.bindComponent( TLPath, "TLPath" );
        locator.bindComponent( TLType, "TLType" );
        locator.bindComponent( interfaceUpdateList, "InterfaceUpdateList@i" );
        locator.bindComponent( interfaceSelector, "InterfaceSelector" );
        locator.bindComponent( interfaceID, "InterfaceID" );
        locator.bindComponent( interfaceType, "InterfaceType" );
        locator.bindComponent( gevInterfaceMACAddress, "GevInterfaceMACAddress" );
        locator.bindComponent( gevInterfaceDefaultIPAddress, "GevInterfaceDefaultIPAddress" );
        locator.bindComponent( gevInterfaceDefaultSubnetMask, "GevInterfaceDefaultSubnetMask" );
        locator.bindComponent( gevInterfaceDefaultGateway, "GevInterfaceDefaultGateway" );
        locator.bindComponent( mvGevInterfaceMTU, "mvGevInterfaceMTU" );
        locator.bindComponent( mvGevInterfaceLinkSpeed, "mvGevInterfaceLinkSpeed" );
        locator.bindComponent( genTLVersionMajor, "GenTLVersionMajor" );
        locator.bindComponent( genTLVersionMinor, "GenTLVersionMinor" );
        locator.bindComponent( genCPVersionMajor, "GenCPVersionMajor" );
        locator.bindComponent( genCPVersionMinor, "GenCPVersionMinor" );
        locator.bindComponent( gevVersionMajor, "GevVersionMajor" );
        locator.bindComponent( gevVersionMinor, "GevVersionMinor" );
        locator.bindComponent( mvGevChannelDummyPacketSendEnable, "mvGevChannelDummyPacketSendEnable" );
        locator.bindComponent( mvGevChannelDummyPacketSendInterval, "mvGevChannelDummyPacketSendInterval" );
        locator.bindComponent( u3vVersionMajor, "U3vVersionMajor" );
        locator.bindComponent( u3vVersionMinor, "U3vVersionMinor" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Indicates the name of the transport layer vendor.
    /**
     *  This is a read only element. It is a string that indicates the name of the transport layer vendor.
     */
    PropertyS TLVendorName;
    /// \brief Indicates the name of the transport layer Model.
    /**
     *  This is a read only element. It is a string that indicates the name of the transport layer Model to distinguish different kinds of GenTL Producer implementations from one vendor.
     */
    PropertyS TLModelName;
    /// \brief Indicates the ID of the transport layer.
    /**
     *  This is a read only element. It is a string that indicates the ID of the transport layer.
     */
    PropertyS TLID;
    /// \brief Indicates a vendor specific version string for this transport layer.
    /**
     *  This is a read only element. It is a string that indicates a vendor specific version string for this transport layer.
     */
    PropertyS TLVersion;
    /// \brief Indicates the full path to the GenTL Producer driver including name and extension.
    /**
     *  This is a read only element. It is a string that indicates the full path to the GenTL Producer driver including name and extension.
     */
    PropertyS TLPath;
    /// \brief Identifies the transport layer technology of the GenTL Producer implementation.
    /**
     *  This is a read only feature. This enumeration provides a value that indicates the transport layer technology of the GenTL Producer implementation.
     */
    PropertyI64 TLType;
    /// \brief Updates the internal interface list.
    /**
     *  This command updates the internal interface list of this transport layer.
     */
    Method interfaceUpdateList;
    /// \brief Selector for the different GenTL Producer interfaces.
    /**
     *  Selector for the different GenTL Producer interfaces. Selector for the different GenTL Producer interfaces. This interface list only changes on execution of InterfaceUpdateList. The selector is 0-based in order to match the index of the C interface.
     */
    PropertyI64 interfaceSelector;
    /// \brief GenTL producer wide unique identifier of the selected interface.
    /**
     *  This is a read only element. It is a string that indicates a GenTL producer wide unique identifier of the selected interface.
     */
    PropertyS interfaceID;
    /// \brief Identifies the interfaces technology of the GenTL Producer implementation.
    /**
     *  This is a read only feature. This enumeration provides a value that indicates interfaces technology of the GenTL Producer implementation.
     */
    PropertyI64 interfaceType;
    /// \brief Indicates the 48-bit MAC address of the selected interface.
    /**
     *  This is a read only element. It indicates the 48-bit MAC address of the selected interface.
     */
    PropertyI64 gevInterfaceMACAddress;
    /// \brief Indicates the IP address of the first subnet of the selected interface.
    /**
     *  This is a read only element. It indicates the IP address of the first subnet of the selected interface.
     */
    PropertyI64 gevInterfaceDefaultIPAddress;
    /// \brief Indicates the subnet mask of the first subnet of the selected interface.
    /**
     *  This is a read only element. It indicates the subnet mask of the first subnet of the selected interface.
     */
    PropertyI64 gevInterfaceDefaultSubnetMask;
    /// \brief Indicates the default gateway of the first subnet of the selected interface.
    /**
     *  This is a read only element. It indicates the default gateway of the first subnet of the selected interface.
     */
    PropertyI64 gevInterfaceDefaultGateway;
    /// \brief Indicates the MTU of the selected interface.
    /**
     *  This is a read only element. It indicates the MTU(Maximum Transmission Unit) of the selected interface.
     */
    PropertyI64 mvGevInterfaceMTU;
    /// \brief Indicates the link speed of this interface.
    /**
     *  This is a read only element. It indicates the link speed(in Mbits per second) of this interface.
     */
    PropertyI64 mvGevInterfaceLinkSpeed;
    /// \brief Defines the major version number of the GenTL specification the GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It defines the major version number of the GenTL specification the GenTL Producer implementation complies with.
     */
    PropertyI64 genTLVersionMajor;
    /// \brief Defines the minor version number of the GenTL specification the GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It defines the minor version number of the GenTL specification the GenTL Producer implementation complies with.
     */
    PropertyI64 genTLVersionMinor;
    /// \brief Indicates the major version number of the GenCP specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the major version number of the GenCP specification this GenTL Producer implementation complies with.
     */
    PropertyI64 genCPVersionMajor;
    /// \brief Indicates the minor version number of the GenCP specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the minor version number of the GenCP specification this GenTL Producer implementation complies with.
     */
    PropertyI64 genCPVersionMinor;
    /// \brief Major version of the specification.
    /**
     *  Major version of the specification.
     */
    PropertyI64 gevVersionMajor;
    /// \brief Minor version of the specification.
    /**
     *  Minor version of the specification.
     */
    PropertyI64 gevVersionMinor;
    /// \brief Enables or disables the periodical sending of dummy packets to a stream or message channel source port of a GigE Vision device.
    /**
     *  Enables or disables the periodical sending of dummy packets to a stream or message channel source port of a GigE Vision device. This might be useful to overcome firewall related problems when working with network devices.
     */
    PropertyIBoolean mvGevChannelDummyPacketSendEnable;
    /// \brief Defines the period(in ms) for sending dummy packets to a stream or message channel source port of a GigE Vision device.
    /**
     *  Defines the period(in ms) for sending dummy packets to a stream or message channel source port of a GigE Vision device. This might be useful to overcome firewall related problems when working with network devices.
     */
    PropertyI64 mvGevChannelDummyPacketSendInterval;
    /// \brief Indicates the major version number of the USB3 Vision specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the major version number of the USB3 Vision specification this GenTL Producer implementation complies with.
     */
    PropertyI64 u3vVersionMajor;
    /// \brief Indicates the minor version number of the USB3 Vision specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the minor version number of the USB3 Vision specification this GenTL Producer implementation complies with.
     */
    PropertyI64 u3vVersionMinor;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains items that belong to the interface module of the transport layer.
/**
 *  The Interface category contains items that belong to the interface module of the transport layer.
 */
class InterfaceModule : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::InterfaceModule</b> object.
    explicit InterfaceModule(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The \a index of the instance this object shall be created for. Passing an invalid index will raise an exception.
        int64_type index ) :
        mvIMPACT::acquire::ComponentCollection( INVALID_ID ),
        interfaceID(),
        interfaceType(),
        gevInterfaceGatewaySelector(),
        gevInterfaceGateway(),
        gevInterfaceMACAddress(),
        gevInterfaceSubnetSelector(),
        gevInterfaceSubnetIPAddress(),
        gevInterfaceSubnetMask(),
        mvGevInterfaceMTU(),
        mvGevInterfaceLinkSpeed(),
        mvGevAdvancedDeviceDiscoveryEnable(),
        deviceUpdateList(),
        mvActionDeviceKey(),
        mvActionGroupKey(),
        mvActionGroupMask(),
        mvActionScheduledTimeEnable(),
        mvActionScheduledTime(),
        mvActionDestinationIPAddress(),
        mvActionSend(),
        deviceSelector(),
        deviceID(),
        deviceVendorName(),
        deviceModelName(),
        deviceType(),
        deviceLinkSpeed(),
        deviceAccessStatus(),
        mvDeviceCommandChannelTransmissionTimeout(),
        mvDeviceCommandChannelRetryCount(),
        gevVersionMajor(),
        gevVersionMinor(),
        genCPVersionMajor(),
        genCPVersionMinor(),
        u3vVersionMajor(),
        u3vVersionMinor(),
        mvDevicePrimaryApplicationSwitchoverSupported(),
        mvDevicePrimaryApplicationSwitchoverEnable(),
        mvDevicePrimaryApplicationSwitchoverKey(),
        mvDeviceNetworkInterfaceCount(),
        gevDeviceIPAddress(),
        gevDeviceSubnetMask(),
        gevDeviceMACAddress()
    {
        mvIMPACT::acquire::ComponentLocator locator( pDev->deviceDriverFeatureList() );
        locator.bindSearchBase( locator.searchbase_id(), "GenTL/Interfaces" );
        std::ostringstream oss;
        oss << "Interface" << index;
        locator = mvIMPACT::acquire::ComponentLocator( locator.findComponent( oss.str() ) );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( interfaceID, "InterfaceID" );
        locator.bindComponent( interfaceType, "InterfaceType" );
        locator.bindComponent( gevInterfaceGatewaySelector, "GevInterfaceGatewaySelector" );
        locator.bindComponent( gevInterfaceGateway, "GevInterfaceGateway" );
        locator.bindComponent( gevInterfaceMACAddress, "GevInterfaceMACAddress" );
        locator.bindComponent( gevInterfaceSubnetSelector, "GevInterfaceSubnetSelector" );
        locator.bindComponent( gevInterfaceSubnetIPAddress, "GevInterfaceSubnetIPAddress" );
        locator.bindComponent( gevInterfaceSubnetMask, "GevInterfaceSubnetMask" );
        locator.bindComponent( mvGevInterfaceMTU, "mvGevInterfaceMTU" );
        locator.bindComponent( mvGevInterfaceLinkSpeed, "mvGevInterfaceLinkSpeed" );
        locator.bindComponent( mvGevAdvancedDeviceDiscoveryEnable, "mvGevAdvancedDeviceDiscoveryEnable" );
        locator.bindComponent( deviceUpdateList, "DeviceUpdateList@i" );
        locator.bindComponent( mvActionDeviceKey, "mvActionDeviceKey" );
        locator.bindComponent( mvActionGroupKey, "mvActionGroupKey" );
        locator.bindComponent( mvActionGroupMask, "mvActionGroupMask" );
        locator.bindComponent( mvActionScheduledTimeEnable, "mvActionScheduledTimeEnable" );
        locator.bindComponent( mvActionScheduledTime, "mvActionScheduledTime" );
        locator.bindComponent( mvActionDestinationIPAddress, "mvActionDestinationIPAddress" );
        locator.bindComponent( mvActionSend, "mvActionSend@i" );
        locator.bindComponent( deviceSelector, "DeviceSelector" );
        locator.bindComponent( deviceID, "DeviceID" );
        locator.bindComponent( deviceVendorName, "DeviceVendorName" );
        locator.bindComponent( deviceModelName, "DeviceModelName" );
        locator.bindComponent( deviceType, "DeviceType" );
        locator.bindComponent( deviceLinkSpeed, "DeviceLinkSpeed" );
        locator.bindComponent( deviceAccessStatus, "DeviceAccessStatus" );
        locator.bindComponent( mvDeviceCommandChannelTransmissionTimeout, "mvDeviceCommandChannelTransmissionTimeout" );
        locator.bindComponent( mvDeviceCommandChannelRetryCount, "mvDeviceCommandChannelRetryCount" );
        locator.bindComponent( gevVersionMajor, "GevVersionMajor" );
        locator.bindComponent( gevVersionMinor, "GevVersionMinor" );
        locator.bindComponent( genCPVersionMajor, "GenCPVersionMajor" );
        locator.bindComponent( genCPVersionMinor, "GenCPVersionMinor" );
        locator.bindComponent( u3vVersionMajor, "U3vVersionMajor" );
        locator.bindComponent( u3vVersionMinor, "U3vVersionMinor" );
        locator.bindComponent( mvDevicePrimaryApplicationSwitchoverSupported, "mvDevicePrimaryApplicationSwitchoverSupported" );
        locator.bindComponent( mvDevicePrimaryApplicationSwitchoverEnable, "mvDevicePrimaryApplicationSwitchoverEnable" );
        locator.bindComponent( mvDevicePrimaryApplicationSwitchoverKey, "mvDevicePrimaryApplicationSwitchoverKey" );
        locator.bindComponent( mvDeviceNetworkInterfaceCount, "mvDeviceNetworkInterfaceCount" );
        locator.bindComponent( gevDeviceIPAddress, "GevDeviceIPAddress" );
        locator.bindComponent( gevDeviceSubnetMask, "GevDeviceSubnetMask" );
        locator.bindComponent( gevDeviceMACAddress, "GevDeviceMACAddress" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief GenTL producer wide unique identifier of the selected interface.
    /**
     *  This is a read only element. It is a string that indicates a GenTL producer wide unique identifier of the selected interface.
     */
    PropertyS interfaceID;
    /// \brief Identifies the interfaces technology of the GenTL Producer implementation.
    /**
     *  This is a read only feature. This enumeration provides a value that indicates interfaces technology of the GenTL Producer implementation.
     */
    PropertyI64 interfaceType;
    /// \brief Selector for the different gateway entries for this interface.
    /**
     *  Selector for the different gateway entries for this interface. The selector is 0-based in order to match the index of the C interface.
     */
    PropertyI64 gevInterfaceGatewaySelector;
    /// \brief Indicates the IP address of the selected gateway entry of this interface.
    /**
     *  This is a read only element. It indicates the IP address of the selected gateway entry of this interface.
     */
    PropertyI64 gevInterfaceGateway;
    /// \brief Indicates the 48-bit MAC address of the selected interface.
    /**
     *  This is a read only element. It indicates the 48-bit MAC address of the selected interface.
     */
    PropertyI64 gevInterfaceMACAddress;
    /// \brief Selector for the different subnet entries for this interface.
    /**
     *  Selector for the different subnet entries for this interface. The selector is 0-based in order to match the index of the C interface.
     */
    PropertyI64 gevInterfaceSubnetSelector;
    /// \brief Indicates the IP address of the selected subnet entry of this interface.
    /**
     *  This is a read only element. It indicates the IP address of the selected subnet entry of this interface.
     */
    PropertyI64 gevInterfaceSubnetIPAddress;
    /// \brief Indicates the subnet mask of the selected subnet entry of this interface.
    /**
     *  This is a read only element. It indicates the subnet mask of the selected subnet entry of this interface.
     */
    PropertyI64 gevInterfaceSubnetMask;
    /// \brief Indicates the MTU of this interface.
    /**
     *  This is a read only element. It indicates the MTU(Maximum Transmission Unit) of this interface.
     */
    PropertyI64 mvGevInterfaceMTU;
    /// \brief Indicates the link speed of this interface.
    /**
     *  This is a read only element. It indicates the link speed(in Mbits per second) of this interface.
     */
    PropertyI64 mvGevInterfaceLinkSpeed;
    /// \brief Enables or disables the advanced device discovery.
    /**
     *  Enables or disables the advanced device discovery. When enabled also devices, which currently use an incorrect IP configuration for the network they are connected to might be detectable. However depending on the operating system this may result in devices showing up on interfaces to which they are not physically connected.
     */
    PropertyIBoolean mvGevAdvancedDeviceDiscoveryEnable;
    /// \brief Updates the internal device list of this interface.
    /**
     *  This command updates the internal device list of this interface.
     */
    Method deviceUpdateList;
    /// \brief The device key for the action command
    /**
     *  The device key is one of the three main components that constitute an action command packet. It partly defines which device(s) will positively assert the action command packet.
     */
    PropertyI64 mvActionDeviceKey;
    /// \brief The group key for the action command
    /**
     *  The group key is one of the three main components that constitute an action command packet. It partly defines which device(s) will positively assert the action command packet.
     */
    PropertyI64 mvActionGroupKey;
    /// \brief The group mask for the action command
    /**
     *  The group mask is one of the three main components that constitute an action command packet. It partly defines which device(s) will positively assert the action command packet.
     */
    PropertyI64 mvActionGroupMask;
    /// \brief Enables or disables action command scheduling
    /**
     *  Action commands can be scheduled to execute at a particular moment in time, defined by the 'mvActionScheduledTime' property. If this is disabled the action command takes place immediately after it is received and asserted by each device.
     */
    PropertyIBoolean mvActionScheduledTimeEnable;
    /// \brief Sets the time in which the action command will be executed
    /**
     *  Sets the time in which the action command will be executed
     */
    PropertyI64 mvActionScheduledTime;
    /// \brief The IP address of the action command recepient
    /**
     *  A valid IP address if the action command shall be unicast. A broadcast subnet if the action command shall be broadcast.
     */
    PropertyI64 mvActionDestinationIPAddress;
    /// \brief Sends the action command
    /**
     *  It either sends an action command unicast packet to the IP address specified by the 'mvActionDestinationIPAddress' property, or broadcasts an action command broadcast packet on the broadcast domain specified by the 'mvActionDestinationIPAddress' property
     */
    Method mvActionSend;
    /// \brief Selector for the different devices on this interface.
    /**
     *  Selector for the different devices on this interface. The limits of this feature might change upon execution of DeviceUpdateList.
     */
    PropertyI64 deviceSelector;
    /// \brief This feature is deprecated (See DeviceSerialNumber).
    /**
     *  \deprecated
     *  This feature is deprecated (See DeviceSerialNumber). It was representing the Device unique identifier (serial number).
     */
    PropertyS deviceID;
    /// \brief Name of the manufacturer of the device.
    /**
     *  Name of the manufacturer of the device.
     */
    PropertyS deviceVendorName;
    /// \brief Model of the device.
    /**
     *  Model of the device.
     */
    PropertyS deviceModelName;
    /// \brief Returns the device type.
    /**
     *  Returns the device type.
     */
    PropertyI64 deviceType;
    /// \brief Indicates the speed of transmission negotiated on the specified Link.
    /**
     *  Indicates the speed of transmission negotiated on the specified Link.
     */
    PropertyI64 deviceLinkSpeed;
    /// \brief Indicates the current access status for the device.
    /**
     *  This is a read only feature. This enumeration provides a value that indicates the current access status for the device.
     */
    PropertyI64 deviceAccessStatus;
    /// \brief Defines the maximum time in milli-seconds the host driver will wait for an ACK from the device to a previously sent command.
    /**
     *  Defines the maximum time in milli-seconds the host driver will wait for an ACK from the device to a previously sent command.
     */
    PropertyI64 mvDeviceCommandChannelTransmissionTimeout;
    /// \brief Indicates the number of retransmissions allowed when command channel message timed out (no ACK was received from the device).
    /**
     *  Indicates the number of retransmissions allowed when command channel message timed out (no ACK was received from the device).
     */
    PropertyI64 mvDeviceCommandChannelRetryCount;
    /// \brief Major version of the specification.
    /**
     *  Major version of the specification.
     */
    PropertyI64 gevVersionMajor;
    /// \brief Minor version of the specification.
    /**
     *  Minor version of the specification.
     */
    PropertyI64 gevVersionMinor;
    /// \brief Indicates the major version number of the GenCP specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the major version number of the GenCP specification this GenTL Producer implementation complies with.
     */
    PropertyI64 genCPVersionMajor;
    /// \brief Indicates the minor version number of the GenCP specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the minor version number of the GenCP specification this GenTL Producer implementation complies with.
     */
    PropertyI64 genCPVersionMinor;
    /// \brief Indicates the major version number of the USB3 Vision specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the major version number of the USB3 Vision specification this GenTL Producer implementation complies with.
     */
    PropertyI64 u3vVersionMajor;
    /// \brief Indicates the minor version number of the USB3 Vision specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the minor version number of the USB3 Vision specification this GenTL Producer implementation complies with.
     */
    PropertyI64 u3vVersionMinor;
    /// \brief Reports the availability of the primary application switchover feature.
    /**
     *  Reports the availability of the primary application switchover feature.
     */
    PropertyIBoolean mvDevicePrimaryApplicationSwitchoverSupported;
    /// \brief Enables or disables primary application switchover.
    /**
     *  Enables or disables primary application switchover.
     */
    PropertyIBoolean mvDevicePrimaryApplicationSwitchoverEnable;
    /// \brief Controls the key to use to authenticate primary application switchover requests.
    /**
     *  Controls the key to use to authenticate primary application switchover requests. If the device to take over has 'mvDevicePrimaryApplicationSwitchoverEnable' set to true and this key matches the devices internal key control access will be granted.
     */
    PropertyI64 mvDevicePrimaryApplicationSwitchoverKey;
    /// \brief The number of physical network interfaces supported by this device.
    /**
     *  This is an integer feature. It contains the number of physical network interfaces supported by this device.
     */
    PropertyI64 mvDeviceNetworkInterfaceCount;
    /// \brief Indicates the current IP address of the GVCP interface of the selected remote device.
    /**
     *  This is a read only element. It indicates the current IP address of the GVCP interface of the selected remote device.
     */
    PropertyI64 gevDeviceIPAddress;
    /// \brief Indicates the current subnet mask of the GVCP interface of the selected remote device.
    /**
     *  This is a read only element. It indicates the current subnet mask of the GVCP interface of the selected remote device.
     */
    PropertyI64 gevDeviceSubnetMask;
    /// \brief Indicates the 48-bit MAC address of the GVCP interface of the selected remote device.
    /**
     *  This is a read only element. It indicates the 48-bit MAC address of the GVCP interface of the selected remote device.
     */
    PropertyI64 gevDeviceMACAddress;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category contains items that belong to the device module of the transport layer.
/**
 *  The Device category contains items that belong to the device module of the transport layer.
 */
class DeviceModule : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::DeviceModule</b> object.
    explicit DeviceModule(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        deviceID(),
        deviceVendorName(),
        deviceModelName(),
        deviceType(),
        deviceLinkSpeed(),
        gevVersionMajor(),
        gevVersionMinor(),
        genCPVersionMajor(),
        genCPVersionMinor(),
        u3vVersionMajor(),
        u3vVersionMinor(),
        gevDeviceIPAddress(),
        gevDeviceSubnetMask(),
        gevDeviceMACAddress(),
        gevDeviceGateway(),
        deviceEndianessMechanism(),
        streamSelector(),
        streamID()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenTL/Device" );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( deviceID, "DeviceID" );
        locator.bindComponent( deviceVendorName, "DeviceVendorName" );
        locator.bindComponent( deviceModelName, "DeviceModelName" );
        locator.bindComponent( deviceType, "DeviceType" );
        locator.bindComponent( deviceLinkSpeed, "DeviceLinkSpeed" );
        locator.bindComponent( gevVersionMajor, "GevVersionMajor" );
        locator.bindComponent( gevVersionMinor, "GevVersionMinor" );
        locator.bindComponent( genCPVersionMajor, "GenCPVersionMajor" );
        locator.bindComponent( genCPVersionMinor, "GenCPVersionMinor" );
        locator.bindComponent( u3vVersionMajor, "U3vVersionMajor" );
        locator.bindComponent( u3vVersionMinor, "U3vVersionMinor" );
        locator.bindComponent( gevDeviceIPAddress, "GevDeviceIPAddress" );
        locator.bindComponent( gevDeviceSubnetMask, "GevDeviceSubnetMask" );
        locator.bindComponent( gevDeviceMACAddress, "GevDeviceMACAddress" );
        locator.bindComponent( gevDeviceGateway, "GevDeviceGateway" );
        locator.bindComponent( deviceEndianessMechanism, "DeviceEndianessMechanism" );
        locator.bindComponent( streamSelector, "StreamSelector" );
        locator.bindComponent( streamID, "StreamID" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief This feature is deprecated (See DeviceSerialNumber).
    /**
     *  \deprecated
     *  This feature is deprecated (See DeviceSerialNumber). It was representing the Device unique identifier (serial number).
     */
    PropertyS deviceID;
    /// \brief Name of the manufacturer of the device.
    /**
     *  Name of the manufacturer of the device.
     */
    PropertyS deviceVendorName;
    /// \brief Model of the device.
    /**
     *  Model of the device.
     */
    PropertyS deviceModelName;
    /// \brief Returns the device type.
    /**
     *  Returns the device type.
     */
    PropertyI64 deviceType;
    /// \brief Indicates the speed of transmission negotiated on the specified Link.
    /**
     *  Indicates the speed of transmission negotiated on the specified Link.
     */
    PropertyI64 deviceLinkSpeed;
    /// \brief Major version of the specification.
    /**
     *  Major version of the specification.
     */
    PropertyI64 gevVersionMajor;
    /// \brief Minor version of the specification.
    /**
     *  Minor version of the specification.
     */
    PropertyI64 gevVersionMinor;
    /// \brief Indicates the major version number of the GenCP specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the major version number of the GenCP specification this GenTL Producer implementation complies with.
     */
    PropertyI64 genCPVersionMajor;
    /// \brief Indicates the minor version number of the GenCP specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the minor version number of the GenCP specification this GenTL Producer implementation complies with.
     */
    PropertyI64 genCPVersionMinor;
    /// \brief Indicates the major version number of the USB3 Vision specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the major version number of the USB3 Vision specification this GenTL Producer implementation complies with.
     */
    PropertyI64 u3vVersionMajor;
    /// \brief Indicates the minor version number of the USB3 Vision specification this GenTL Producer implementation complies with.
    /**
     *  This is a read only element. It indicates the minor version number of the USB3 Vision specification this GenTL Producer implementation complies with.
     */
    PropertyI64 u3vVersionMinor;
    /// \brief Indicates the current IP address of the GVCP interface of the selected remote device.
    /**
     *  This is a read only element. It indicates the current IP address of the GVCP interface of the selected remote device.
     */
    PropertyI64 gevDeviceIPAddress;
    /// \brief Indicates the current subnet mask of the GVCP interface of the selected remote device.
    /**
     *  This is a read only element. It indicates the current subnet mask of the GVCP interface of the selected remote device.
     */
    PropertyI64 gevDeviceSubnetMask;
    /// \brief Indicates the 48-bit MAC address of the GVCP interface of the selected remote device.
    /**
     *  This is a read only element. It indicates the 48-bit MAC address of the GVCP interface of the selected remote device.
     */
    PropertyI64 gevDeviceMACAddress;
    /// \brief Indicates the current gateway of the GVCP interface of the remote device.
    /**
     *  This is a read only element. It indicates the current gateway of the GVCP interface of the remote device.
     */
    PropertyI64 gevDeviceGateway;
    /// \brief Identifies the endianess mode to be used for this device.
    /**
     *  This is a read only feature. This enumeration provides a value that indicates the endianess mode to be used for this device.
     */
    PropertyI64 deviceEndianessMechanism;
    /// \brief Selects the stream channel.
    /**
     *  Selects the stream channel.
     */
    PropertyI64 streamSelector;
    /// \brief Device wide unique ID of the selected stream.
    /**
     *  This is a read only element. It is a string that indicates a device wide unique identifier of the selected stream.
     */
    PropertyS streamID;
    PYTHON_ONLY( %mutable; )
};

//-----------------------------------------------------------------------------
/// \brief Category that contains items that belong to the data stream module of the transport layer.
/**
 *  The DataStream category contains items that belong to the data stream module of the transport layer.
 */
class DataStreamModule : public mvIMPACT::acquire::ComponentCollection
//-----------------------------------------------------------------------------
{
public:
    /// \brief Constructs a new <b>mvIMPACT::acquire::GenICam::DataStreamModule</b> object.
    explicit DataStreamModule(
        /// [in] A pointer to a <b>mvIMPACT::acquire::Device</b> object obtained from a <b>mvIMPACT::acquire::DeviceManager</b> object.
        mvIMPACT::acquire::Device* pDev,
        /// [in] The \a index of the instance this object shall be created for. Passing an invalid index will raise an exception.
        int64_type index,
        /// [in] The name of the driver internal setting to access with this instance.
        /// A list of valid setting names can be obtained by a call to
        /// <b>mvIMPACT::acquire::FunctionInterface::getAvailableSettings</b>, new
        /// settings can be created with the function
        /// <b>mvIMPACT::acquire::FunctionInterface::createSetting</b>
        const std::string& settingName = "Base" ) :
        mvIMPACT::acquire::ComponentCollection( pDev ),
        streamID(),
        streamAnnouncedBufferCount(),
        mvStreamAnnounceBufferMaximum(),
        streamAcquisitionModeSelector(),
        streamAnnounceBufferMinimum(),
        streamType(),
        mvStreamDriverTechnology(),
        mvResendActive(),
        mvResendMode(),
        mvResendBatchingActive(),
        mvResendCaptureWindowSize(),
        mvResendThreshold(),
        mvResendRequestMax(),
        mvResendRequestCredits(),
        mvResendResponseTimeout(),
        mvResendsPerTimeout(),
        mvResendFeaturesLocked()
    {
        mvIMPACT::acquire::DeviceComponentLocator locator( pDev, mvIMPACT::acquire::dltSetting, settingName );
        locator.bindSearchBase( locator.searchbase_id(), "Camera/GenTL/DataStreams" );
        std::ostringstream oss;
        oss << "Stream" << index;
        locator = mvIMPACT::acquire::DeviceComponentLocator( locator.findComponent( oss.str() ) );
        m_hRoot = locator.searchbase_id();
        locator.bindComponent( streamID, "StreamID" );
        locator.bindComponent( streamAnnouncedBufferCount, "StreamAnnouncedBufferCount" );
        locator.bindComponent( mvStreamAnnounceBufferMaximum, "mvStreamAnnounceBufferMaximum" );
        locator.bindComponent( streamAcquisitionModeSelector, "StreamAcquisitionModeSelector" );
        locator.bindComponent( streamAnnounceBufferMinimum, "StreamAnnounceBufferMinimum" );
        locator.bindComponent( streamType, "StreamType" );
        locator.bindComponent( mvStreamDriverTechnology, "mvStreamDriverTechnology" );
        locator.bindComponent( mvResendActive, "mvResendActive" );
        locator.bindComponent( mvResendMode, "mvResendMode" );
        locator.bindComponent( mvResendBatchingActive, "mvResendBatchingActive" );
        locator.bindComponent( mvResendCaptureWindowSize, "mvResendCaptureWindowSize" );
        locator.bindComponent( mvResendThreshold, "mvResendThreshold" );
        locator.bindComponent( mvResendRequestMax, "mvResendRequestMax" );
        locator.bindComponent( mvResendRequestCredits, "mvResendRequestCredits" );
        locator.bindComponent( mvResendResponseTimeout, "mvResendResponseTimeout" );
        locator.bindComponent( mvResendsPerTimeout, "mvResendsPerTimeout" );
        locator.bindComponent( mvResendFeaturesLocked, "mvResendFeaturesLocked" );
    }
    PYTHON_ONLY( %immutable; )
    /// \brief Device wide unique ID of the selected stream.
    /**
     *  This is a read only element. It is a string that indicates a device wide unique identifier of the selected stream.
     */
    PropertyS streamID;
    /// \brief Number of announced (known) buffers on this stream. This value is volatile. It may change if additional buffers are announced and/or buffers are revoked by the GenTL Consumer.
    /**
     *  This is a read-only feature. It indicates the number of announced (known) buffers on this stream. This value is volatile. It may change if additional buffers are announced and/or buffers are revoked by the GenTL Consumer.
     */
    PropertyI64 streamAnnouncedBufferCount;
    /// \brief Maximal number of buffers to announce to enable selected acquisition mode.
    /**
     *  This feature indicates the maximal number of buffers to announce to enable selected acquisition mode.
     */
    PropertyI64 mvStreamAnnounceBufferMaximum;
    /// \brief Allows to select the acquisition mode for the stream.
    /**
     *  This enumeration allows the selection of the acquisition mode for the stream.
     */
    PropertyI64 streamAcquisitionModeSelector;
    /// \brief Minimal number of buffers to announce to enable selected acquisition mode.
    /**
     *  This feature indicates the minimal number of buffers to announce to enable selected acquisition mode.
     */
    PropertyI64 streamAnnounceBufferMinimum;
    /// \brief Identifies the stream technology of the GenTL Producer implementation.
    /**
     *  This is a read only feature. This enumeration provides a value that indicates stream technology of the GenTL Producer implementation.
     */
    PropertyI64 streamType;
    /// \brief The underlying driver technology used by this stream.
    /**
     *  This is a read only element. It is a string that contains the underlying driver technology used by this stream.
     */
    PropertyS mvStreamDriverTechnology;
    /// \brief This feature controls if the stream will issue packet resend requests.
    /**
     *  This feature controls if the stream will issue packet resend requests.
     */
    PropertyIBoolean mvResendActive;
    /// \brief Indicates the mode the internal resend algorithm is working in.
    /**
     *  This feature indicates the mode the internal resend algorithm is working in.
     */
    PropertyI64 mvResendMode;
    /// \brief This feature controls if the stream will issue batched packet resend requests if it detects several consecutive missing packets.
    /**
     *  This feature controls if the stream will issue batched packet resend requests if it detects several consecutive missing packets.
     */
    PropertyIBoolean mvResendBatchingActive;
    /// \brief Indicates the width of the capture window.
    /**
     *  This feature indicates the width of the capture window in packets.
     */
    PropertyI64 mvResendCaptureWindowSize;
    /// \brief Indicates the resend threshold within the capture window.
    /**
     *  This feature indicates the resend threshold within the capture window. If current packet ID and first missing packet ID are mvResendThreshold IDs apart the stream will issue a resend request.
     */
    PropertyI64 mvResendThreshold;
    /// \brief Indicates the maximum number of resend requests per packet to send to the device until the packet is considered as lost.
    /**
     *  This feature indicates the maximum number of resend requests per packet to send to the device until the packet is considered as lost.
     */
    PropertyI64 mvResendRequestMax;
    /// \brief Indicates the maximum number of resend requests in percent of payload packets per buffer to send to the device until the packet is considered as lost.
    /**
     *  This feature indicates the maximum number of resend requests in percent of payload packets per buffer to send to the device until the packet is considered as lost.
     */
    PropertyF mvResendRequestCredits;
    /// \brief This feature controls the resend response timeout in milliseconds.
    /**
     *  This float value sets the resend response timeout in milliseconds. Whenever a requested packet does not arive wirthin this timer period it will be requested again until mvResendRequestMax resend requests for this packet have been issued.
     */
    PropertyI64 mvResendResponseTimeout;
    /// \brief Indicates the number of packets to be requested whenever the resend response timeout elapses.
    /**
     *  This feature indicates the number of packets to be requested whenever the resend response timeout elapses.
     */
    PropertyI64 mvResendsPerTimeout;
    /// \brief Used by the driver to lock critical resend related parameters during the acquisition.
    /**
     *  Used by the driver to lock critical resend related parameters during the acquisition.
     */
    PropertyI64 mvResendFeaturesLocked;
    PYTHON_ONLY( %mutable; )
};

/// @}

} // namespace GenICam
} // namespace acquire
} // namespace mvIMPACT

#endif //mvIMPACT_acquire_GenICam_CPP_autogen_h
